using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace TMS1000Sample
{
	/// <summary>
	/// explanation of the outline of TMS1000SampleForm
	/// </summary>
	public class TMS1000SampleForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button buttonScan;
		private System.Windows.Forms.Button buttonExit;
		/// <summary>
		/// necessary designer variable
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button btnCancel;

		protected ApiUsage m_objApi;

		public TMS1000SampleForm()
		{
			//
			// Required by the Windows Form Designer
			//
			InitializeComponent();

			//
			// TODO: InitializeComponent
			//
			m_objApi = new ApiUsage();
			m_objApi.MainFormItem(this);
			m_objApi.Configure();
		}

		/// <summary>
		/// Postprocessing is run to the resource that is used
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
				// end process
				m_objApi.Close();
			}
			base.Dispose( disposing );
		}

		#region Create code by Windwos Form Designer 
		/// <summary>
		/// The following procedure is required by the Windows Form Designer
		/// It can be modified using the Windows Form Designer.
		/// Do not modify it using the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(TMS1000SampleForm));
			this.buttonScan = new System.Windows.Forms.Button();
			this.buttonExit = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// buttonScan
			// 
			this.buttonScan.Location = new System.Drawing.Point(16, 56);
			this.buttonScan.Name = "buttonScan";
			this.buttonScan.TabIndex = 0;
			this.buttonScan.Text = "Scan";
			this.buttonScan.Click += new System.EventHandler(this.buttonScan_Click);
			// 
			// buttonExit
			// 
			this.buttonExit.Location = new System.Drawing.Point(200, 56);
			this.buttonExit.Name = "buttonExit";
			this.buttonExit.TabIndex = 2;
			this.buttonExit.Text = "Exit";
			this.buttonExit.Click += new System.EventHandler(this.buttonExit_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.Location = new System.Drawing.Point(112, 56);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 1;
			this.btnCancel.Text = "Cancel";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// TMS1000SampleForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(292, 144);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.buttonExit);
			this.Controls.Add(this.buttonScan);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "TMS1000SampleForm";
			this.Text = "TM-S1000SampleStep1";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// main entry point of application
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new TMS1000SampleForm());
		}

		// This method is called when the user clicks the scan button
		private void buttonScan_Click(object sender, System.EventArgs e)
		{
			buttonScan.Enabled = false;
			m_objApi.Scan();
		}

		// This delegate enables asynchronous calls for setting.
		delegate void ComplateCallback(int transactionNumber);

		// This method is called when the Complete scan
		public void Complate(int transactionNumber)
		{
			if (this.buttonScan.InvokeRequired)
			{
				ComplateCallback c = new ComplateCallback(Complate);
				this.Invoke(c, new object[] { transactionNumber });
			}
			else
			{
				buttonScan.Enabled = true;
			}
		}

		// This method is called when the user clicks the Exit button
		private void buttonExit_Click(object sender, System.EventArgs e)
		{
			m_objApi.Close();
			Close();
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			m_objApi.CancelScan();
		}
	}
}
