using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace TMS1000Sample
{
	/// <summary>
	/// explanation of the outline of ConfigureForm
	/// </summary>
	public class ConfigureForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button buttonOK;
		private System.Windows.Forms.Button buttonCancel;
		private System.Windows.Forms.Button buttonApply;
		private System.Windows.Forms.TabControl tabControl1;
		private System.Windows.Forms.TabPage tabImage;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.ComboBox comboBoxScanFunc;
		/// <summary>
		/// necessary designer variable
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.TabPage tabEndorse;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.CheckBox checkBoxElecEndorseText;
		private System.Windows.Forms.CheckBox checkBoxElecEndorseImage;

		protected Properties m_objConfig = null;

		public ConfigureForm()
		{
			//
			// Required by the Windows Form Designer
			//
			InitializeComponent();

			//
			// TODO: InitializeComponent
			//
			m_objConfig = new Properties();
			LoadProPerties();
		}

		/// <summary>
		/// Postprocessing is run to the resource that is used
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Create code by Windwos Form Designer 
		/// <summary>
		/// The following procedure is required by the Windows Form Designer
		/// It can be modified using the Windows Form Designer.
		/// Do not modify it using the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ConfigureForm));
			this.buttonOK = new System.Windows.Forms.Button();
			this.buttonCancel = new System.Windows.Forms.Button();
			this.buttonApply = new System.Windows.Forms.Button();
			this.tabControl1 = new System.Windows.Forms.TabControl();
			this.tabImage = new System.Windows.Forms.TabPage();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.comboBoxScanFunc = new System.Windows.Forms.ComboBox();
			this.tabEndorse = new System.Windows.Forms.TabPage();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.checkBoxElecEndorseImage = new System.Windows.Forms.CheckBox();
			this.checkBoxElecEndorseText = new System.Windows.Forms.CheckBox();
			this.tabControl1.SuspendLayout();
			this.tabImage.SuspendLayout();
			this.groupBox1.SuspendLayout();
			this.tabEndorse.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();
			// 
			// buttonOK
			// 
			this.buttonOK.Location = new System.Drawing.Point(8, 232);
			this.buttonOK.Name = "buttonOK";
			this.buttonOK.TabIndex = 1;
			this.buttonOK.Text = "OK";
			this.buttonOK.Click += new System.EventHandler(this.buttonOK_Click);
			// 
			// buttonCancel
			// 
			this.buttonCancel.Location = new System.Drawing.Point(112, 232);
			this.buttonCancel.Name = "buttonCancel";
			this.buttonCancel.TabIndex = 2;
			this.buttonCancel.Text = "Cancel";
			this.buttonCancel.Click += new System.EventHandler(this.buttonCancel_Click);
			// 
			// buttonApply
			// 
			this.buttonApply.Location = new System.Drawing.Point(216, 232);
			this.buttonApply.Name = "buttonApply";
			this.buttonApply.TabIndex = 3;
			this.buttonApply.Text = "Apply";
			this.buttonApply.Click += new System.EventHandler(this.buttonApply_Click);
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.Add(this.tabImage);
			this.tabControl1.Controls.Add(this.tabEndorse);
			this.tabControl1.Location = new System.Drawing.Point(8, 8);
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(280, 216);
			this.tabControl1.TabIndex = 0;
			// 
			// tabImage
			// 
			this.tabImage.Controls.Add(this.groupBox1);
			this.tabImage.Location = new System.Drawing.Point(4, 21);
			this.tabImage.Name = "tabImage";
			this.tabImage.Size = new System.Drawing.Size(272, 191);
			this.tabImage.TabIndex = 0;
			this.tabImage.Text = "Image";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.comboBoxScanFunc);
			this.groupBox1.Location = new System.Drawing.Point(0, 0);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(272, 72);
			this.groupBox1.TabIndex = 0;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Scanner";
			// 
			// comboBoxScanFunc
			// 
			this.comboBoxScanFunc.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxScanFunc.Items.AddRange(new object[] {
																  "Multi Scan",
																  "Single Scan"});
			this.comboBoxScanFunc.Location = new System.Drawing.Point(72, 32);
			this.comboBoxScanFunc.Name = "comboBoxScanFunc";
			this.comboBoxScanFunc.Size = new System.Drawing.Size(136, 20);
			this.comboBoxScanFunc.TabIndex = 0;
			this.comboBoxScanFunc.SelectedIndexChanged += new System.EventHandler(this.comboBoxScanFunc_SelectedIndexChanged);
			// 
			// tabEndorse
			// 
			this.tabEndorse.Controls.Add(this.groupBox2);
			this.tabEndorse.Location = new System.Drawing.Point(4, 21);
			this.tabEndorse.Name = "tabEndorse";
			this.tabEndorse.Size = new System.Drawing.Size(272, 191);
			this.tabEndorse.TabIndex = 1;
			this.tabEndorse.Text = "Endorse";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.checkBoxElecEndorseImage);
			this.groupBox2.Controls.Add(this.checkBoxElecEndorseText);
			this.groupBox2.Location = new System.Drawing.Point(0, 0);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(272, 192);
			this.groupBox2.TabIndex = 0;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Settings";
			// 
			// checkBoxElecEndorseImage
			// 
			this.checkBoxElecEndorseImage.Location = new System.Drawing.Point(24, 96);
			this.checkBoxElecEndorseImage.Name = "checkBoxElecEndorseImage";
			this.checkBoxElecEndorseImage.Size = new System.Drawing.Size(232, 24);
			this.checkBoxElecEndorseImage.TabIndex = 1;
			this.checkBoxElecEndorseImage.Text = "Perform electronic endorsement[Image]";
			this.checkBoxElecEndorseImage.CheckedChanged += new System.EventHandler(this.checkBoxElecEndorseImage_CheckedChanged);
			// 
			// checkBoxElecEndorseText
			// 
			this.checkBoxElecEndorseText.Location = new System.Drawing.Point(24, 64);
			this.checkBoxElecEndorseText.Name = "checkBoxElecEndorseText";
			this.checkBoxElecEndorseText.Size = new System.Drawing.Size(224, 24);
			this.checkBoxElecEndorseText.TabIndex = 0;
			this.checkBoxElecEndorseText.Text = "Perform electronic endorsement[Text]";
			this.checkBoxElecEndorseText.CheckedChanged += new System.EventHandler(this.checkBoxElecEndorseText_CheckedChanged);
			// 
			// ConfigureForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(298, 266);
			this.Controls.Add(this.tabControl1);
			this.Controls.Add(this.buttonOK);
			this.Controls.Add(this.buttonCancel);
			this.Controls.Add(this.buttonApply);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "ConfigureForm";
			this.Text = "ConfigureForm";
			this.tabControl1.ResumeLayout(false);
			this.tabImage.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			this.tabEndorse.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		// input of the property  
		public void SetProc(Properties Proc)
		{
			m_objConfig = new Properties(Proc);
			LoadProPerties();
		}

		// output of the property  
		public Properties GetProc()
		{
			return new Properties(m_objConfig);
		}

		// this method is called when the user click the OK button
		private void buttonOK_Click(object sender, System.EventArgs e)
		{
			SetProperties();
			Close();
		}

		// this method is called when the user click the Cancel button
		private void buttonCancel_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		// this method is called when the user click the Apply button
		private void buttonApply_Click(object sender, System.EventArgs e)
		{
			SetProperties();
			buttonApply.Enabled = false;
		}

		// this method is Each value is bound to the property   
		private void SetProperties()
		{
			m_objConfig.SetValue("Scan Func", comboBoxScanFunc.SelectedIndex);
			m_objConfig.SetValue("Electronic Endorse Text", checkBoxElecEndorseText.Checked);
			m_objConfig.SetValue("Electronic Endorse Image", checkBoxElecEndorseImage.Checked);
		}

		// this method is property is bound to the  Each value
		private void LoadProPerties()
		{
			comboBoxScanFunc.SelectedIndex = m_objConfig.GetValue("Scan Func");
			checkBoxElecEndorseText.Checked = m_objConfig.GetValueBool("Electronic Endorse Text");
			checkBoxElecEndorseImage.Checked = m_objConfig.GetValueBool("Electronic Endorse Image");

			buttonApply.Enabled = false;
		}

		private void comboBoxScanFunc_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;
		}

		private void checkBoxElecEndorseText_CheckedChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;
		}

		private void checkBoxElecEndorseImage_CheckedChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;		
		}
	}
}
