using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace TMS1000Sample
{
	/// <summary>
	/// explanation of the outline of ConfigureForm
	/// </summary>
	public class ConfigureForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button buttonOK;
		private System.Windows.Forms.Button buttonCancel;
		private System.Windows.Forms.Button buttonApply;
		private System.Windows.Forms.TabControl tabControl1;
		private System.Windows.Forms.TabPage tabImage;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.ComboBox comboBoxScanFunc;
		/// <summary>
		/// necessary designer variable
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.TabPage tabEndorse;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.TabPage tabConfirmation;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.CheckBox checkBoxConfirmation;
		private System.Windows.Forms.TabPage tabPaperMisInsertion;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.CheckBox checkBoxMisInsertDetect;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ComboBox comboBoxMisInsertEject;
		private System.Windows.Forms.CheckBox checkBoxMisInsertStamp;
		private System.Windows.Forms.CheckBox checkBoxMisInsertCancel;
		private System.Windows.Forms.TabPage tabNoise;
		private System.Windows.Forms.GroupBox groupBox5;
		private System.Windows.Forms.CheckBox checkBoxNoiseDetect;
		private System.Windows.Forms.CheckBox checkBoxNoiseStamp;
		private System.Windows.Forms.ComboBox comboBoxNoiseEject;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.CheckBox checkBoxNoiseCancel;
		private System.Windows.Forms.TabPage tabDoubleFeed;
		private System.Windows.Forms.GroupBox groupBox6;
		private System.Windows.Forms.CheckBox checkBoxDFStamp;
		private System.Windows.Forms.ComboBox comboBoxDFEject;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.CheckBox checkBoxDFCancel;
		private System.Windows.Forms.CheckBox checkBoxDFDetect;
		private System.Windows.Forms.TabPage tabNodata;
		private System.Windows.Forms.GroupBox groupBox7;
		private System.Windows.Forms.CheckBox checkBoxNoStamp;
		private System.Windows.Forms.ComboBox comboBoxNoEject;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.CheckBox checkBoxNoCancel;
		private System.Windows.Forms.CheckBox checkBoxNoDetect;
		private System.Windows.Forms.TabPage tabBaddata;
		private System.Windows.Forms.GroupBox groupBox8;
		private System.Windows.Forms.CheckBox checkBoxBadStamp;
		private System.Windows.Forms.ComboBox comboBoxBadEject;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.CheckBox checkBoxBadCancel;
		private System.Windows.Forms.CheckBox checkBoxBadDetect;
		private System.Windows.Forms.CheckBox checkBoxElecEndorseText;
		private System.Windows.Forms.CheckBox checkBoxElecEndorseImage;
		private System.Windows.Forms.CheckBox checkBoxRunScnToResult;
		private System.Windows.Forms.CheckBox checkBoxNoCallScnToResult;
		private System.Windows.Forms.Button buttonSettingValues;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.TextBox textBoxBadCount;

		protected Properties config = null;

		public ConfigureForm()
		{
			//
			// Required by the Windows Form Designer
			//
			InitializeComponent();

			//
			// TODO: InitializeComponent
			//
			config = new Properties();
			LoadProPerties();
		}

		/// <summary>
		/// Postprocessing is run to the resource that is used
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Create code by Windwos Form Designer 
		/// <summary>
		/// The following procedure is required by the Windows Form Designer
		/// It can be modified using the Windows Form Designer.
		/// Do not modify it using the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ConfigureForm));
			this.buttonOK = new System.Windows.Forms.Button();
			this.buttonCancel = new System.Windows.Forms.Button();
			this.buttonApply = new System.Windows.Forms.Button();
			this.tabControl1 = new System.Windows.Forms.TabControl();
			this.tabImage = new System.Windows.Forms.TabPage();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.comboBoxScanFunc = new System.Windows.Forms.ComboBox();
			this.tabDoubleFeed = new System.Windows.Forms.TabPage();
			this.groupBox6 = new System.Windows.Forms.GroupBox();
			this.checkBoxDFStamp = new System.Windows.Forms.CheckBox();
			this.comboBoxDFEject = new System.Windows.Forms.ComboBox();
			this.label3 = new System.Windows.Forms.Label();
			this.checkBoxDFCancel = new System.Windows.Forms.CheckBox();
			this.checkBoxDFDetect = new System.Windows.Forms.CheckBox();
			this.tabEndorse = new System.Windows.Forms.TabPage();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.checkBoxElecEndorseText = new System.Windows.Forms.CheckBox();
			this.checkBoxElecEndorseImage = new System.Windows.Forms.CheckBox();
			this.tabConfirmation = new System.Windows.Forms.TabPage();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.buttonSettingValues = new System.Windows.Forms.Button();
			this.checkBoxNoCallScnToResult = new System.Windows.Forms.CheckBox();
			this.checkBoxRunScnToResult = new System.Windows.Forms.CheckBox();
			this.checkBoxConfirmation = new System.Windows.Forms.CheckBox();
			this.tabPaperMisInsertion = new System.Windows.Forms.TabPage();
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.checkBoxMisInsertStamp = new System.Windows.Forms.CheckBox();
			this.comboBoxMisInsertEject = new System.Windows.Forms.ComboBox();
			this.label1 = new System.Windows.Forms.Label();
			this.checkBoxMisInsertDetect = new System.Windows.Forms.CheckBox();
			this.checkBoxMisInsertCancel = new System.Windows.Forms.CheckBox();
			this.tabNoise = new System.Windows.Forms.TabPage();
			this.groupBox5 = new System.Windows.Forms.GroupBox();
			this.checkBoxNoiseStamp = new System.Windows.Forms.CheckBox();
			this.comboBoxNoiseEject = new System.Windows.Forms.ComboBox();
			this.label2 = new System.Windows.Forms.Label();
			this.checkBoxNoiseCancel = new System.Windows.Forms.CheckBox();
			this.checkBoxNoiseDetect = new System.Windows.Forms.CheckBox();
			this.tabBaddata = new System.Windows.Forms.TabPage();
			this.groupBox8 = new System.Windows.Forms.GroupBox();
			this.textBoxBadCount = new System.Windows.Forms.TextBox();
			this.label6 = new System.Windows.Forms.Label();
			this.checkBoxBadStamp = new System.Windows.Forms.CheckBox();
			this.comboBoxBadEject = new System.Windows.Forms.ComboBox();
			this.label5 = new System.Windows.Forms.Label();
			this.checkBoxBadCancel = new System.Windows.Forms.CheckBox();
			this.checkBoxBadDetect = new System.Windows.Forms.CheckBox();
			this.tabNodata = new System.Windows.Forms.TabPage();
			this.groupBox7 = new System.Windows.Forms.GroupBox();
			this.checkBoxNoStamp = new System.Windows.Forms.CheckBox();
			this.comboBoxNoEject = new System.Windows.Forms.ComboBox();
			this.label4 = new System.Windows.Forms.Label();
			this.checkBoxNoCancel = new System.Windows.Forms.CheckBox();
			this.checkBoxNoDetect = new System.Windows.Forms.CheckBox();
			this.tabControl1.SuspendLayout();
			this.tabImage.SuspendLayout();
			this.groupBox1.SuspendLayout();
			this.tabDoubleFeed.SuspendLayout();
			this.groupBox6.SuspendLayout();
			this.tabEndorse.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.tabConfirmation.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.tabPaperMisInsertion.SuspendLayout();
			this.groupBox4.SuspendLayout();
			this.tabNoise.SuspendLayout();
			this.groupBox5.SuspendLayout();
			this.tabBaddata.SuspendLayout();
			this.groupBox8.SuspendLayout();
			this.tabNodata.SuspendLayout();
			this.groupBox7.SuspendLayout();
			this.SuspendLayout();
			// 
			// buttonOK
			// 
			this.buttonOK.Location = new System.Drawing.Point(8, 232);
			this.buttonOK.Name = "buttonOK";
			this.buttonOK.TabIndex = 0;
			this.buttonOK.Text = "OK";
			this.buttonOK.Click += new System.EventHandler(this.buttonOK_Click);
			// 
			// buttonCancel
			// 
			this.buttonCancel.Location = new System.Drawing.Point(112, 232);
			this.buttonCancel.Name = "buttonCancel";
			this.buttonCancel.TabIndex = 0;
			this.buttonCancel.Text = "Cancel";
			this.buttonCancel.Click += new System.EventHandler(this.buttonCancel_Click);
			// 
			// buttonApply
			// 
			this.buttonApply.Location = new System.Drawing.Point(216, 232);
			this.buttonApply.Name = "buttonApply";
			this.buttonApply.TabIndex = 0;
			this.buttonApply.Text = "Apply";
			this.buttonApply.Click += new System.EventHandler(this.buttonApply_Click);
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.Add(this.tabImage);
			this.tabControl1.Controls.Add(this.tabDoubleFeed);
			this.tabControl1.Controls.Add(this.tabEndorse);
			this.tabControl1.Controls.Add(this.tabConfirmation);
			this.tabControl1.Controls.Add(this.tabPaperMisInsertion);
			this.tabControl1.Controls.Add(this.tabNoise);
			this.tabControl1.Controls.Add(this.tabBaddata);
			this.tabControl1.Controls.Add(this.tabNodata);
			this.tabControl1.Location = new System.Drawing.Point(8, 8);
			this.tabControl1.Multiline = true;
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(280, 216);
			this.tabControl1.SizeMode = System.Windows.Forms.TabSizeMode.FillToRight;
			this.tabControl1.TabIndex = 1;
			// 
			// tabImage
			// 
			this.tabImage.Controls.Add(this.groupBox1);
			this.tabImage.Location = new System.Drawing.Point(4, 38);
			this.tabImage.Name = "tabImage";
			this.tabImage.Size = new System.Drawing.Size(272, 174);
			this.tabImage.TabIndex = 0;
			this.tabImage.Text = "Image";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.comboBoxScanFunc);
			this.groupBox1.Location = new System.Drawing.Point(0, 0);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(272, 72);
			this.groupBox1.TabIndex = 0;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Scanner";
			// 
			// comboBoxScanFunc
			// 
			this.comboBoxScanFunc.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxScanFunc.Items.AddRange(new object[] {
																  "Multi Scan",
																  "Single Scan"});
			this.comboBoxScanFunc.Location = new System.Drawing.Point(72, 32);
			this.comboBoxScanFunc.Name = "comboBoxScanFunc";
			this.comboBoxScanFunc.Size = new System.Drawing.Size(136, 20);
			this.comboBoxScanFunc.TabIndex = 0;
			this.comboBoxScanFunc.SelectedIndexChanged += new System.EventHandler(this.comboBoxScanFunc_SelectedIndexChanged);
			// 
			// tabDoubleFeed
			// 
			this.tabDoubleFeed.Controls.Add(this.groupBox6);
			this.tabDoubleFeed.Location = new System.Drawing.Point(4, 38);
			this.tabDoubleFeed.Name = "tabDoubleFeed";
			this.tabDoubleFeed.Size = new System.Drawing.Size(272, 174);
			this.tabDoubleFeed.TabIndex = 5;
			this.tabDoubleFeed.Text = "DoubleFeed";
			// 
			// groupBox6
			// 
			this.groupBox6.Controls.Add(this.checkBoxDFStamp);
			this.groupBox6.Controls.Add(this.comboBoxDFEject);
			this.groupBox6.Controls.Add(this.label3);
			this.groupBox6.Controls.Add(this.checkBoxDFCancel);
			this.groupBox6.Controls.Add(this.checkBoxDFDetect);
			this.groupBox6.Location = new System.Drawing.Point(0, 3);
			this.groupBox6.Name = "groupBox6";
			this.groupBox6.Size = new System.Drawing.Size(272, 168);
			this.groupBox6.TabIndex = 1;
			this.groupBox6.TabStop = false;
			this.groupBox6.Text = "Settings";
			// 
			// checkBoxDFStamp
			// 
			this.checkBoxDFStamp.Location = new System.Drawing.Point(120, 88);
			this.checkBoxDFStamp.Name = "checkBoxDFStamp";
			this.checkBoxDFStamp.TabIndex = 2;
			this.checkBoxDFStamp.Text = "Stamp";
			this.checkBoxDFStamp.CheckedChanged += new System.EventHandler(this.checkBoxDFStamp_CheckedChanged);
			// 
			// comboBoxDFEject
			// 
			this.comboBoxDFEject.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxDFEject.Items.AddRange(new object[] {
																 "Main Eject",
																 "Sub Eject"});
			this.comboBoxDFEject.Location = new System.Drawing.Point(120, 56);
			this.comboBoxDFEject.Name = "comboBoxDFEject";
			this.comboBoxDFEject.Size = new System.Drawing.Size(121, 20);
			this.comboBoxDFEject.TabIndex = 1;
			this.comboBoxDFEject.SelectedIndexChanged += new System.EventHandler(this.comboBoxDFEject_SelectedIndexChanged);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(16, 56);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(72, 23);
			this.label3.TabIndex = 4;
			this.label3.Text = "Eject Type";
			// 
			// checkBoxDFCancel
			// 
			this.checkBoxDFCancel.Location = new System.Drawing.Point(120, 120);
			this.checkBoxDFCancel.Name = "checkBoxDFCancel";
			this.checkBoxDFCancel.TabIndex = 3;
			this.checkBoxDFCancel.Text = "Cancel";
			this.checkBoxDFCancel.CheckedChanged += new System.EventHandler(this.checkBoxDFCancel_CheckedChanged);
			// 
			// checkBoxDFDetect
			// 
			this.checkBoxDFDetect.Location = new System.Drawing.Point(48, 24);
			this.checkBoxDFDetect.Name = "checkBoxDFDetect";
			this.checkBoxDFDetect.TabIndex = 0;
			this.checkBoxDFDetect.Text = "Detect";
			this.checkBoxDFDetect.CheckedChanged += new System.EventHandler(this.checkBoxDFDetect_CheckedChanged);
			// 
			// tabEndorse
			// 
			this.tabEndorse.Controls.Add(this.groupBox2);
			this.tabEndorse.Location = new System.Drawing.Point(4, 38);
			this.tabEndorse.Name = "tabEndorse";
			this.tabEndorse.Size = new System.Drawing.Size(272, 174);
			this.tabEndorse.TabIndex = 1;
			this.tabEndorse.Text = "Endorse";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.checkBoxElecEndorseText);
			this.groupBox2.Controls.Add(this.checkBoxElecEndorseImage);
			this.groupBox2.Location = new System.Drawing.Point(0, 0);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(272, 168);
			this.groupBox2.TabIndex = 0;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Settings";
			// 
			// checkBoxElecEndorseText
			// 
			this.checkBoxElecEndorseText.Location = new System.Drawing.Point(24, 48);
			this.checkBoxElecEndorseText.Name = "checkBoxElecEndorseText";
			this.checkBoxElecEndorseText.Size = new System.Drawing.Size(224, 24);
			this.checkBoxElecEndorseText.TabIndex = 0;
			this.checkBoxElecEndorseText.Text = "Perform electronic endorsement[Text]";
			this.checkBoxElecEndorseText.CheckedChanged += new System.EventHandler(this.checkBoxElecEndorseText_CheckedChanged);
			// 
			// checkBoxElecEndorseImage
			// 
			this.checkBoxElecEndorseImage.Location = new System.Drawing.Point(24, 80);
			this.checkBoxElecEndorseImage.Name = "checkBoxElecEndorseImage";
			this.checkBoxElecEndorseImage.Size = new System.Drawing.Size(232, 24);
			this.checkBoxElecEndorseImage.TabIndex = 0;
			this.checkBoxElecEndorseImage.Text = "Perform electronic endorsement[Image]";
			this.checkBoxElecEndorseImage.CheckedChanged += new System.EventHandler(this.checkBoxElecEndorseImage_CheckedChanged);
			// 
			// tabConfirmation
			// 
			this.tabConfirmation.Controls.Add(this.groupBox3);
			this.tabConfirmation.Location = new System.Drawing.Point(4, 38);
			this.tabConfirmation.Name = "tabConfirmation";
			this.tabConfirmation.Size = new System.Drawing.Size(272, 174);
			this.tabConfirmation.TabIndex = 2;
			this.tabConfirmation.Text = "Confirmation";
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.Add(this.buttonSettingValues);
			this.groupBox3.Controls.Add(this.checkBoxNoCallScnToResult);
			this.groupBox3.Controls.Add(this.checkBoxRunScnToResult);
			this.groupBox3.Controls.Add(this.checkBoxConfirmation);
			this.groupBox3.Location = new System.Drawing.Point(0, 0);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(272, 168);
			this.groupBox3.TabIndex = 0;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "Settings";
			// 
			// buttonSettingValues
			// 
			this.buttonSettingValues.Location = new System.Drawing.Point(96, 128);
			this.buttonSettingValues.Name = "buttonSettingValues";
			this.buttonSettingValues.Size = new System.Drawing.Size(88, 23);
			this.buttonSettingValues.TabIndex = 6;
			this.buttonSettingValues.Text = "Setting Values";
			this.buttonSettingValues.Click += new System.EventHandler(this.buttonSettingValues_Click);
			// 
			// checkBoxNoCallScnToResult
			// 
			this.checkBoxNoCallScnToResult.Location = new System.Drawing.Point(64, 88);
			this.checkBoxNoCallScnToResult.Name = "checkBoxNoCallScnToResult";
			this.checkBoxNoCallScnToResult.Size = new System.Drawing.Size(192, 16);
			this.checkBoxNoCallScnToResult.TabIndex = 5;
			this.checkBoxNoCallScnToResult.Text = "No call SetBehaviorToScnResult";
			this.checkBoxNoCallScnToResult.CheckedChanged += new System.EventHandler(this.checkBoxNoCallScnToResult_CheckedChanged);
			// 
			// checkBoxRunScnToResult
			// 
			this.checkBoxRunScnToResult.Location = new System.Drawing.Point(48, 56);
			this.checkBoxRunScnToResult.Name = "checkBoxRunScnToResult";
			this.checkBoxRunScnToResult.Size = new System.Drawing.Size(184, 16);
			this.checkBoxRunScnToResult.TabIndex = 4;
			this.checkBoxRunScnToResult.Text = "Run SetBehaviorToScnResult";
			this.checkBoxRunScnToResult.CheckedChanged += new System.EventHandler(this.checkBoxRunScnToResult_CheckedChanged);
			// 
			// checkBoxConfirmation
			// 
			this.checkBoxConfirmation.Location = new System.Drawing.Point(32, 24);
			this.checkBoxConfirmation.Name = "checkBoxConfirmation";
			this.checkBoxConfirmation.Size = new System.Drawing.Size(144, 16);
			this.checkBoxConfirmation.TabIndex = 0;
			this.checkBoxConfirmation.Text = "Confirmation Mode";
			this.checkBoxConfirmation.CheckedChanged += new System.EventHandler(this.checkBoxConfirmation_CheckedChanged);
			// 
			// tabPaperMisInsertion
			// 
			this.tabPaperMisInsertion.Controls.Add(this.groupBox4);
			this.tabPaperMisInsertion.Location = new System.Drawing.Point(4, 38);
			this.tabPaperMisInsertion.Name = "tabPaperMisInsertion";
			this.tabPaperMisInsertion.Size = new System.Drawing.Size(272, 174);
			this.tabPaperMisInsertion.TabIndex = 3;
			this.tabPaperMisInsertion.Text = "PaperMisInsert";
			// 
			// groupBox4
			// 
			this.groupBox4.Controls.Add(this.checkBoxMisInsertStamp);
			this.groupBox4.Controls.Add(this.comboBoxMisInsertEject);
			this.groupBox4.Controls.Add(this.label1);
			this.groupBox4.Controls.Add(this.checkBoxMisInsertDetect);
			this.groupBox4.Controls.Add(this.checkBoxMisInsertCancel);
			this.groupBox4.Location = new System.Drawing.Point(0, 0);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(272, 160);
			this.groupBox4.TabIndex = 0;
			this.groupBox4.TabStop = false;
			this.groupBox4.Text = "Settings";
			// 
			// checkBoxMisInsertStamp
			// 
			this.checkBoxMisInsertStamp.Location = new System.Drawing.Point(120, 88);
			this.checkBoxMisInsertStamp.Name = "checkBoxMisInsertStamp";
			this.checkBoxMisInsertStamp.TabIndex = 3;
			this.checkBoxMisInsertStamp.Text = "Stamp";
			this.checkBoxMisInsertStamp.CheckedChanged += new System.EventHandler(this.checkBoxMisInsertStamp_CheckedChanged);
			// 
			// comboBoxMisInsertEject
			// 
			this.comboBoxMisInsertEject.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxMisInsertEject.Items.AddRange(new object[] {
																		"Main Eject",
																		"Sub Eject"});
			this.comboBoxMisInsertEject.Location = new System.Drawing.Point(120, 56);
			this.comboBoxMisInsertEject.Name = "comboBoxMisInsertEject";
			this.comboBoxMisInsertEject.Size = new System.Drawing.Size(121, 20);
			this.comboBoxMisInsertEject.TabIndex = 2;
			this.comboBoxMisInsertEject.SelectedIndexChanged += new System.EventHandler(this.comboBoxMisInsertEject_SelectedIndexChanged);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 56);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 23);
			this.label1.TabIndex = 1;
			this.label1.Text = "Eject Type";
			// 
			// checkBoxMisInsertDetect
			// 
			this.checkBoxMisInsertDetect.Location = new System.Drawing.Point(48, 24);
			this.checkBoxMisInsertDetect.Name = "checkBoxMisInsertDetect";
			this.checkBoxMisInsertDetect.TabIndex = 0;
			this.checkBoxMisInsertDetect.Text = "Detect";
			this.checkBoxMisInsertDetect.CheckedChanged += new System.EventHandler(this.checkBoxMisInsertDetect_CheckedChanged);
			// 
			// checkBoxMisInsertCancel
			// 
			this.checkBoxMisInsertCancel.Location = new System.Drawing.Point(120, 120);
			this.checkBoxMisInsertCancel.Name = "checkBoxMisInsertCancel";
			this.checkBoxMisInsertCancel.TabIndex = 3;
			this.checkBoxMisInsertCancel.Text = "Cancel";
			this.checkBoxMisInsertCancel.CheckedChanged += new System.EventHandler(this.checkBoxMisInsertCancel_CheckedChanged);
			// 
			// tabNoise
			// 
			this.tabNoise.Controls.Add(this.groupBox5);
			this.tabNoise.Location = new System.Drawing.Point(4, 38);
			this.tabNoise.Name = "tabNoise";
			this.tabNoise.Size = new System.Drawing.Size(272, 174);
			this.tabNoise.TabIndex = 4;
			this.tabNoise.Text = "Noise";
			// 
			// groupBox5
			// 
			this.groupBox5.Controls.Add(this.checkBoxNoiseStamp);
			this.groupBox5.Controls.Add(this.comboBoxNoiseEject);
			this.groupBox5.Controls.Add(this.label2);
			this.groupBox5.Controls.Add(this.checkBoxNoiseCancel);
			this.groupBox5.Controls.Add(this.checkBoxNoiseDetect);
			this.groupBox5.Location = new System.Drawing.Point(0, 0);
			this.groupBox5.Name = "groupBox5";
			this.groupBox5.Size = new System.Drawing.Size(272, 168);
			this.groupBox5.TabIndex = 0;
			this.groupBox5.TabStop = false;
			this.groupBox5.Text = "Settings";
			// 
			// checkBoxNoiseStamp
			// 
			this.checkBoxNoiseStamp.Location = new System.Drawing.Point(120, 88);
			this.checkBoxNoiseStamp.Name = "checkBoxNoiseStamp";
			this.checkBoxNoiseStamp.TabIndex = 6;
			this.checkBoxNoiseStamp.Text = "Stamp";
			this.checkBoxNoiseStamp.CheckedChanged += new System.EventHandler(this.checkBoxNoiseStamp_CheckedChanged);
			// 
			// comboBoxNoiseEject
			// 
			this.comboBoxNoiseEject.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxNoiseEject.Items.AddRange(new object[] {
																	"Main Eject",
																	"Sub Eject"});
			this.comboBoxNoiseEject.Location = new System.Drawing.Point(120, 56);
			this.comboBoxNoiseEject.Name = "comboBoxNoiseEject";
			this.comboBoxNoiseEject.Size = new System.Drawing.Size(121, 20);
			this.comboBoxNoiseEject.TabIndex = 5;
			this.comboBoxNoiseEject.SelectedIndexChanged += new System.EventHandler(this.comboBoxNoiseEject_SelectedIndexChanged);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 56);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(72, 23);
			this.label2.TabIndex = 4;
			this.label2.Text = "Eject Type";
			// 
			// checkBoxNoiseCancel
			// 
			this.checkBoxNoiseCancel.Location = new System.Drawing.Point(120, 120);
			this.checkBoxNoiseCancel.Name = "checkBoxNoiseCancel";
			this.checkBoxNoiseCancel.TabIndex = 7;
			this.checkBoxNoiseCancel.Text = "Cancel";
			this.checkBoxNoiseCancel.CheckedChanged += new System.EventHandler(this.checkBoxNoiseCancel_CheckedChanged);
			// 
			// checkBoxNoiseDetect
			// 
			this.checkBoxNoiseDetect.Location = new System.Drawing.Point(48, 24);
			this.checkBoxNoiseDetect.Name = "checkBoxNoiseDetect";
			this.checkBoxNoiseDetect.TabIndex = 0;
			this.checkBoxNoiseDetect.Text = "Detect";
			this.checkBoxNoiseDetect.CheckedChanged += new System.EventHandler(this.checkBoxNoiseDetect_CheckedChanged);
			// 
			// tabBaddata
			// 
			this.tabBaddata.Controls.Add(this.groupBox8);
			this.tabBaddata.Location = new System.Drawing.Point(4, 38);
			this.tabBaddata.Name = "tabBaddata";
			this.tabBaddata.Size = new System.Drawing.Size(272, 174);
			this.tabBaddata.TabIndex = 7;
			this.tabBaddata.Text = "Baddata";
			// 
			// groupBox8
			// 
			this.groupBox8.Controls.Add(this.textBoxBadCount);
			this.groupBox8.Controls.Add(this.label6);
			this.groupBox8.Controls.Add(this.checkBoxBadStamp);
			this.groupBox8.Controls.Add(this.comboBoxBadEject);
			this.groupBox8.Controls.Add(this.label5);
			this.groupBox8.Controls.Add(this.checkBoxBadCancel);
			this.groupBox8.Controls.Add(this.checkBoxBadDetect);
			this.groupBox8.Location = new System.Drawing.Point(0, 3);
			this.groupBox8.Name = "groupBox8";
			this.groupBox8.Size = new System.Drawing.Size(272, 168);
			this.groupBox8.TabIndex = 3;
			this.groupBox8.TabStop = false;
			this.groupBox8.Text = "Settings";
			// 
			// textBoxBadCount
			// 
			this.textBoxBadCount.Location = new System.Drawing.Point(120, 136);
			this.textBoxBadCount.Name = "textBoxBadCount";
			this.textBoxBadCount.TabIndex = 9;
			this.textBoxBadCount.Text = "";
			this.textBoxBadCount.TextChanged += new System.EventHandler(this.textBoxBadCount_TextChanged);
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(32, 136);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(48, 23);
			this.label6.TabIndex = 8;
			this.label6.Text = "Count";
			// 
			// checkBoxBadStamp
			// 
			this.checkBoxBadStamp.Location = new System.Drawing.Point(120, 80);
			this.checkBoxBadStamp.Name = "checkBoxBadStamp";
			this.checkBoxBadStamp.TabIndex = 6;
			this.checkBoxBadStamp.Text = "Stamp";
			this.checkBoxBadStamp.CheckedChanged += new System.EventHandler(this.checkBoxBadStamp_CheckedChanged);
			// 
			// comboBoxBadEject
			// 
			this.comboBoxBadEject.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxBadEject.Items.AddRange(new object[] {
																  "Main Eject",
																  "Sub Eject"});
			this.comboBoxBadEject.Location = new System.Drawing.Point(120, 56);
			this.comboBoxBadEject.Name = "comboBoxBadEject";
			this.comboBoxBadEject.Size = new System.Drawing.Size(121, 20);
			this.comboBoxBadEject.TabIndex = 5;
			this.comboBoxBadEject.SelectedIndexChanged += new System.EventHandler(this.comboBoxBadEject_SelectedIndexChanged);
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(16, 56);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(72, 23);
			this.label5.TabIndex = 4;
			this.label5.Text = "Eject Type";
			// 
			// checkBoxBadCancel
			// 
			this.checkBoxBadCancel.Location = new System.Drawing.Point(120, 104);
			this.checkBoxBadCancel.Name = "checkBoxBadCancel";
			this.checkBoxBadCancel.TabIndex = 7;
			this.checkBoxBadCancel.Text = "Cancel";
			this.checkBoxBadCancel.CheckedChanged += new System.EventHandler(this.checkBoxBadCancel_CheckedChanged);
			// 
			// checkBoxBadDetect
			// 
			this.checkBoxBadDetect.Location = new System.Drawing.Point(48, 24);
			this.checkBoxBadDetect.Name = "checkBoxBadDetect";
			this.checkBoxBadDetect.Size = new System.Drawing.Size(72, 24);
			this.checkBoxBadDetect.TabIndex = 0;
			this.checkBoxBadDetect.Text = "Detect";
			this.checkBoxBadDetect.CheckedChanged += new System.EventHandler(this.checkBoxBadDetect_CheckedChanged);
			// 
			// tabNodata
			// 
			this.tabNodata.Controls.Add(this.groupBox7);
			this.tabNodata.Location = new System.Drawing.Point(4, 38);
			this.tabNodata.Name = "tabNodata";
			this.tabNodata.Size = new System.Drawing.Size(272, 174);
			this.tabNodata.TabIndex = 6;
			this.tabNodata.Text = "Nodata";
			// 
			// groupBox7
			// 
			this.groupBox7.Controls.Add(this.checkBoxNoStamp);
			this.groupBox7.Controls.Add(this.comboBoxNoEject);
			this.groupBox7.Controls.Add(this.label4);
			this.groupBox7.Controls.Add(this.checkBoxNoCancel);
			this.groupBox7.Controls.Add(this.checkBoxNoDetect);
			this.groupBox7.Location = new System.Drawing.Point(0, 3);
			this.groupBox7.Name = "groupBox7";
			this.groupBox7.Size = new System.Drawing.Size(272, 168);
			this.groupBox7.TabIndex = 2;
			this.groupBox7.TabStop = false;
			this.groupBox7.Text = "Settings";
			// 
			// checkBoxNoStamp
			// 
			this.checkBoxNoStamp.Location = new System.Drawing.Point(120, 88);
			this.checkBoxNoStamp.Name = "checkBoxNoStamp";
			this.checkBoxNoStamp.TabIndex = 6;
			this.checkBoxNoStamp.Text = "Stamp";
			this.checkBoxNoStamp.CheckedChanged += new System.EventHandler(this.checkBoxNoStamp_CheckedChanged);
			// 
			// comboBoxNoEject
			// 
			this.comboBoxNoEject.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxNoEject.Items.AddRange(new object[] {
																 "Main Eject",
																 "Sub Eject"});
			this.comboBoxNoEject.Location = new System.Drawing.Point(120, 56);
			this.comboBoxNoEject.Name = "comboBoxNoEject";
			this.comboBoxNoEject.Size = new System.Drawing.Size(121, 20);
			this.comboBoxNoEject.TabIndex = 5;
			this.comboBoxNoEject.SelectedIndexChanged += new System.EventHandler(this.comboBoxNoEject_SelectedIndexChanged);
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 56);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(72, 23);
			this.label4.TabIndex = 4;
			this.label4.Text = "Eject Type";
			// 
			// checkBoxNoCancel
			// 
			this.checkBoxNoCancel.Location = new System.Drawing.Point(120, 120);
			this.checkBoxNoCancel.Name = "checkBoxNoCancel";
			this.checkBoxNoCancel.TabIndex = 7;
			this.checkBoxNoCancel.Text = "Cancel";
			this.checkBoxNoCancel.CheckedChanged += new System.EventHandler(this.checkBoxNoCancel_CheckedChanged);
			// 
			// checkBoxNoDetect
			// 
			this.checkBoxNoDetect.Location = new System.Drawing.Point(48, 24);
			this.checkBoxNoDetect.Name = "checkBoxNoDetect";
			this.checkBoxNoDetect.TabIndex = 0;
			this.checkBoxNoDetect.Text = "Detect";
			this.checkBoxNoDetect.CheckedChanged += new System.EventHandler(this.checkBoxNoDetect_CheckedChanged);
			// 
			// ConfigureForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(298, 266);
			this.Controls.Add(this.tabControl1);
			this.Controls.Add(this.buttonOK);
			this.Controls.Add(this.buttonCancel);
			this.Controls.Add(this.buttonApply);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "ConfigureForm";
			this.Text = "ConfigureForm";
			this.tabControl1.ResumeLayout(false);
			this.tabImage.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			this.tabDoubleFeed.ResumeLayout(false);
			this.groupBox6.ResumeLayout(false);
			this.tabEndorse.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.tabConfirmation.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.tabPaperMisInsertion.ResumeLayout(false);
			this.groupBox4.ResumeLayout(false);
			this.tabNoise.ResumeLayout(false);
			this.groupBox5.ResumeLayout(false);
			this.tabBaddata.ResumeLayout(false);
			this.groupBox8.ResumeLayout(false);
			this.tabNodata.ResumeLayout(false);
			this.groupBox7.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		// input of the property  
		public void SetProc(Properties Proc)
		{
			config = new Properties(Proc);
			LoadProPerties();
		}

		// output of the property  
		public Properties GetProc()
		{
			return new Properties(config);
		}

		// this method is called when the user click the OK button
		private void buttonOK_Click(object sender, System.EventArgs e)
		{
			SetProperties();
			Close();
		}

		// this method is called when the user click the Cancel button
		private void buttonCancel_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		// this method is called when the user click the Apply button
		private void buttonApply_Click(object sender, System.EventArgs e)
		{
			SetProperties();
			buttonApply.Enabled = false;
		}

		// this method is Each value is bound to the property   
		private void SetProperties()
		{
			config.SetValue(Properties.SCAN_FUNC, comboBoxScanFunc.SelectedIndex);
			config.SetValue(Properties.ELEC_ENDORSE_TEXT, checkBoxElecEndorseText.Checked);
			config.SetValue(Properties.ELEC_ENDORSE_IMAGE, checkBoxElecEndorseImage.Checked);

			config.SetValue(Properties.CONFIRMATION, checkBoxConfirmation.Checked);
			config.SetValue(Properties.RUN_SCN_TO_RESULT, checkBoxRunScnToResult.Checked);
			config.SetValue(Properties.NO_CALL_SCN_TO_RESULT, checkBoxNoCallScnToResult.Checked);

			config.SetValue(Properties.MIS_INSERT_DETECT, checkBoxMisInsertDetect.Checked);
			config.SetValue(Properties.MIS_INSERT_EJECT, comboBoxMisInsertEject.SelectedIndex);
			config.SetValue(Properties.MIS_INSERT_STAMP, checkBoxMisInsertStamp.Checked);
			config.SetValue(Properties.MIS_INSERT_CANCEL, checkBoxMisInsertCancel.Checked);

			config.SetValue(Properties.NOISE_DETECT, checkBoxNoiseDetect.Checked);
			config.SetValue(Properties.NOISE_EJECT, comboBoxNoiseEject.SelectedIndex);
			config.SetValue(Properties.NOISE_STAMP, checkBoxNoiseStamp.Checked);
			config.SetValue(Properties.NOISE_CANCEL, checkBoxNoiseCancel.Checked);

			config.SetValue(Properties.DOUBLE_FEED_DETECT, checkBoxDFDetect.Checked);
			config.SetValue(Properties.DOUBLE_FEED_EJECT, comboBoxDFEject.SelectedIndex);
			config.SetValue(Properties.DOUBLE_FEED_STAMP, checkBoxDFStamp.Checked);
			config.SetValue(Properties.DOUBLE_FEED_CANCEL, checkBoxDFCancel.Checked);

			config.SetValue(Properties.BADDATA_COUNT, Convert.ToInt32(textBoxBadCount.Text));
			config.SetValue(Properties.BADDATA_DETECT, checkBoxBadDetect.Checked);
			config.SetValue(Properties.BADDATA_EJECT, comboBoxBadEject.SelectedIndex);
			config.SetValue(Properties.BADDATA_STAMP, checkBoxBadStamp.Checked);
			config.SetValue(Properties.BADDATA_CANCEL, checkBoxBadCancel.Checked);

			config.SetValue(Properties.NODATA_DETECT, checkBoxNoDetect.Checked);
			config.SetValue(Properties.NODATA_EJECT, comboBoxNoEject.SelectedIndex);
			config.SetValue(Properties.NODATA_STAMP, checkBoxNoStamp.Checked);
			config.SetValue(Properties.NODATA_CANCEL, checkBoxNoCancel.Checked);
		}

		// this method is property is bound to the  Each value
		private void LoadProPerties()
		{
			comboBoxScanFunc.SelectedIndex = config.GetValue(Properties.SCAN_FUNC);
			checkBoxElecEndorseText.Checked = config.GetValueBool(Properties.ELEC_ENDORSE_TEXT);
			checkBoxElecEndorseImage.Checked = config.GetValueBool(Properties.ELEC_ENDORSE_IMAGE);

			checkBoxConfirmation.Checked = config.GetValueBool(Properties.CONFIRMATION);
			checkBoxRunScnToResult.Checked = config.GetValueBool(Properties.RUN_SCN_TO_RESULT);
			checkBoxNoCallScnToResult.Checked = config.GetValueBool(Properties.NO_CALL_SCN_TO_RESULT);

			checkBoxMisInsertDetect.Checked = config.GetValueBool(Properties.MIS_INSERT_DETECT);
			comboBoxMisInsertEject.SelectedIndex = config.GetValue(Properties.MIS_INSERT_EJECT);
			checkBoxMisInsertStamp.Checked = config.GetValueBool(Properties.MIS_INSERT_STAMP);
			checkBoxMisInsertCancel.Checked = config.GetValueBool(Properties.MIS_INSERT_CANCEL);

			checkBoxNoiseDetect.Checked = config.GetValueBool(Properties.NOISE_DETECT);
			comboBoxNoiseEject.SelectedIndex = config.GetValue(Properties.NOISE_EJECT);
			checkBoxNoiseStamp.Checked = config.GetValueBool(Properties.NOISE_STAMP);
			checkBoxNoiseCancel.Checked = config.GetValueBool(Properties.NOISE_CANCEL);

			checkBoxDFDetect.Checked = config.GetValueBool(Properties.DOUBLE_FEED_DETECT);
			comboBoxDFEject.SelectedIndex = config.GetValue(Properties.DOUBLE_FEED_EJECT);
			checkBoxDFStamp.Checked = config.GetValueBool(Properties.DOUBLE_FEED_STAMP);
			checkBoxDFCancel.Checked = config.GetValueBool(Properties.DOUBLE_FEED_CANCEL);

			textBoxBadCount.Text = config.GetValue(Properties.BADDATA_COUNT).ToString();
			checkBoxBadDetect.Checked = config.GetValueBool(Properties.BADDATA_DETECT);
			comboBoxBadEject.SelectedIndex = config.GetValue(Properties.BADDATA_EJECT);
			checkBoxBadStamp.Checked = config.GetValueBool(Properties.BADDATA_STAMP);
			checkBoxBadCancel.Checked = config.GetValueBool(Properties.BADDATA_CANCEL);

			checkBoxNoDetect.Checked = config.GetValueBool(Properties.NODATA_DETECT);
			comboBoxNoEject.SelectedIndex = config.GetValue(Properties.NODATA_EJECT);
			checkBoxNoStamp.Checked = config.GetValueBool(Properties.NODATA_STAMP);
			checkBoxNoCancel.Checked = config.GetValueBool(Properties.NODATA_CANCEL);

			EnableMisInsert(config.GetValueBool(Properties.MIS_INSERT_DETECT));
			EnableNoise(config.GetValueBool(Properties.NOISE_DETECT));
			EnableDoubleFeed(config.GetValueBool(Properties.DOUBLE_FEED_DETECT));
			EnableBaddata(config.GetValueBool(Properties.BADDATA_DETECT));
			EnableNodata(config.GetValueBool(Properties.NODATA_DETECT));
			RunEnable(checkBoxConfirmation.Checked);
			buttonApply.Enabled = false;
		}

		private void comboBoxScanFunc_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;
		}

		private void checkBoxElecEndorseText_CheckedChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;
		}

		private void checkBoxConfirmation_CheckedChanged(object sender, System.EventArgs e)
		{
			RunEnable(checkBoxConfirmation.Checked);

			buttonApply.Enabled = true;
		}

		private void checkBoxMisInsertDetect_CheckedChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;	
			EnableMisInsert(checkBoxMisInsertDetect.Checked);
		}

		private void comboBoxMisInsertEject_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;	
		}

		private void checkBoxMisInsertStamp_CheckedChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;
		}

		private void checkBoxMisInsertCancel_CheckedChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;
		}

		private void checkBoxNoiseDetect_CheckedChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;
			EnableNoise(checkBoxNoiseDetect.Checked);
		}

		private void comboBoxNoiseEject_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;
		}

		private void checkBoxNoiseStamp_CheckedChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;
		}

		private void checkBoxNoiseCancel_CheckedChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;
		}

		private void checkBoxDFDetect_CheckedChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;
			EnableDoubleFeed(checkBoxDFDetect.Checked);
		}

		private void comboBoxDFEject_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;
		}

		private void checkBoxDFStamp_CheckedChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;
		}

		private void checkBoxDFCancel_CheckedChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;
		}
		private void checkBoxBadDetect_CheckedChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;
			EnableBaddata(checkBoxBadDetect.Checked);
		}

		private void comboBoxBadEject_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;
		}

		private void checkBoxBadStamp_CheckedChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;
		}

		private void checkBoxBadCancel_CheckedChanged(object sender, System.EventArgs e)
		{	buttonApply.Enabled = true;
		
		}

		private void checkBoxNoDetect_CheckedChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;
			EnableNodata(checkBoxNoDetect.Checked);
		}

		private void comboBoxNoEject_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;
		}

		private void checkBoxNoStamp_CheckedChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;
		}

		private void checkBoxNoCancel_CheckedChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;
		}

		// Condition of the control of MisInsett it changes
		private void EnableMisInsert(bool bEnable)
		{
			comboBoxMisInsertEject.Enabled = bEnable;
			checkBoxMisInsertStamp.Enabled = bEnable;
			checkBoxMisInsertCancel.Enabled = bEnable;
		}

		// Condition of the control of Noise it changes
		private void EnableNoise(bool bEnable)
		{
			comboBoxNoiseEject.Enabled = bEnable;
			checkBoxNoiseStamp.Enabled = bEnable;
			checkBoxNoiseCancel.Enabled = bEnable;
		}

		// Condition of the control of DoubleFeed it changes
		private void EnableDoubleFeed(bool bEnable)
		{
			comboBoxDFEject.Enabled = bEnable;
			checkBoxDFStamp.Enabled = bEnable;
			checkBoxDFCancel.Enabled = bEnable;
		}
		
		// Condition of the control of Baddata it changes
		private void EnableBaddata(bool bEnable)
		{
			comboBoxBadEject.Enabled = bEnable;
			checkBoxBadStamp.Enabled = bEnable;
			checkBoxBadCancel.Enabled = bEnable;
			textBoxBadCount.Enabled = bEnable;
		}

		// Condition of the control of Nodata it changes
		private void EnableNodata(bool bEnable)
		{
			comboBoxNoEject.Enabled = bEnable;
			checkBoxNoStamp.Enabled = bEnable;
			checkBoxNoCancel.Enabled = bEnable;
		}

		private void checkBoxElecEndorseImage_CheckedChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;
		}

		private void RunEnable(bool bCheck)
		{
			checkBoxRunScnToResult.Enabled = bCheck;
			NoCallEnable(checkBoxRunScnToResult.Checked);
			if(!bCheck)
			{
				NoCallEnable(bCheck);
			}
		}

		private void NoCallEnable(bool bCheck)
		{
			checkBoxNoCallScnToResult.Enabled = bCheck;
			buttonSettingValues.Enabled = checkBoxNoCallScnToResult.Checked;
			if(!bCheck)
			{
				buttonSettingValues.Enabled = bCheck;
			}
		}

		private void checkBoxRunScnToResult_CheckedChanged(object sender, System.EventArgs e)
		{
			NoCallEnable(checkBoxRunScnToResult.Checked);

			buttonApply.Enabled = true;
		}

		private void checkBoxNoCallScnToResult_CheckedChanged(object sender, System.EventArgs e)
		{
			buttonSettingValues.Enabled = checkBoxNoCallScnToResult.Checked;

			buttonApply.Enabled = true;
		}

		private void buttonSettingValues_Click(object sender, System.EventArgs e)
		{
			ConfirmationForm pDlg = new ConfirmationForm();
			pDlg.SetProc(config, "");
			pDlg.ShowDialog();
			config = pDlg.GetProc();	
			buttonApply.Enabled = true;
		}

		private void textBoxBadCount_TextChanged(object sender, System.EventArgs e)
		{
			buttonApply.Enabled = true;
		}
	}
}
