using System;


namespace TMS1000Sample
{

	/// <summary>
	/// explanation of the outline of Properties
	/// </summary>
	public class Properties
	{
		public const string SCAN_FUNC = "Scan Function";
		public const string ELEC_ENDORSE_TEXT = "Electronic Endorse Text";
		public const string ELEC_ENDORSE_IMAGE = "Electronic Endorse Image";
		public const string MIS_INSERT_DETECT = "PaperMisInsertionErrorDetect";
		public const string MIS_INSERT_EJECT = "PaperMisInsertionErrorEject";
		public const string MIS_INSERT_STAMP = "PaperMisInsertionStamp";
		public const string MIS_INSERT_CANCEL = "PaperMisInsertionCancel";
		public const string NOISE_DETECT = "NoiseErrorDetect";
		public const string NOISE_EJECT = "NoiseErrorEject";
		public const string NOISE_STAMP = "NoiseStamp";
		public const string NOISE_CANCEL = "NoiseCancel";
		public const string DOUBLE_FEED_DETECT = "DoubleFeedErrorDetect";
		public const string DOUBLE_FEED_EJECT = "DoubleFeedErrorEject";
		public const string DOUBLE_FEED_STAMP = "DoubleFeedStamp";
		public const string DOUBLE_FEED_CANCEL = "DoubleFeedCancel";
		public const string NODATA_DETECT = "NodataErrorDetect";
		public const string NODATA_EJECT = "NodataErrorEject";
		public const string NODATA_STAMP = "NodataStamp";
		public const string NODATA_CANCEL = "NodataCancel";
		public const string BADDATA_COUNT = "BaddataCount";
		public const string BADDATA_DETECT = "BaddataErrorDetect";
		public const string BADDATA_EJECT = "BaddataErrorEject";
		public const string BADDATA_STAMP = "BaddataStamp";
		public const string BADDATA_CANCEL = "BaddataCancel";
		public const string CONFIRMATION = "Confirmation Mode";
		public const string RUN_SCN_TO_RESULT = "run ScnToReslut";
		public const string NO_CALL_SCN_TO_RESULT = "No call ScnToReslut";
		public const string SETTINGS_VALUS = "Settings m_Values";
		public const string CONF_EJECT = "Confirmation Eject";
		public const string CONF_STAMP = "Confirmation Stamp";
		public const string CONF_NEXT_CHECK = "Confirmation NextCheck";
		public const string CONF_OK = "Confirmation OK";

		protected System.Collections.Hashtable m_Values;

		public Properties()
		{
			// 
			// TODO: Add the constructor logic here
			//
			m_Values = new System.Collections.Hashtable();
			m_Values.Add(SCAN_FUNC, 0);
			m_Values.Add(ELEC_ENDORSE_TEXT, false);
			m_Values.Add(ELEC_ENDORSE_IMAGE, false);

			m_Values.Add(CONFIRMATION, false);
			m_Values.Add(RUN_SCN_TO_RESULT, false);
			m_Values.Add(NO_CALL_SCN_TO_RESULT, false);
			m_Values.Add(SETTINGS_VALUS, false);

			m_Values.Add(MIS_INSERT_DETECT, true);
			m_Values.Add(MIS_INSERT_EJECT, 0);
			m_Values.Add(MIS_INSERT_STAMP, false);
			m_Values.Add(MIS_INSERT_CANCEL, false);

			m_Values.Add(NOISE_DETECT, true);
			m_Values.Add(NOISE_EJECT, 0);
			m_Values.Add(NOISE_STAMP, false);
			m_Values.Add(NOISE_CANCEL, true);

			m_Values.Add(DOUBLE_FEED_DETECT, true);
			m_Values.Add(DOUBLE_FEED_EJECT, 0);
			m_Values.Add(DOUBLE_FEED_STAMP, false);
			m_Values.Add(DOUBLE_FEED_CANCEL, false);

			m_Values.Add(BADDATA_COUNT, 255);
			m_Values.Add(BADDATA_DETECT, true);
			m_Values.Add(BADDATA_EJECT, 0);
			m_Values.Add(BADDATA_STAMP, false);
			m_Values.Add(BADDATA_CANCEL, false);

			m_Values.Add(NODATA_DETECT, true);
			m_Values.Add(NODATA_EJECT, 0);
			m_Values.Add(NODATA_STAMP, false);
			m_Values.Add(NODATA_CANCEL, false);
		}

		public Properties(Properties Proc)
		{
			m_Values = Proc.m_Values;
		}

		// This method is settings value
		public void SetValue(string strName, object oValue)
		{
			if(m_Values.Contains(strName))
			{
				// If strName exists renewal the value
				m_Values[strName] = oValue;
			}
			else
			{
				// If strName does not exist it adds it
				m_Values.Add(strName, oValue);
			}
		}

		// This method is return value
		public int GetValue(string strName)
		{
			if(m_Values.Contains(strName))
			{
				// If strName exists return to value
				return Convert.ToInt32(m_Values[strName]);
			}
			// If strName does not exist return to 0
			return 0;
		}

		// This method is return value 
		public bool GetValueBool(string strName)
		{
			// Change the values to boolean
			return Convert.ToBoolean(GetValue(strName));
		}
	}
}
