using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace TMS1000Sample
{
	/// <summary>
	/// explanation of the outline of TMS1000SampleForm
	/// </summary>
	public class TMS1000SampleForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button buttonScan;
		private System.Windows.Forms.Button buttonExit;
		/// <summary>
		/// necessary designer variable
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox textBoxMICR;
		private System.Windows.Forms.PictureBox pictureBoxFront;
		private System.Windows.Forms.PictureBox pictureBoxBack;
		private System.Windows.Forms.Button buttonConfigure;
		private System.Windows.Forms.Button btnCancel;

		protected Properties m_objConfig = null;
		protected ApiUsage m_objApi = null;
		protected int m_iStartTransactionNumber = 0;
		protected DateTime m_dtStartTime;

		public TMS1000SampleForm()
		{
			//
			// Required by the Windows Form Designer
			//
			InitializeComponent();

			//
			// TODO: InitializeComponent
			//
			m_objConfig = new Properties();
			m_objApi = new ApiUsage();
			m_objApi.MainFormItem(this);
			m_objApi.Configure(m_objConfig);
		}

		/// <summary>
		/// Postprocessing is run to the resource that is used
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
				// end process
				m_objApi.Close();
			}
			base.Dispose( disposing );
		}

		#region Create code by Windwos Form Designer 
		/// <summary>
		/// The following procedure is required by the Windows Form Designer
		/// It can be modified using the Windows Form Designer.
		/// Do not modify it using the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(TMS1000SampleForm));
			this.buttonScan = new System.Windows.Forms.Button();
			this.buttonExit = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.textBoxMICR = new System.Windows.Forms.TextBox();
			this.pictureBoxFront = new System.Windows.Forms.PictureBox();
			this.pictureBoxBack = new System.Windows.Forms.PictureBox();
			this.buttonConfigure = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// buttonScan
			// 
			this.buttonScan.Location = new System.Drawing.Point(152, 488);
			this.buttonScan.Name = "buttonScan";
			this.buttonScan.TabIndex = 1;
			this.buttonScan.Text = "Scan";
			this.buttonScan.Click += new System.EventHandler(this.buttonScan_Click);
			// 
			// buttonExit
			// 
			this.buttonExit.Location = new System.Drawing.Point(376, 488);
			this.buttonExit.Name = "buttonExit";
			this.buttonExit.TabIndex = 3;
			this.buttonExit.Text = "Exit";
			this.buttonExit.Click += new System.EventHandler(this.buttonExit_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(64, 16);
			this.label1.TabIndex = 2;
			this.label1.Text = "MICR data";
			// 
			// textBoxMICR
			// 
			this.textBoxMICR.AutoSize = false;
			this.textBoxMICR.Location = new System.Drawing.Point(88, 8);
			this.textBoxMICR.Name = "textBoxMICR";
			this.textBoxMICR.ReadOnly = true;
			this.textBoxMICR.Size = new System.Drawing.Size(384, 24);
			this.textBoxMICR.TabIndex = 4;
			this.textBoxMICR.TabStop = false;
			this.textBoxMICR.Text = "";
			// 
			// pictureBoxFront
			// 
			this.pictureBoxFront.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pictureBoxFront.Location = new System.Drawing.Point(8, 40);
			this.pictureBoxFront.Name = "pictureBoxFront";
			this.pictureBoxFront.Size = new System.Drawing.Size(464, 216);
			this.pictureBoxFront.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.pictureBoxFront.TabIndex = 4;
			this.pictureBoxFront.TabStop = false;
			// 
			// pictureBoxBack
			// 
			this.pictureBoxBack.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pictureBoxBack.Location = new System.Drawing.Point(8, 264);
			this.pictureBoxBack.Name = "pictureBoxBack";
			this.pictureBoxBack.Size = new System.Drawing.Size(464, 216);
			this.pictureBoxBack.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.pictureBoxBack.TabIndex = 4;
			this.pictureBoxBack.TabStop = false;
			// 
			// buttonConfigure
			// 
			this.buttonConfigure.Location = new System.Drawing.Point(32, 488);
			this.buttonConfigure.Name = "buttonConfigure";
			this.buttonConfigure.TabIndex = 0;
			this.buttonConfigure.Text = "Configure";
			this.buttonConfigure.Click += new System.EventHandler(this.buttonConfigure_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.Location = new System.Drawing.Point(272, 488);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 2;
			this.btnCancel.Text = "Cancel";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// TMS1000SampleForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(480, 518);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.buttonConfigure);
			this.Controls.Add(this.pictureBoxFront);
			this.Controls.Add(this.textBoxMICR);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.buttonExit);
			this.Controls.Add(this.buttonScan);
			this.Controls.Add(this.pictureBoxBack);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "TMS1000SampleForm";
			this.Text = "TM-S1000SampleStep5";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// main entry point of application
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new TMS1000SampleForm());
		}

		// This method is called when the user clicks the scan button
		private void buttonScan_Click(object sender, System.EventArgs e)
		{
			textBoxMICR.Text = "";
			if(pictureBoxFront.Image != null)
			{
				pictureBoxFront.Image.Dispose();
			}
			if(pictureBoxBack.Image != null)
			{
				pictureBoxBack.Image.Dispose();
			}
			pictureBoxFront.Image = null;
			pictureBoxBack.Image = null;
			this.Text = "TM-S1000SampleStep5";

			buttonScan.Enabled = false;
			buttonConfigure.Enabled = false;
			m_iStartTransactionNumber = m_objApi.GetTransactionNumber();
			m_dtStartTime = DateTime.Now;
			m_objApi.Scan();
		}

		// This delegate enables asynchronous calls for setting.
		delegate void ComplateCallback(int transactionNumber);

		// This method is called when the Complete scan
		public void Complate(int transactionNumber)
		{
			if(this.InvokeRequired)
			{
				ComplateCallback c = new ComplateCallback(Complate);
				this.Invoke(c, new object [] { transactionNumber });
			}
			else
			{
				// Calculation as a result of measuring
				TimeSpan spanTime = DateTime.Now - m_dtStartTime;
				spanTime = spanTime - m_objApi.GetStartWaitTime();
				long lScanCount = transactionNumber - m_iStartTransactionNumber + 1;
				double dRate = (double)lScanCount / spanTime.TotalMinutes;
				this.Text = "TM-S1000SampleStep5 Scan Complete(" + lScanCount.ToString() + " @ " + dRate.ToString("G4") + " DPM )";
				buttonScan.Enabled = true;
				buttonConfigure.Enabled = true;
			}
		}

		// This method is called when the user clicks the Exit button
		private void buttonExit_Click(object sender, System.EventArgs e)
		{
			m_objApi.Close();
			Close();
		}
		// this method is display MICR data
		public void SetMicr(string strMicr)
		{
			textBoxMICR.Text = strMicr;
		}

		// this method is display front image
		public void SetFrontImage(System.Drawing.Image FrontImage)
		{
			if(pictureBoxFront.Image != null)
			{
				pictureBoxFront.Image.Dispose();
			}
			pictureBoxFront.Image = FrontImage;
		}

		// this method is display back image
		public void SetBackImage(System.Drawing.Image BackImage)
		{
			if(pictureBoxBack.Image != null)
			{
				pictureBoxBack.Image.Dispose();
			}
			pictureBoxBack.Image = BackImage;
		}

		// this method is called when the user click the Configure button
		private void buttonConfigure_Click(object sender, System.EventArgs e)
		{
			ConfigureForm pDlg = new ConfigureForm();
			pDlg.SetProc(m_objConfig);
			pDlg.ShowDialog();
			m_objConfig = pDlg.GetProc();
			m_objApi.Configure(m_objConfig);
		}

		// this method is called when the confirmation mode
		public bool Confirmation()
		{
			ConfirmationForm pDlg = new ConfirmationForm();
			pDlg.SetProc(m_objConfig, m_objApi.GetErrorOccured());
			pDlg.ShowDialog();
			m_objConfig = pDlg.GetProc();
			m_objApi.SetProc(m_objConfig);
			return m_objConfig.GetValueBool(Properties.CONF_OK);
		}

		// This method is called when the user clicks the Cancel button
		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			m_objApi.CancelScan();
		}
	}
}
