using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using com.epson.bank.driver;

namespace TMS1000Sample
{
	/// <summary>
	/// explanation of the outline of TMS1000SampleForm
	/// </summary>
	public class TMS1000SampleForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button buttonScan;
		private System.Windows.Forms.Button buttonExit;
		/// <summary>
		/// necessary designer variable
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox textBoxMICR;
		private System.Windows.Forms.TextBox textBoxOCR;
		private System.Windows.Forms.PictureBox pictureBoxFront;
		private System.Windows.Forms.PictureBox pictureBoxBack;
		private System.Windows.Forms.Button buttonConfigure;
		private System.Windows.Forms.Button buttonDeviceStatus;
		private System.Windows.Forms.Button buttonStopBuzzer;
		private System.Windows.Forms.Button buttonCleaning;
		private System.Windows.Forms.Button btnCancel;

		private Properties m_objConfig = null;
		private ApiUsage m_objApi = null;
		private int m_iStartTransactionNumber = 0;
		private DateTime m_dtStartTime;
		private DeviceStatusForm m_objDeviceStatusF = null;
		private IqaResultForm m_objIqaResultF = null;
		private System.Windows.Forms.Button buttonIqa;
		public bool m_bDeviceStatus = false;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox textBoxBarcodeBack;
		private System.Windows.Forms.TextBox textBoxBarcodeFront;
		public bool m_bIqaResult = false;

		public TMS1000SampleForm()
		{
			//
			// Required by the Windows Form Designer
			//
			InitializeComponent();

			//
			// TODO: InitializeComponent
			//
			m_objConfig = new Properties();
			m_objApi = new ApiUsage();
			m_objApi.MainFormItem(this);
			m_objApi.Configure(m_objConfig);
		}

		/// <summary>
		/// Postprocessing is run to the resource that is used
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
				// end process
				m_objApi.Close();
			}
			base.Dispose( disposing );
		}

		#region Create code by Windwos Form Designer 
		/// <summary>
		/// The following procedure is required by the Windows Form Designer
		/// It can be modified using the Windows Form Designer.
		/// Do not modify it using the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(TMS1000SampleForm));
			this.buttonScan = new System.Windows.Forms.Button();
			this.buttonExit = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.textBoxMICR = new System.Windows.Forms.TextBox();
			this.textBoxOCR = new System.Windows.Forms.TextBox();
			this.pictureBoxFront = new System.Windows.Forms.PictureBox();
			this.pictureBoxBack = new System.Windows.Forms.PictureBox();
			this.buttonConfigure = new System.Windows.Forms.Button();
			this.buttonDeviceStatus = new System.Windows.Forms.Button();
			this.buttonStopBuzzer = new System.Windows.Forms.Button();
			this.buttonCleaning = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.buttonIqa = new System.Windows.Forms.Button();
			this.textBoxBarcodeBack = new System.Windows.Forms.TextBox();
			this.textBoxBarcodeFront = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// buttonScan
			// 
			this.buttonScan.Location = new System.Drawing.Point(120, 512);
			this.buttonScan.Name = "buttonScan";
			this.buttonScan.TabIndex = 1;
			this.buttonScan.Text = "Scan";
			this.buttonScan.Click += new System.EventHandler(this.buttonScan_Click);
			// 
			// buttonExit
			// 
			this.buttonExit.Location = new System.Drawing.Point(400, 512);
			this.buttonExit.Name = "buttonExit";
			this.buttonExit.Size = new System.Drawing.Size(88, 23);
			this.buttonExit.TabIndex = 3;
			this.buttonExit.Text = "Exit";
			this.buttonExit.Click += new System.EventHandler(this.buttonExit_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(64, 16);
			this.label1.TabIndex = 2;
			this.label1.Text = "MICR data";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 40);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(56, 16);
			this.label2.TabIndex = 2;
			this.label2.Text = "OCR data";
			// 
			// textBoxMICR
			// 
			this.textBoxMICR.AutoSize = false;
			this.textBoxMICR.Location = new System.Drawing.Point(88, 8);
			this.textBoxMICR.Name = "textBoxMICR";
			this.textBoxMICR.ReadOnly = true;
			this.textBoxMICR.Size = new System.Drawing.Size(400, 24);
			this.textBoxMICR.TabIndex = 7;
			this.textBoxMICR.TabStop = false;
			this.textBoxMICR.Text = "";
			// 
			// textBoxOCR
			// 
			this.textBoxOCR.AutoSize = false;
			this.textBoxOCR.Location = new System.Drawing.Point(88, 32);
			this.textBoxOCR.Name = "textBoxOCR";
			this.textBoxOCR.ReadOnly = true;
			this.textBoxOCR.Size = new System.Drawing.Size(400, 24);
			this.textBoxOCR.TabIndex = 8;
			this.textBoxOCR.TabStop = false;
			this.textBoxOCR.Text = "";
			// 
			// pictureBoxFront
			// 
			this.pictureBoxFront.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pictureBoxFront.Location = new System.Drawing.Point(8, 112);
			this.pictureBoxFront.Name = "pictureBoxFront";
			this.pictureBoxFront.Size = new System.Drawing.Size(480, 192);
			this.pictureBoxFront.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.pictureBoxFront.TabIndex = 4;
			this.pictureBoxFront.TabStop = false;
			// 
			// pictureBoxBack
			// 
			this.pictureBoxBack.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pictureBoxBack.Location = new System.Drawing.Point(8, 312);
			this.pictureBoxBack.Name = "pictureBoxBack";
			this.pictureBoxBack.Size = new System.Drawing.Size(480, 192);
			this.pictureBoxBack.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.pictureBoxBack.TabIndex = 4;
			this.pictureBoxBack.TabStop = false;
			// 
			// buttonConfigure
			// 
			this.buttonConfigure.Location = new System.Drawing.Point(16, 512);
			this.buttonConfigure.Name = "buttonConfigure";
			this.buttonConfigure.Size = new System.Drawing.Size(80, 23);
			this.buttonConfigure.TabIndex = 0;
			this.buttonConfigure.Text = "Configure";
			this.buttonConfigure.Click += new System.EventHandler(this.buttonConfigure_Click);
			// 
			// buttonDeviceStatus
			// 
			this.buttonDeviceStatus.Location = new System.Drawing.Point(400, 536);
			this.buttonDeviceStatus.Name = "buttonDeviceStatus";
			this.buttonDeviceStatus.Size = new System.Drawing.Size(88, 23);
			this.buttonDeviceStatus.TabIndex = 6;
			this.buttonDeviceStatus.Text = "DeviceStatus";
			this.buttonDeviceStatus.Click += new System.EventHandler(this.buttonDeviceStatus_Click);
			// 
			// buttonStopBuzzer
			// 
			this.buttonStopBuzzer.Location = new System.Drawing.Point(16, 536);
			this.buttonStopBuzzer.Name = "buttonStopBuzzer";
			this.buttonStopBuzzer.Size = new System.Drawing.Size(80, 23);
			this.buttonStopBuzzer.TabIndex = 4;
			this.buttonStopBuzzer.Text = "Stop Buzzer";
			this.buttonStopBuzzer.Click += new System.EventHandler(this.buttonStopBuzzer_Click);
			// 
			// buttonCleaning
			// 
			this.buttonCleaning.Location = new System.Drawing.Point(176, 536);
			this.buttonCleaning.Name = "buttonCleaning";
			this.buttonCleaning.Size = new System.Drawing.Size(72, 23);
			this.buttonCleaning.TabIndex = 5;
			this.buttonCleaning.Text = "Cleaning";
			this.buttonCleaning.Click += new System.EventHandler(this.buttonCleaning_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.Location = new System.Drawing.Point(224, 512);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 2;
			this.btnCancel.Text = "Cancel";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// buttonIqa
			// 
			this.buttonIqa.Location = new System.Drawing.Point(312, 536);
			this.buttonIqa.Name = "buttonIqa";
			this.buttonIqa.Size = new System.Drawing.Size(88, 23);
			this.buttonIqa.TabIndex = 6;
			this.buttonIqa.Text = "IQA Result";
			this.buttonIqa.Click += new System.EventHandler(this.buttonIqa_Click);
			// 
			// textBoxBarcodeBack
			// 
			this.textBoxBarcodeBack.AutoSize = false;
			this.textBoxBarcodeBack.Location = new System.Drawing.Point(88, 80);
			this.textBoxBarcodeBack.Name = "textBoxBarcodeBack";
			this.textBoxBarcodeBack.ReadOnly = true;
			this.textBoxBarcodeBack.Size = new System.Drawing.Size(400, 24);
			this.textBoxBarcodeBack.TabIndex = 8;
			this.textBoxBarcodeBack.TabStop = false;
			this.textBoxBarcodeBack.Text = "";
			// 
			// textBoxBarcodeFront
			// 
			this.textBoxBarcodeFront.AutoSize = false;
			this.textBoxBarcodeFront.Location = new System.Drawing.Point(88, 56);
			this.textBoxBarcodeFront.Name = "textBoxBarcodeFront";
			this.textBoxBarcodeFront.ReadOnly = true;
			this.textBoxBarcodeFront.Size = new System.Drawing.Size(400, 24);
			this.textBoxBarcodeFront.TabIndex = 7;
			this.textBoxBarcodeFront.TabStop = false;
			this.textBoxBarcodeFront.Text = "";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 88);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(80, 16);
			this.label3.TabIndex = 2;
			this.label3.Text = "Barcode back";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 64);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(80, 16);
			this.label4.TabIndex = 2;
			this.label4.Text = "Barcode front";
			// 
			// TMS1000SampleForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(498, 568);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.buttonCleaning);
			this.Controls.Add(this.buttonStopBuzzer);
			this.Controls.Add(this.buttonDeviceStatus);
			this.Controls.Add(this.buttonConfigure);
			this.Controls.Add(this.pictureBoxFront);
			this.Controls.Add(this.textBoxMICR);
			this.Controls.Add(this.textBoxOCR);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.buttonExit);
			this.Controls.Add(this.buttonScan);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.pictureBoxBack);
			this.Controls.Add(this.buttonIqa);
			this.Controls.Add(this.textBoxBarcodeBack);
			this.Controls.Add(this.textBoxBarcodeFront);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label4);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "TMS1000SampleForm";
			this.Text = "TM-S1000SampleStep8";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// main entry point of application
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new TMS1000SampleForm());
		}

		// This method is called when the user clicks the scan button
		private void buttonScan_Click(object sender, System.EventArgs e)
		{
			textBoxMICR.Text = "";
			textBoxOCR.Text = "";
			if(pictureBoxFront.Image != null)
			{
				pictureBoxFront.Image.Dispose();
			}
			if(pictureBoxBack.Image != null)
			{
				pictureBoxBack.Image.Dispose();
			}
			pictureBoxFront.Image = null;
			pictureBoxBack.Image = null;
			this.Text = "TM-S1000SampleStep8";

			buttonScan.Enabled = false;
			buttonConfigure.Enabled = false;
			buttonCleaning.Enabled = false;
			m_iStartTransactionNumber = m_objApi.GetTransactionNumber();
			m_dtStartTime = DateTime.Now;
			m_objApi.Scan();
		}

		// This delegate enables asynchronous calls for setting.
		delegate void ComplateCallback(int transactionNumber);

		// This method is called when the Complete scan
		public void Complate(int transactionNumber)
		{
			if(this.InvokeRequired)
			{
				ComplateCallback c = new ComplateCallback(Complate);
				this.Invoke(c, new object [] { transactionNumber });
			}
			else
			{
				// Calculation as a result of measuring
				TimeSpan spanTime = DateTime.Now - m_dtStartTime;
				spanTime = spanTime - m_objApi.GetStartWaitTime();
				long lScanCount = transactionNumber - m_iStartTransactionNumber + 1;
				double dRate = (double)lScanCount / spanTime.TotalMinutes;
				this.Text = "TM-S1000SampleStep8 Scan Complete(" + lScanCount.ToString() + " @ " + dRate.ToString("G4") + " DPM )";
				buttonScan.Enabled = true;
				buttonConfigure.Enabled = true;
				buttonCleaning.Enabled = true;
			}
		}

		// This method is called when the user clicks the Exit button
		private void buttonExit_Click(object sender, System.EventArgs e)
		{
			m_objApi.Close();
			Close();
		}
		// this method is display MICR data
		public void SetMicr(string strMicr)
		{
			textBoxMICR.Text = strMicr;
		}

		// this method is display OCR data
		public void SetOcr(string strOcr)
		{
			textBoxOCR.Text = strOcr;
		}

		// this method is display front image
		public void SetFrontImage(System.Drawing.Image FrontImage)
		{
			if(pictureBoxFront.Image != null)
			{
				pictureBoxFront.Image.Dispose();
			}
			pictureBoxFront.Image = FrontImage;
		}

		// this method is display back image
		public void SetBackImage(System.Drawing.Image BackImage)
		{
			if(pictureBoxBack.Image != null)
			{
				pictureBoxBack.Image.Dispose();
			}
			pictureBoxBack.Image = BackImage;

		}

		// this method is called when the user click the Configure button
		private void buttonConfigure_Click(object sender, System.EventArgs e)
		{
			ConfigureForm pDlg = new ConfigureForm();
			pDlg.SetProc(m_objConfig);
			pDlg.ShowDialog();
			m_objConfig = pDlg.GetProc();
			m_objApi.Configure(m_objConfig);
		}

		// this method is called when the confirmation mode
		public bool Confirmation()
		{
			ConfirmationForm pDlg = new ConfirmationForm();
			pDlg.SetProc(m_objConfig, m_objApi.GetErrorOccured());
			pDlg.ShowDialog();
			m_objConfig = pDlg.GetProc();
			m_objApi.SetProc(m_objConfig);
			return m_objConfig.GetValueBool(Properties.CONF_OK);
		}

		// Set status to DeviceStatus Form
		public void SetDeviceStatus(ASB Status)
		{
			// If DeviceStatusForm is display, set status
			if(m_bDeviceStatus)
			{
				m_objDeviceStatusF.SetDeviceStatus(Status);
			}
		}

		// DeviceStatus Form is display
		private void buttonDeviceStatus_Click(object sender, System.EventArgs e)
		{
			// If it is DeviceStatusFrom displayed it does not indicate it
			if(!m_bDeviceStatus)
			{
				m_bDeviceStatus = true;
				m_objDeviceStatusF = new DeviceStatusForm();
				m_objDeviceStatusF.SetMainForm(this);
				m_objDeviceStatusF.SetDeviceStatus(m_objApi.GetStatus());
				m_objDeviceStatusF.Show();
			}
			m_objDeviceStatusF.Activate();
		}

		// this method is called when the user click the Stop Buzzer button
		private void buttonStopBuzzer_Click(object sender, System.EventArgs e)
		{
			m_objApi.StopBuzzer();
		}

		// this method is called when the user click the Cleaning button
		private void buttonCleaning_Click(object sender, System.EventArgs e)
		{
			m_objApi.Cleaning();
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			m_objApi.CancelScan();
		}

		// IqaResult Form is display
		private void buttonIqa_Click(object sender, System.EventArgs e)
		{
			// If it is IqaResultForm displayed it does not indicate it
			if(!m_bIqaResult)
			{
				m_bIqaResult = true;
				m_objIqaResultF = new IqaResultForm();
				m_objIqaResultF.SetMainForm(this);
				m_objIqaResultF.Show();
			}
			m_objIqaResultF.Activate();
		}
		public void SetIqaResult(MFIqaResult mfIqaResult)
		{
			if(m_objIqaResultF != null)
			{
				m_objIqaResultF.SetIqaResult(mfIqaResult);
			}
		}
		public void SetBarcodeFront(string strBarcode)
		{
			textBoxBarcodeFront.Text = strBarcode;
		}
		public void SetBarcodeBack(string strBarcode)
		{
			textBoxBarcodeBack.Text = strBarcode;
		}
	}
}
