#pragma once
#include "MultiFunction.h"
#include "EpsStmApiInterface.h"

// CAPIUsage

class CAPIUsage : public CWnd
{
	DECLARE_DYNAMIC(CAPIUsage)

public:
	CAPIUsage();
	virtual ~CAPIUsage();

	void Scan();
	void Configure();
	void ScanStatus(DWORD dwTransactionNumber, WORD wMainStatus, WORD wSubStatus, LPSTR pPortName);
	void CancelScan();
	void End();
	DWORD GetTransactonNumber();
	DWORD GetStartWaitTime();

protected:
	DECLARE_MESSAGE_MAP()

private:
	HANDLE			m_hScanEvent;		// Event handle to scan
	HANDLE			m_hCancelHandle;	// Event handle to cancel
	int				m_iHandle;			// Number of Handle
	MF_BASE01		m_tBase01;			// MF_BASE struct
	MF_SCAN			m_tScanFront;		// MF_SCAN struct
	MF_SCAN			m_tScanBack;		// MF_SCAN struct
	MF_MICR			m_tMicr;			// MF_MICR struct
	MF_PRINT01		m_tPrint01;			// MF_PRINT struct
	MF_PROCESS		m_tProcess;			// MF_PROCESS struct


	HINSTANCE m_hLibrary;

	DLL_BiOpenMonPrinter				BiOpenMonPrinter;
	DLL_BiSetMonInterval				BiSetMonInterval;
	DLL_BiGetStatus						BiGetStatus;
	DLL_BiSetStatusBackFunction			BiSetStatusBackFunction;
	DLL_BiSetStatusBackWnd				BiSetStatusBackWnd;
	DLL_BiCancelStatusBack				BiCancelStatusBack;
	DLL_BiResetPrinter					BiResetPrinter;
	DLL_BiGetCounter					BiGetCounter;
	DLL_BiResetCounter					BiResetCounter;
	DLL_BiCancelError					BiCancelError;
	DLL_BiGetType						BiGetType;
	DLL_BiGetOfflineCode				BiGetOfflineCode;
	DLL_BiGetOfflineCodeByIndex			BiGetOfflineCodeByIndex;
	DLL_BiMICRSelectDataHandling		BiMICRSelectDataHandling;
	DLL_BiMICRGetStatus					BiMICRGetStatus;
	DLL_BiMICRCleaning					BiMICRCleaning;
	DLL_BiSCNSetImageQuality			BiSCNSetImageQuality;
	DLL_BiSCNSetImageFormat				BiSCNSetImageFormat;
	DLL_BiSCNSetScanArea				BiSCNSetScanArea;
	DLL_BiSCNGetImageQuality			BiSCNGetImageQuality;
	DLL_BiSCNGetImageFormat				BiSCNGetImageFormat;
	DLL_BiSCNGetScanArea				BiSCNGetScanArea;
	DLL_BiSCNSetCroppingArea			BiSCNSetCroppingArea;
	DLL_BiSCNGetCroppingArea			BiSCNGetCroppingArea;
	DLL_BiSCNDeleteCroppingArea			BiSCNDeleteCroppingArea;
	DLL_BiSCNSelectScanUnit				BiSCNSelectScanUnit;
	DLL_BiSCNMICRFunction				BiSCNMICRFunction;
	DLL_BiSCNMICRCancelFunction			BiSCNMICRCancelFunction;
	DLL_BiSCNSelectScanFace				BiSCNSelectScanFace;
	DLL_BiGetPrnCapability				BiGetPrnCapability;
	DLL_BiCloseMonPrinter				BiCloseMonPrinter;
	DLL_BiGetRealStatus					BiGetRealStatus;
	DLL_BiSetStatusBackFunctionEx		BiSetStatusBackFunctionEx;
	DLL_BiSCNMICRFunctionContinuously	BiSCNMICRFunctionContinuously;
	DLL_BiSCNMICRFunctionPostPrint		BiSCNMICRFunctionPostPrint;
	DLL_BiSCNMICRSetStatusBackFunction	BiSCNMICRSetStatusBackFunction;
	DLL_BiSCNMICRSetStatusBackWnd		BiSCNMICRSetStatusBackWnd;
	DLL_BiSCNMICRCancelStatusBack		BiSCNMICRCancelStatusBack;
	DLL_BiGetMicrText					BiGetMicrText;
	DLL_BiGetScanImage					BiGetScanImage;
	DLL_BiGetTransactionNumber			BiGetTransactionNumber;
	DLL_BiSetTransactionNumber			BiSetTransactionNumber;
	DLL_BiGetPrintStation				BiGetPrintStation;
	DLL_BiSetPrintStation				BiSetPrintStation;
	DLL_BiPrintText						BiPrintText;
	DLL_BiPrintImage					BiPrintImage;
	DLL_BiGetPrintSize					BiGetPrintSize;
	DLL_BiSetPrintSize					BiSetPrintSize;
	DLL_BiGetPrintPosition				BiGetPrintPosition;
	DLL_BiSetPrintPosition				BiSetPrintPosition;
	DLL_BiBufferedPrint					BiBufferedPrint;
	DLL_BiSetTransactionNumberWithIncremental	BiSetTransactionNumberWithIncremental;
	DLL_BiSetBehaviorToScnResult		BiSetBehaviorToScnResult;
	DLL_BiRingBuzzer					BiRingBuzzer;

	DLL_BiESCNEnable				BiESCNEnable;
	DLL_BiESCNGetAutoSize			BiESCNGetAutoSize;
	DLL_BiESCNSetAutoSize			BiESCNSetAutoSize;
	DLL_BiESCNGetCutSize			BiESCNGetCutSize;
	DLL_BiESCNSetCutSize			BiESCNSetCutSize;
	DLL_BiESCNGetRotate				BiESCNGetRotate;
	DLL_BiESCNSetRotate				BiESCNSetRotate;
	DLL_BiESCNGetDocumentSize		BiESCNGetDocumentSize;
	DLL_BiESCNSetDocumentSize		BiESCNSetDocumentSize;
	DLL_BiESCNDefineCropArea		BiESCNDefineCropArea;
	DLL_BiESCNGetMaxCropAreas		BiESCNGetMaxCropAreas;
	DLL_BiESCNStoreImage			BiESCNStoreImage;
	DLL_BiESCNRetrieveImage			BiESCNRetrieveImage;
	DLL_BiESCNClearImage			BiESCNClearImage;
	DLL_BiESCNGetRemainingImages	BiESCNGetRemainingImages;

	long InitInstance();
	BOOL MsgWaitForMultipleObjectsInfinite(HANDLE hHandle);

public:
	// Error code to string
	static LPCTSTR GetResultString(int iResultCode) {
		switch(iResultCode) {
			case SUCCESS:
				return _T("SUCCESS");
			case ERR_TYPE:
				return _T("ERR_TYPE");
			case ERR_OPENED:
				return _T("ERR_OPENED");
			case ERR_NO_PRINTER:
				return _T("ERR_NO_PRINTER");
			case ERR_NO_TARGET:
				return _T("ERR_NO_TARGET");
			case ERR_NO_MEMORY:
				return _T("ERR_NO_MEMORY");
			case ERR_HANDLE:
				return _T("ERR_HANDLE");
			case ERR_TIMEOUT:
				return _T("ERR_TIMEOUT");
			case ERR_ACCESS:
				return _T("ERR_ACCESS");
			case ERR_PARAM:
				return _T("ERR_PARAM");
			case ERR_NOT_SUPPORT:
				return _T("ERR_NOT_SUPPORT");
			case ERR_OFFLINE:
				return _T("ERR_OFFLINE");
			case ERR_NOT_EPSON:
				return _T("ERR_NOT_EPSON");
			case ERR_WITHOUT_CB:
				return _T("ERR_WITHOUT_CB");
			case ERR_BUFFER_OVER_FLOW:
				return _T("ERR_BUFFER_OVER_FLOW");
			case ERR_REGISTRY:
				return _T("ERR_REGISTRY");
			case ERR_ENABLE:
				return _T("ERR_ENABLE");
			case ERR_DISK_FULL:
				return _T("ERR_DISK_FULL");
			case ERR_NO_IMAGE:
				return _T("ERR_NO_IMAGE");
			case ERR_ENTRY_OVER:
				return _T("ERR_ENTRY_OVER");
			case ERR_CROPAREAID:
				return _T("ERR_CROPAREAID");
			case ERR_EXIST:
				return _T("ERR_EXIST");
			case ERR_NOT_FOUND:
				return _T("ERR_NOT_FOUND");
			case ERR_IMAGE_FILEOPEN:
				return _T("ERR_IMAGE_FILEOPEN");
			case ERR_IMAGE_UNKNOWNFORMAT:
				return _T("ERR_IMAGE_UNKNOWNFORMAT");
			case ERR_IMAGE_FAILED:
				return _T("ERR_IMAGE_FAILED");
			case ERR_WORKAREA_NO_MEMORY:
				return _T("ERR_WORKAREA_NO_MEMORY");
			case ERR_WORKAREA_UNKNOWNFORMAT:
				return _T("ERR_WORKAREA_UNKNOWNFORMAT");
			case ERR_WORKAREA_FAILED:
				return _T("ERR_WORKAREA_FAILED");
			case ERR_IMAGE_FILEREAD:
				return _T("ERR_IMAGE_FILEREAD");
			case ERR_PAPERINSERT_TIMEOUT:
				return _T("ERR_PAPERINSERT_TIMEOUT");
			case ERR_EXEC_FUNCTION:
				return _T("ERR_EXEC_FUNCTION");
			case ERR_EXEC_MICR:
				return _T("ERR_EXEC_MICR");
			case ERR_EXEC_SCAN:
				return _T("ERR_EXEC_SCAN");
			case ERR_SS_NOT_EXIST:
				return _T("ERR_SS_NOT_EXIST");
			case ERR_SPL_NOT_EXIST:
				return _T("ERR_SPL_NOT_EXIST");
			case ERR_SPL_PAUSED:
				return _T("ERR_SPL_PAUSED");
			case ERR_RESET:
				return _T("ERR_RESET");
			case ERR_THREAD:
				return _T("ERR_THREAD");
			case ERR_ABORT:
				return _T("ERR_ABORT");
			case ERR_MICR:
				return _T("ERR_MICR");
			case ERR_SCAN:
				return _T("ERR_SCAN");
			case ERR_LINE_OVERFLOW:
				return _T("ERR_LINE_OVERFLOW");
			case ERR_NOT_EXEC:
				return _T("ERR_NOT_EXEC");
			case ERR_SIZE:
				return _T("ERR_SIZE");
			case ERR_PAPER_PILED:
				return _T("ERR_PAPER_PILED");
			case ERR_PAPER_JAM:
				return _T("ERR_PAPER_JAM");
			case ERR_COVER_OPEN:
				return _T("ERR_COVER_OPEN");
			case ERR_MICR_NODATA:
				return _T("ERR_MICR_NODATA");
			case ERR_MICR_BADDATA:
				return _T("ERR_MICR_BADDATA");
			case ERR_MICR_PARSE:
				return _T("ERR_MICR_PARSE");
			case ERR_MICR_NOISE:
				return _T("ERR_MICR_NOISE");
			case ERR_SCN_COMPRESS:
				return _T("ERR_SCN_COMPRESS");
			case ERR_PAPER_EXIST:
				return _T("ERR_PAPER_EXIST");
			case ERR_PAPER_INSERT:
				return _T("ERR_PAPER_INSERT");
			case ERR_EXEC_SCAN_CHECK_CONTINUOUS:
				return _T("ERR_EXEC_SCAN_CHECK_CONTINUOUS");
			case ERR_EXEC_SCAN_CHECK_ONEBYONE:
				return _T("ERR_EXEC_SCAN_CHECK_ONEBYONE");
			case ERR_EXEC_SCAN_IDCARD:
				return _T("ERR_EXEC_SCAN_IDCARD");
			case ERR_EXEC_PRINT_ROLLPAPER:
				return _T("ERR_EXEC_PRINT_ROLLPAPER");
			case ERR_EXEC_PRINT_VALIDATION:
				return _T("ERR_EXEC_PRINT_VALIDATION");
		}
		static CString strResult;
		strResult.Format("%d", iResultCode);
		return strResult;
	}
};


