// ConfigureDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TM-S1000Sample.h"
#include "ConfigureDlg.h"
#include ".\configuredlg.h"


// CConfigureDlg Dialog

IMPLEMENT_DYNAMIC(CConfigureDlg, CDialog)
CConfigureDlg::CConfigureDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConfigureDlg::IDD, pParent)
{
}

CConfigureDlg::~CConfigureDlg()
{
	theApp.m_ConfigureDlg = NULL;
	theApp.m_Tab = NULL;
}

void CConfigureDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TAB1, m_tabConfigure);
}


BEGIN_MESSAGE_MAP(CConfigureDlg, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDC_BUTTON_APPLY, OnBnClickedButtonApply)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB1, OnTcnSelchangeTab1)
END_MESSAGE_MAP()


// CConfigureDlg message handlers
BOOL CConfigureDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Image
	TCITEM tcItem1;
	tcItem1.mask = TCIF_TEXT;
	tcItem1.pszText = "Image";
	m_tabConfigure.InsertItem(0, &tcItem1);

	// Endorse
	TCITEM tcItem2;
	tcItem2.mask = TCIF_TEXT;
	tcItem2.pszText = "Endorse";
	m_tabConfigure.InsertItem(1, &tcItem2);

	m_ImageDlg.Create(IDD_IMAGE_DIALOG, &m_tabConfigure);
	m_ImageDlg.SetWindowPos(&wndTop, 5, 23, 0, 0, SWP_NOSIZE | SWP_SHOWWINDOW);

	m_EndorseDlg.Create(IDD_ENDORSE_DIALOG, &m_tabConfigure);
	m_EndorseDlg.SetWindowPos(&wndTop, 5, 23, 0, 0, SWP_NOSIZE | SWP_HIDEWINDOW);

	m_ImageDlg.m_pConfigure = this;
	m_EndorseDlg.m_pConfigure = this;

	m_tabConfigure.SetCurSel(0);

	GetDlgItem(IDC_BUTTON_APPLY)->EnableWindow(FALSE);

	theApp.m_ConfigureDlg = m_hWnd;
	theApp.m_Tab = m_tabConfigure.m_hWnd;

	return TRUE;
}

// This method is called when the user clicks the OK button
void CConfigureDlg::OnBnClickedOk()
{
	OnBnClickedButtonApply();
	OnOK();
}

// This method is called when the user clicks the Cancel button
void CConfigureDlg::OnBnClickedCancel()
{
	OnCancel();
}

// This method is called when the user clicks the Apply button
void CConfigureDlg::OnBnClickedButtonApply()
{
	m_ImageDlg.Apply();
	m_EndorseDlg.Apply();

	GetDlgItem(IDC_BUTTON_APPLY)->EnableWindow(FALSE);
}

// This method is the Apply button effectively
void CConfigureDlg::SetEnableApply()
{
	GetDlgItem(IDC_BUTTON_APPLY)->EnableWindow(TRUE);
}

// This method is called when the user clicks the tab
void CConfigureDlg::OnTcnSelchangeTab1(NMHDR *pNMHDR, LRESULT *pResult)
{
	m_ImageDlg.ShowWindow(SW_HIDE);
	m_EndorseDlg.ShowWindow(SW_HIDE);

	switch(m_tabConfigure.GetCurSel()){
		case 0:
			m_ImageDlg.ShowWindow(SW_SHOW);
			break;
		case 1:
			m_EndorseDlg.ShowWindow(SW_SHOW);
			break;
	}
	*pResult = 0;
}
