// Confirmation.cpp : implementation file
//

#include "stdafx.h"
#include "TM-S1000Sample.h"
#include "TM-S1000SampleDlg.h"
#include "Confirmation.h"
#include ".\confirmation.h"
#include "ConfigureDlg.h"


// CConfirmation Dialog

IMPLEMENT_DYNAMIC(CConfirmation, CDialog)
CConfirmation::CConfirmation(CWnd* pParent /*=NULL*/)
	: CDialog(CConfirmation::IDD, pParent)
{
}

CConfirmation::~CConfirmation()
{
}

void CConfirmation::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CConfirmation, CDialog)
	ON_BN_CLICKED(IDC_CHECK_CONFIRMATION, OnBnClickedCheckConfirmation)
	ON_BN_CLICKED(IDC_CHECK_RUN, OnBnClickedCheckRun)
	ON_BN_CLICKED(IDC_BUTTON_SET_VALUES, OnBnClickedButtonSetValues)
	ON_BN_CLICKED(IDC_CHECK_NO_CALL_SCN_TO_RESULT, OnBnClickedCheckNoCallScnToResult)
END_MESSAGE_MAP()


// CConfirmation message handlers
BOOL CConfirmation::OnInitDialog()
{
	CDialog::OnInitDialog();

	// 
	((CButton*)GetDlgItem(IDC_CHECK_CONFIRMATION))->SetCheck(!theApp.m_Properties.GetValueDefTrue(ACTIVATE_MODE));
	((CButton*)GetDlgItem(IDC_CHECK_RUN))->SetCheck(theApp.m_Properties.GetValueDefFalse(RUN_TO_SCN_RESULT));
	((CButton*)GetDlgItem(IDC_CHECK_NO_CALL_SCN_TO_RESULT))->SetCheck(theApp.m_Properties.GetValueDefFalse(NO_CALL_TO_SCN_RESULT));

	// setting enable
	((CButton*)GetDlgItem(IDC_CHECK_CONFIRMATION))->EnableWindow(TRUE);
	EnableRunToScnResult(((CButton*)GetDlgItem(IDC_CHECK_CONFIRMATION))->GetCheck());
	return TRUE;
}

// This method is called when the user clicks the ConfirmationMode checkbox
void CConfirmation::OnBnClickedCheckConfirmation()
{
	UpdateData(TRUE);

	m_Properties.SetValue(ACTIVATE_MODE, !((CButton*)GetDlgItem(IDC_CHECK_CONFIRMATION))->GetCheck());

	m_pConfigure->SetEnableApply();

	EnableRunToScnResult(((CButton*)GetDlgItem(IDC_CHECK_CONFIRMATION))->GetCheck());
}

// settings enable 'Run BiSetBehaviorToScnResult'
void CConfirmation::EnableRunToScnResult(BOOL bEnable)
{
	((CButton*)GetDlgItem(IDC_CHECK_RUN))->EnableWindow(bEnable);
	EnableCallToScnResult(((CButton*)GetDlgItem(IDC_CHECK_RUN))->GetCheck());
	if(!bEnable){
		EnableCallToScnResult(bEnable);
	}
}

// This method is called when the user clicks the 'Confirmation Mode' check
void CConfirmation::EnableCallToScnResult(BOOL bEnable)
{
	((CButton*)GetDlgItem(IDC_CHECK_NO_CALL_SCN_TO_RESULT))->EnableWindow(bEnable);
	((CButton*)GetDlgItem(IDC_BUTTON_SET_VALUES))->EnableWindow(((CButton*)GetDlgItem(IDC_CHECK_NO_CALL_SCN_TO_RESULT))->GetCheck());
	if(!bEnable){
		((CButton*)GetDlgItem(IDC_BUTTON_SET_VALUES))->EnableWindow(bEnable);
	}
}

// This method is called when the user clicks the Apply button
void CConfirmation::Apply()
{
	theApp.m_Properties.SetProperty(&m_Properties);
}

// This method is called when the user clicks the 'Run BiSetBehaviorToScnResult' check
void CConfirmation::OnBnClickedCheckRun()
{
	UpdateData(TRUE);

	m_Properties.SetValue(RUN_TO_SCN_RESULT, ((CButton*)GetDlgItem(IDC_CHECK_RUN))->GetCheck());

	m_pConfigure->SetEnableApply();

	EnableCallToScnResult(((CButton*)GetDlgItem(IDC_CHECK_RUN))->GetCheck());
}

// This method is called when the user clicks the 'No call BiSetBehaviorToScnResult' check
void CConfirmation::OnBnClickedCheckNoCallScnToResult()
{
	UpdateData(TRUE);

	m_Properties.SetValue(NO_CALL_TO_SCN_RESULT, ((CButton*)GetDlgItem(IDC_CHECK_NO_CALL_SCN_TO_RESULT))->GetCheck());

	m_pConfigure->SetEnableApply();

	((CButton*)GetDlgItem(IDC_BUTTON_SET_VALUES))->EnableWindow(((CButton*)GetDlgItem(IDC_CHECK_NO_CALL_SCN_TO_RESULT))->GetCheck());
}

// This method is called when the user clicks the 'Settings Values' button
void CConfirmation::OnBnClickedButtonSetValues()
{
	((CTMS1000SampleDlg*)theApp.m_pMainWnd)->SetConfirmationMode();

	m_pConfigure->SetEnableApply();
}

