// DoubleFeedDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TM-S1000Sample.h"
#include "DoubleFeedDlg.h"
#include "ConfigureDlg.h"
#include ".\doublefeeddlg.h"


// CDoubleFeedDlg Dialog

IMPLEMENT_DYNAMIC(CDoubleFeedDlg, CDialog)
CDoubleFeedDlg::CDoubleFeedDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDoubleFeedDlg::IDD, pParent)
{
}

CDoubleFeedDlg::~CDoubleFeedDlg()
{
}

void CDoubleFeedDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CDoubleFeedDlg, CDialog)
	ON_BN_CLICKED(IDC_CHECK_DETECT, OnBnClickedCheckDetect)
	ON_CBN_SELCHANGE(IDC_COMBO_EJECT, OnCbnSelchangeComboEject)
	ON_BN_CLICKED(IDC_CHECK_STAMP, OnBnClickedCheckStamp)
	ON_BN_CLICKED(IDC_CHECK_CANCEL, OnBnClickedCheckCancel)
END_MESSAGE_MAP()


// CDoubleFeedDlg message handlers
BOOL CDoubleFeedDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	((CButton*)GetDlgItem(IDC_CHECK_DETECT))->SetCheck(
		theApp.m_Properties.GetValueDefTrue(DOUBLE_FEED_DETECT));

	((CComboBox*)GetDlgItem(IDC_COMBO_EJECT))->SetCurSel(
		theApp.m_Properties.GetValueDefFalse(DOUBLE_FEED_EJECT));

	((CButton*)GetDlgItem(IDC_CHECK_STAMP))->SetCheck(
		theApp.m_Properties.GetValueDefFalse(DOUBLE_FEED_STAMP));

	((CButton*)GetDlgItem(IDC_CHECK_CANCEL))->SetCheck(
		theApp.m_Properties.GetValueDefFalse(DOUBLE_FEED_CANCEL));

	SetEnableItem(theApp.m_Properties.GetValueDefTrue(PAPER_MIS_INSERT_DETECT));

	SetEnableItem(theApp.m_Properties.GetValueDefTrue(DOUBLE_FEED_DETECT));

	return TRUE;
}

// This method is called when the user clicks the Apply button
void CDoubleFeedDlg::Apply()
{
	theApp.m_Properties.SetProperty(&m_Properties);
}

void CDoubleFeedDlg::SetEnableItem(BOOL bCheck)
{
	((CComboBox*)GetDlgItem(IDC_COMBO_EJECT))->EnableWindow(bCheck);
	((CButton*)GetDlgItem(IDC_CHECK_STAMP))->EnableWindow(bCheck);
	((CButton*)GetDlgItem(IDC_CHECK_CANCEL))->EnableWindow(bCheck);
}

// This method is called when the user clicks the Detect checkbox
void CDoubleFeedDlg::OnBnClickedCheckDetect()
{
	UpdateData(TRUE);

	int iCheck = ((CButton*)GetDlgItem(IDC_CHECK_DETECT))->GetCheck();

	m_Properties.SetValue(DOUBLE_FEED_DETECT, iCheck);

	m_pConfigure->SetEnableApply();

	SetEnableItem(iCheck);
}

// This method is called when the user changed the Eject combobox
void CDoubleFeedDlg::OnCbnSelchangeComboEject()
{
	UpdateData(TRUE);

	m_Properties.SetValue(DOUBLE_FEED_EJECT, ((CComboBox*)GetDlgItem(IDC_COMBO_EJECT))->GetCurSel());

	m_pConfigure->SetEnableApply();
}

// This method is called when the user clicks the Stamp checkbox
void CDoubleFeedDlg::OnBnClickedCheckStamp()
{
	UpdateData(TRUE);

	int iCheck = ((CButton*)GetDlgItem(IDC_CHECK_STAMP))->GetCheck();

	m_Properties.SetValue(DOUBLE_FEED_STAMP, iCheck);

	m_pConfigure->SetEnableApply();
}

// This method is called when the user clicks the Cancel checkbox
void CDoubleFeedDlg::OnBnClickedCheckCancel()
{
	UpdateData(TRUE);

	int iCheck = ((CButton*)GetDlgItem(IDC_CHECK_CANCEL))->GetCheck();

	m_Properties.SetValue(DOUBLE_FEED_CANCEL, iCheck);

	m_pConfigure->SetEnableApply();
}
