// Conf.cpp : implementation file
//

#include "stdafx.h"
#include "TM-S1000Sample.h"
#include "TM-S1000SampleDlg.h"
#include "Conf.h"
#include ".\conf.h"


// CConf Dialog

IMPLEMENT_DYNAMIC(CConf, CDialog)
CConf::CConf(CWnd* pParent /*=NULL*/)
	: CDialog(CConf::IDD, pParent)
{
}

CConf::~CConf()
{
}

void CConf::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CConf, CDialog)
	ON_CBN_SELCHANGE(IDC_COMBO_EJECT_TYPE, OnCbnSelchangeComboEjectType)
	ON_BN_CLICKED(IDC_CHECK_STAMP, OnBnClickedCheckStamp)
	ON_CBN_SELCHANGE(IDC_COMBO_NEXT_CHECK, OnCbnSelchangeComboNextCheck)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
END_MESSAGE_MAP()


// CConf message handlers
BOOL CConf::OnInitDialog()
{
	CDialog::OnInitDialog();

	((CComboBox*)GetDlgItem(IDC_COMBO_EJECT_TYPE))->SetCurSel(
		theApp.m_Properties.GetValueDefFalse(CONFIRMATION_EJECT));
	((CButton*)GetDlgItem(IDC_CHECK_STAMP))->SetCheck(
		theApp.m_Properties.GetValueDefFalse(CONFIRMATION_STAMP));
	((CComboBox*)GetDlgItem(IDC_COMBO_NEXT_CHECK))->SetCurSel(
		theApp.m_Properties.GetValueDefFalse(CONFIRMATION_NEXT_CHECK));

	SetWindowText(((CTMS1000SampleDlg*)theApp.m_pMainWnd)->m_api.GetErrorOccured());

	return TRUE;
}

// This method is called when the user changed the EjectType combobox
void CConf::OnCbnSelchangeComboEjectType()
{
	theApp.m_Properties.SetValue(CONFIRMATION_EJECT, ((CComboBox*)GetDlgItem(IDC_COMBO_EJECT_TYPE))->GetCurSel());
}

// This method is called when the user clicks the Stamp checkbox
void CConf::OnBnClickedCheckStamp()
{
	theApp.m_Properties.SetValue(CONFIRMATION_STAMP, ((CButton*)GetDlgItem(IDC_CHECK_STAMP))->GetCheck());
}

// This method is called when the user changed the NextCheck combobox
void CConf::OnCbnSelchangeComboNextCheck()
{
	theApp.m_Properties.SetValue(CONFIRMATION_NEXT_CHECK, ((CComboBox*)GetDlgItem(IDC_COMBO_NEXT_CHECK))->GetCurSel());
}

// This method is called when the user clicks the OK button
void CConf::OnBnClickedOk()
{
	OnOK();
}

// This method is called when the user clicks the Cancel button
void CConf::OnBnClickedCancel()
{
	OnCancel();
}


