// MicrDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TM-S1000Sample.h"
#include "MicrDlg.h"
#include ".\micrdlg.h"
#include "ConfigureDlg.h"


// CMicrDlg Dialog

IMPLEMENT_DYNAMIC(CMicrDlg, CDialog)
CMicrDlg::CMicrDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMicrDlg::IDD, pParent)
{
}

CMicrDlg::~CMicrDlg()
{
}

void CMicrDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CMicrDlg, CDialog)
	ON_BN_CLICKED(IDC_CHECK_MICR, OnBnClickedCheckMicr)
	ON_BN_CLICKED(IDC_CHECK_SAVE, OnBnClickedCheckSave)
	ON_CBN_SELCHANGE(IDC_COMBO_FONT, OnCbnSelchangeComboFont)
END_MESSAGE_MAP()


// CMicrDlg message handlers
BOOL CMicrDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	((CButton*)GetDlgItem(IDC_CHECK_MICR))->SetCheck(theApp.m_Properties.GetValueDefTrue(READ_MICR));
	((CButton*)GetDlgItem(IDC_CHECK_SAVE))->SetCheck(theApp.m_Properties.GetValueDefFalse(MICR_SAVE));
	((CComboBox*)GetDlgItem(IDC_COMBO_FONT))->SetCurSel(theApp.m_Properties.GetValueDefFalse(MICR_FONT));

	((CComboBox*)GetDlgItem(IDC_COMBO_FONT))->EnableWindow(((CButton*)GetDlgItem(IDC_CHECK_MICR))->GetCheck());

	GetDlgItem(IDC_CHECK_SAVE)->EnableWindow(theApp.m_Properties.GetValueDefTrue(MICR_SAVE_ENABLE));

	return TRUE;
}

// This method is called when the user clicks the Apply button
void CMicrDlg::Apply()
{
	theApp.m_Properties.SetProperty(&m_Properties);
}

// This method is called when the user clicks the MICR checkbox
void CMicrDlg::OnBnClickedCheckMicr()
{
	UpdateData(TRUE);

	m_Properties.SetValue(READ_MICR, ((CButton*)GetDlgItem(IDC_CHECK_MICR))->GetCheck());

	m_pConfigure->SetEnableApply();

	GetDlgItem(IDC_CHECK_SAVE)->EnableWindow(((CButton*)GetDlgItem(IDC_CHECK_MICR))->GetCheck());

	m_Properties.SetValue(MICR_SAVE_ENABLE, ((CButton*)GetDlgItem(IDC_CHECK_MICR))->GetCheck());

	GetDlgItem(IDC_COMBO_FONT)->EnableWindow(((CButton*)GetDlgItem(IDC_CHECK_MICR))->GetCheck());
}

// This method is called when the user clicks the MicrSave checkbox
void CMicrDlg::OnBnClickedCheckSave()
{
	UpdateData(TRUE);

	m_Properties.SetValue(MICR_SAVE, ((CButton*)GetDlgItem(IDC_CHECK_SAVE))->GetCheck());

	m_pConfigure->SetEnableApply();
}

void CMicrDlg::OnCbnSelchangeComboFont()
{
	UpdateData(TRUE);

	m_Properties.SetValue(MICR_FONT, ((CComboBox*)GetDlgItem(IDC_COMBO_FONT))->GetCurSel());

	m_pConfigure->SetEnableApply();
}
