// PaperMisInsertion.cpp : implementation file
//

#include "stdafx.h"
#include "TM-S1000Sample.h"
#include "MisInsertion.h"
#include ".\misinsertion.h"
#include "ConfigureDlg.h"


// CPaperMisInsertion Dialog

IMPLEMENT_DYNAMIC(CPaperMisInsertion, CDialog)
CPaperMisInsertion::CPaperMisInsertion(CWnd* pParent /*=NULL*/)
	: CDialog(CPaperMisInsertion::IDD, pParent)
{
}

CPaperMisInsertion::~CPaperMisInsertion()
{
}

void CPaperMisInsertion::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CPaperMisInsertion, CDialog)
	ON_BN_CLICKED(IDC_CHECK_DETECT, OnBnClickedCheckDetect)
	ON_CBN_SELCHANGE(IDC_COMBO_EJECT, OnCbnSelchangeComboEject)
	ON_BN_CLICKED(IDC_CHECK_STAMP, OnBnClickedCheckStamp)
	ON_BN_CLICKED(IDC_CHECK_CANCEL, OnBnClickedCheckCancel)
END_MESSAGE_MAP()


// CPaperMisInsertion message handlers
BOOL CPaperMisInsertion::OnInitDialog()
{
	CDialog::OnInitDialog();

	((CButton*)GetDlgItem(IDC_CHECK_DETECT))->SetCheck(
		theApp.m_Properties.GetValueDefTrue(PAPER_MIS_INSERT_DETECT));

	((CComboBox*)GetDlgItem(IDC_COMBO_EJECT))->SetCurSel(
		theApp.m_Properties.GetValueDefFalse(PAPER_MIS_INSERT_EJECT));

	((CButton*)GetDlgItem(IDC_CHECK_STAMP))->SetCheck(
		theApp.m_Properties.GetValueDefFalse(PAPER_MIS_INSERT_STAMP));

	((CButton*)GetDlgItem(IDC_CHECK_CANCEL))->SetCheck(
		theApp.m_Properties.GetValueDefFalse(PAPER_MIS_INSERT_CANCEL));

	SetEnableItem(theApp.m_Properties.GetValueDefTrue(PAPER_MIS_INSERT_DETECT));

	return TRUE;
}

void CPaperMisInsertion::Apply()
{
	theApp.m_Properties.SetProperty(&m_Properties);
}

void CPaperMisInsertion::SetEnableItem(BOOL bCheck)
{
	((CComboBox*)GetDlgItem(IDC_COMBO_EJECT))->EnableWindow(bCheck);
	((CButton*)GetDlgItem(IDC_CHECK_STAMP))->EnableWindow(bCheck);
	((CButton*)GetDlgItem(IDC_CHECK_CANCEL))->EnableWindow(bCheck);
}

void CPaperMisInsertion::OnBnClickedCheckDetect()
{
	UpdateData(TRUE);

	int iCheck = ((CButton*)GetDlgItem(IDC_CHECK_DETECT))->GetCheck();

	m_Properties.SetValue(PAPER_MIS_INSERT_DETECT, iCheck);

	m_pConfigure->SetEnableApply();

	SetEnableItem(iCheck);
}

void CPaperMisInsertion::OnCbnSelchangeComboEject()
{
	UpdateData(TRUE);

	m_Properties.SetValue(PAPER_MIS_INSERT_EJECT, ((CComboBox*)GetDlgItem(IDC_COMBO_EJECT))->GetCurSel());

	m_pConfigure->SetEnableApply();
}

void CPaperMisInsertion::OnBnClickedCheckStamp()
{
	UpdateData(TRUE);

	int iCheck = ((CButton*)GetDlgItem(IDC_CHECK_STAMP))->GetCheck();

	m_Properties.SetValue(PAPER_MIS_INSERT_STAMP, iCheck);

	m_pConfigure->SetEnableApply();
}

void CPaperMisInsertion::OnBnClickedCheckCancel()
{
	UpdateData(TRUE);

	int iCheck = ((CButton*)GetDlgItem(IDC_CHECK_CANCEL))->GetCheck();

	m_Properties.SetValue(PAPER_MIS_INSERT_CANCEL, iCheck);

	m_pConfigure->SetEnableApply();
}
