// TM-S1000SampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TM-S1000Sample.h"
#include "TM-S1000SampleDlg.h"
#include ".\tm-s1000sampledlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTMS1000SampleDlg dialog



CTMS1000SampleDlg::CTMS1000SampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTMS1000SampleDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_hbmpFront = NULL;
	m_hbmpBack = NULL;
}

void CTMS1000SampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CTMS1000SampleDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_SCAN, OnBnClickedButtonScan)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedExit)
	ON_BN_CLICKED(IDC_BUTTON_CONFIGURE, OnBnClickedButtonConfigure)
	ON_BN_CLICKED(IDC_BUTTON_CANCEL, OnBnClickedButtonCancel)
END_MESSAGE_MAP()

CTMS1000SampleDlg::~CTMS1000SampleDlg()
{
	if(m_hbmpFront != NULL){
		::DeleteObject(m_hbmpFront);
		m_hbmpFront = NULL;
	}
	if(m_hbmpBack != NULL){
		::DeleteObject(m_hbmpBack);
		m_hbmpBack = NULL;
	}
}

// CTMS1000SampleDlg message handlers

BOOL CTMS1000SampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_api.Configure();
	theApp.m_Properties.SetValue(BADDATA_COUNT, 255);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTMS1000SampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		if(nID == SC_CLOSE){
			m_api.End();
		}
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTMS1000SampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
		if(m_hbmpFront){
			DisplayImage(GetDlgItem(IDC_FRONT_IMAGE), m_hbmpFront);
		}
		if(m_hbmpBack){
			DisplayImage(GetDlgItem(IDC_BACK_IMAGE), m_hbmpBack);
		}
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTMS1000SampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

// This method is called when the user clicks the scan button
void CTMS1000SampleDlg::OnBnClickedButtonScan()
{
	// 
	CString strTime;

	SetMicrString(NULL);
	SetImage(NULL, 0, TRUE);
	SetImage(NULL, 0, FALSE);
	SetWindowText("TM-S1000SampleStep5");

	((CButton*)GetDlgItem(IDC_BUTTON_SCAN))->EnableWindow(FALSE);
	((CButton*)GetDlgItem(IDC_BUTTON_CONFIGURE))->EnableWindow(FALSE);
	GotoDlgCtrl(GetDlgItem(IDC_BUTTON_CANCEL));
	DWORD dwTransactionNumber = m_api.GetTransactonNumber();
	DWORD dwTime = ::GetTickCount();

	m_api.Scan();

	DWORD dwProcessTime = ::GetTickCount() - dwTime;
	dwProcessTime = dwProcessTime - m_api.GetStartWaitTime();

	int iCount = m_api.GetTransactonNumber() - dwTransactionNumber;
	strTime.Format("TM-S1000SampleStep5 - Scan Complete( %d @ %.2f DPM )", iCount, 60000. * iCount / dwProcessTime);

	SetWindowText(strTime);

	((CButton*)GetDlgItem(IDC_BUTTON_CONFIGURE))->EnableWindow(TRUE);
	((CButton*)GetDlgItem(IDC_BUTTON_SCAN))->EnableWindow(TRUE);
}

// this method is display MICR data
void CTMS1000SampleDlg::SetMicrString(LPCTSTR lpMicr)
{
	((CEdit*)GetDlgItem(IDC_EDIT_MICR))->SetWindowText(lpMicr);
}

// this method is settings image data
void CTMS1000SampleDlg::SetImage(LPBYTE pBuffer, DWORD dwBufferSize, BOOL bFace)
{
	HBITMAP hBmp = NULL;
	if(pBuffer != NULL && dwBufferSize > 0) {
		CDC* pDC = GetDC();
		BITMAPINFO* pBI = (BITMAPINFO*) (pBuffer + sizeof(BITMAPFILEHEADER));
		void* pImageData = pBuffer + sizeof(BITMAPFILEHEADER) + pBI->bmiHeader.biSize + ((1 << pBI->bmiHeader.biBitCount) * sizeof(RGBQUAD));

		hBmp = CreateDIBitmap(
			pDC->m_hDC,
			&(pBI->bmiHeader),
			CBM_INIT,
			pImageData,
			pBI,
			DIB_RGB_COLORS);
		ReleaseDC(pDC);
	}

	if(bFace){
		if(m_hbmpFront != NULL){
			::DeleteObject(m_hbmpFront);
		}
		m_hbmpFront = hBmp;
	}else{
		if(m_hbmpBack != NULL){
			::DeleteObject(m_hbmpBack);
		}
		m_hbmpBack = hBmp;
	}
	RedrawWindow();
}

// this method is display image
void CTMS1000SampleDlg::DisplayImage(CWnd* pWnd, HBITMAP hBmp)
{
	if(pWnd == NULL){
		return;
	}

	CDC* pDC = pWnd->GetDC();
	CDC imageDC;

	if (imageDC.CreateCompatibleDC(pDC)) {
		BITMAP bmp;
		imageDC.SelectObject(hBmp);

		if (::GetObject(hBmp, sizeof(bmp), &bmp) != 0) {
			RECT rect;
			int width, height;

			pWnd->GetClientRect(&rect);
			width = rect.right - rect.left;
			height = rect.bottom - rect.top;

			::SetStretchBltMode(pDC->m_hDC, COLORONCOLOR);
			pDC->StretchBlt(0, 0, width, height, &imageDC, 0, 0, bmp.bmWidth, bmp.bmHeight, SRCCOPY);
			imageDC.SelectObject((HBITMAP)NULL);
		}
	}
	::DeleteDC(imageDC);
	pWnd->ReleaseDC(pDC);
}

// This method is called when the user clicks the Exit button
void CTMS1000SampleDlg::OnBnClickedExit()
{
	m_api.End();
	OnCancel();
}

// This method is called when the user clicks the Configure button
void CTMS1000SampleDlg::OnBnClickedButtonConfigure()
{
	m_ConfigureDlg.DoModal();
	m_api.Configure();
}

// This method is called when the confirmaiton mode
BOOL CTMS1000SampleDlg::SetConfirmationMode()
{
	if(m_Conf.DoModal() == IDOK){
		return TRUE;
	}else{
		return FALSE;
	}
}

// This method is called when the user clicks the Cancel button
void CTMS1000SampleDlg::OnBnClickedButtonCancel()
{
	m_api.CancelScan();
}
