// ConfigureDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TM-S1000Sample.h"
#include "ConfigureDlg.h"
#include ".\configuredlg.h"


// CConfigureDlg Dialog

IMPLEMENT_DYNAMIC(CConfigureDlg, CDialog)
CConfigureDlg::CConfigureDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConfigureDlg::IDD, pParent)
{
}

CConfigureDlg::~CConfigureDlg()
{
	theApp.m_Tab = NULL;
}

void CConfigureDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TAB1, m_tabConfigure);
}


BEGIN_MESSAGE_MAP(CConfigureDlg, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDC_BUTTON_APPLY, OnBnClickedButtonApply)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB1, OnTcnSelchangeTab1)
END_MESSAGE_MAP()


// CConfigureDlg message handlers
BOOL CConfigureDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Image
	TCITEM tcItem1;
	tcItem1.mask = TCIF_TEXT;
	tcItem1.pszText = "Image";
	m_tabConfigure.InsertItem(0, &tcItem1);

	// MICR
	TCITEM tcItem9;
	tcItem9.mask = TCIF_TEXT;
	tcItem9.pszText = "Micr";
	m_tabConfigure.InsertItem(1, &tcItem9);

	// OcrAB
	TCITEM tcItem11;
	tcItem11.mask = TCIF_TEXT;
	tcItem11.pszText = "OcrAB";
	m_tabConfigure.InsertItem(2, &tcItem11);

	// Endorse
	TCITEM tcItem2;
	tcItem2.mask = TCIF_TEXT;
	tcItem2.pszText = "Endorse";
	m_tabConfigure.InsertItem(3, &tcItem2);

	// Confirmation
	TCITEM tcItem3;
	tcItem3.mask = TCIF_TEXT;
	tcItem3.pszText = "Confirmation";
	m_tabConfigure.InsertItem(4, &tcItem3);

	// MisInsertion
	TCITEM tcItem4;
	tcItem4.mask = TCIF_TEXT;
	tcItem4.pszText = "MisInsetion";
	m_tabConfigure.InsertItem(5, &tcItem4);

	// NoiseDlg
	TCITEM tcItem5;
	tcItem5.mask = TCIF_TEXT;
	tcItem5.pszText = "Noise";
	m_tabConfigure.InsertItem(6, &tcItem5);

	// DoubleFeed
	TCITEM tcItem6;
	tcItem6.mask = TCIF_TEXT;
	tcItem6.pszText = "DoubleFeed";
	m_tabConfigure.InsertItem(7, &tcItem6);

	// Baddata
	TCITEM tcItem7;
	tcItem7.mask = TCIF_TEXT;
	tcItem7.pszText = "Baddata";
	m_tabConfigure.InsertItem(8, &tcItem7);

	// Nodata
	TCITEM tcItem8;
	tcItem8.mask = TCIF_TEXT;
	tcItem8.pszText = "Nodata";
	m_tabConfigure.InsertItem(9, &tcItem8);

	// Beep
	TCITEM tcItem10;
	tcItem10.mask = TCIF_TEXT;
	tcItem10.pszText = "Buzzer";
	m_tabConfigure.InsertItem(10, &tcItem10);

	m_ImageDlg.m_pConfigure = this;
	m_MicrDlg.m_pConfigure = this;
	m_EndorseDlg.m_pConfigure = this;
	m_Confirmation.m_pConfigure = this;
	m_MisInsertion.m_pConfigure = this;
	m_NoiseDlg.m_pConfigure = this;
	m_DoubleFeed.m_pConfigure = this;
	m_BaddataDlg.m_pConfigure = this;
	m_NodataDlg.m_pConfigure = this;
	m_BeepDlg.m_pConfigure = this;
	m_OcrAb.m_pConfigure = this;

	m_ImageDlg.Create(IDD_IMAGE_DIALOG, &m_tabConfigure);
	m_ImageDlg.SetWindowPos(&wndTop, 5, 23, 0, 0, SWP_NOSIZE | SWP_SHOWWINDOW);

	m_MicrDlg.Create(IDD_MICR_DIALOG, &m_tabConfigure);
	m_MicrDlg.SetWindowPos(&wndTop, 5, 23, 0, 0, SWP_NOSIZE | SWP_HIDEWINDOW);

	m_EndorseDlg.Create(IDD_ENDORSE_DIALOG, &m_tabConfigure);
	m_EndorseDlg.SetWindowPos(&wndTop, 5, 23, 0, 0, SWP_NOSIZE | SWP_HIDEWINDOW);

	m_Confirmation.Create(IDD_CONFIRMATION_DIALOG, &m_tabConfigure);
	m_Confirmation.SetWindowPos(&wndTop, 5, 23, 0, 0, SWP_NOSIZE | SWP_HIDEWINDOW);

	m_MisInsertion.Create(IDD_PAPER_MIS_INSERTION_DIALOG, &m_tabConfigure);
	m_MisInsertion.SetWindowPos(&wndTop, 5, 23, 0, 0, SWP_NOSIZE | SWP_HIDEWINDOW);

	m_NoiseDlg.Create(IDD_NOISE_DIALOG, &m_tabConfigure);
	m_NoiseDlg.SetWindowPos(&wndTop, 5, 23, 0, 0, SWP_NOSIZE | SWP_HIDEWINDOW);

	m_DoubleFeed.Create(IDD_DOUBLE_FEED_DIALOG, &m_tabConfigure);
	m_DoubleFeed.SetWindowPos(&wndTop, 5, 23, 0, 0, SWP_NOSIZE | SWP_HIDEWINDOW);

	m_BaddataDlg.Create(IDD_BADDATA_DIALOG, &m_tabConfigure);
	m_BaddataDlg.SetWindowPos(&wndTop, 5, 23, 0, 0, SWP_NOSIZE | SWP_HIDEWINDOW);

	m_NodataDlg.Create(IDD_NODATA_DIALOG, &m_tabConfigure);
	m_NodataDlg.SetWindowPos(&wndTop, 5, 23, 0, 0, SWP_NOSIZE | SWP_HIDEWINDOW);

	m_BeepDlg.Create(IDC_BEEP_DIALOG, &m_tabConfigure);
	m_BeepDlg.SetWindowPos(&wndTop, 5, 23, 0, 0, SWP_NOSIZE | SWP_HIDEWINDOW);

	m_OcrAb.Create(IDD_OCR_AB_DIALOG, &m_tabConfigure);
	m_OcrAb.SetWindowPos(&wndTop, 5, 23, 0, 0, SWP_NOSIZE | SWP_HIDEWINDOW);

	m_tabConfigure.SetCurSel(0);

	GetDlgItem(IDC_BUTTON_APPLY)->EnableWindow(FALSE);

	theApp.m_Tab = m_tabConfigure.m_hWnd;

	return TRUE;
}

// This method is called when the user clicks the OK button
void CConfigureDlg::OnBnClickedOk()
{
	OnBnClickedButtonApply();
	OnOK();
}

// This method is called when the user clicks the Cancel button
void CConfigureDlg::OnBnClickedCancel()
{
	OnCancel();
}

// This method is called when the user clicks the Apply button
void CConfigureDlg::OnBnClickedButtonApply()
{
	m_ImageDlg.Apply();
	m_MicrDlg.Apply();
	m_EndorseDlg.Apply();
	m_Confirmation.Apply();
	m_MisInsertion.Apply();
	m_NoiseDlg.Apply();
	m_DoubleFeed.Apply();
	m_BaddataDlg.Apply();
	m_NodataDlg.Apply();
	m_BeepDlg.Apply();
	m_OcrAb.Apply();

	GetDlgItem(IDC_BUTTON_APPLY)->EnableWindow(FALSE);
}

// This method is the Apply button effectively
void CConfigureDlg::SetEnableApply()
{
	GetDlgItem(IDC_BUTTON_APPLY)->EnableWindow(TRUE);
}

// This method is called when the user clicks the tab
void CConfigureDlg::OnTcnSelchangeTab1(NMHDR *pNMHDR, LRESULT *pResult)
{
	m_ImageDlg.ShowWindow(SW_HIDE);
	m_MicrDlg.ShowWindow(SW_HIDE);
	m_EndorseDlg.ShowWindow(SW_HIDE);
	m_Confirmation.ShowWindow(SW_HIDE);
	m_MisInsertion.ShowWindow(SW_HIDE);
	m_NoiseDlg.ShowWindow(SW_HIDE);
	m_DoubleFeed.ShowWindow(SW_HIDE);
	m_BaddataDlg.ShowWindow(SW_HIDE);
	m_NodataDlg.ShowWindow(SW_HIDE);
	m_BeepDlg.ShowWindow(SW_HIDE);
	m_OcrAb.ShowWindow(SW_HIDE);

	switch(m_tabConfigure.GetCurSel()){
		case 0:
			m_ImageDlg.ShowWindow(SW_SHOW);
			break;
		case 1:
			m_MicrDlg.ShowWindow(SW_SHOW);
			break;
		case 2:
			m_OcrAb.ShowWindow(SW_SHOW);
			break;
		case 3:
			m_EndorseDlg.ShowWindow(SW_SHOW);
			break;
		case 4:
			m_Confirmation.ShowWindow(SW_SHOW);
			break;
		case 5:
			m_MisInsertion.ShowWindow(SW_SHOW);
			break;
		case 6:
			m_NoiseDlg.ShowWindow(SW_SHOW);
			break;
		case 7:
			m_DoubleFeed.ShowWindow(SW_SHOW);
			break;
		case 8:
			m_BaddataDlg.ShowWindow(SW_SHOW);
			break;
		case 9:
			m_NodataDlg.ShowWindow(SW_SHOW);
			break;
		case 10:
			m_BeepDlg.ShowWindow(SW_SHOW);
			break;
	}
	*pResult = 0;
}

void CConfigureDlg::SetOcrAbFlag(BOOL bFlag)
{
	m_MicrDlg.m_bOcrAb = bFlag;
	m_MicrDlg.OnBnClickedCheckOcrAb();
}
