// NoiseDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TM-S1000Sample.h"
#include "NoiseDlg.h"
#include ".\noisedlg.h"
#include "ConfigureDlg.h"


// CNoiseDlg Dialog

IMPLEMENT_DYNAMIC(CNoiseDlg, CDialog)
CNoiseDlg::CNoiseDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNoiseDlg::IDD, pParent)
{
}

CNoiseDlg::~CNoiseDlg()
{
}

void CNoiseDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CNoiseDlg, CDialog)
	ON_BN_CLICKED(IDC_CHECK_DETECT, OnBnClickedCheckDetect)
	ON_CBN_SELCHANGE(IDC_COMBO_EJECT, OnCbnSelchangeComboEject)
	ON_BN_CLICKED(IDC_CHECK_STAMP, OnBnClickedCheckStamp)
	ON_BN_CLICKED(IDC_CHECK_CANCEL, OnBnClickedCheckCancel)
END_MESSAGE_MAP()


// CNoiseDlg message handlers
BOOL CNoiseDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	((CButton*)GetDlgItem(IDC_CHECK_DETECT))->SetCheck(
		theApp.m_Properties.GetValueDefTrue(NOISE_DETECT));

	((CComboBox*)GetDlgItem(IDC_COMBO_EJECT))->SetCurSel(
		theApp.m_Properties.GetValueDefFalse(NOISE_EJECT));

	((CButton*)GetDlgItem(IDC_CHECK_STAMP))->SetCheck(
		theApp.m_Properties.GetValueDefFalse(NOISE_STAMP));

	((CButton*)GetDlgItem(IDC_CHECK_CANCEL))->SetCheck(
		theApp.m_Properties.GetValueDefTrue(NOISE_CANCEL));

	SetEnableItem(theApp.m_Properties.GetValueDefTrue(NOISE_DETECT));


	return TRUE;
}

void CNoiseDlg::SetEnableItem(BOOL bCheck)
{
	((CComboBox*)GetDlgItem(IDC_COMBO_EJECT))->EnableWindow(bCheck);
	((CButton*)GetDlgItem(IDC_CHECK_STAMP))->EnableWindow(bCheck);
	((CButton*)GetDlgItem(IDC_CHECK_CANCEL))->EnableWindow(bCheck);
}

void CNoiseDlg::Apply()
{
	theApp.m_Properties.SetProperty(&m_Properties);
}

void CNoiseDlg::OnBnClickedCheckDetect()
{
	UpdateData(TRUE);

	int iCheck = ((CButton*)GetDlgItem(IDC_CHECK_DETECT))->GetCheck();

	m_Properties.SetValue(NOISE_DETECT, iCheck);

	m_pConfigure->SetEnableApply();

	SetEnableItem(iCheck);
}

void CNoiseDlg::OnCbnSelchangeComboEject()
{
	UpdateData(TRUE);

	m_Properties.SetValue(NOISE_EJECT, ((CComboBox*)GetDlgItem(IDC_COMBO_EJECT))->GetCurSel());

	m_pConfigure->SetEnableApply();
}

void CNoiseDlg::OnBnClickedCheckStamp()
{
	UpdateData(TRUE);

	int iCheck = ((CButton*)GetDlgItem(IDC_CHECK_STAMP))->GetCheck();

	m_Properties.SetValue(NOISE_STAMP, iCheck);

	m_pConfigure->SetEnableApply();
}

void CNoiseDlg::OnBnClickedCheckCancel()
{
	UpdateData(TRUE);

	int iCheck = ((CButton*)GetDlgItem(IDC_CHECK_CANCEL))->GetCheck();

	m_Properties.SetValue(NOISE_CANCEL, iCheck);

	m_pConfigure->SetEnableApply();
}
