// OcrAbDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TM-S1000Sample.h"
#include "OcrAbDlg.h"
#include ".\ocrabdlg.h"
#include "ConfigureDlg.h"


// COcrAbDlg Dialog

IMPLEMENT_DYNAMIC(COcrAbDlg, CDialog)
COcrAbDlg::COcrAbDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COcrAbDlg::IDD, pParent)
{
}

COcrAbDlg::~COcrAbDlg()
{
}

void COcrAbDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(COcrAbDlg, CDialog)
	ON_BN_CLICKED(IDC_CHECK_OCR_AB, OnBnClickedCheckOcrAb)
	ON_CBN_SELCHANGE(IDC_COMBO_FONT, OnCbnSelchangeComboFont)
END_MESSAGE_MAP()


// COcrAbDlg message handlers

BOOL COcrAbDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	BOOL bOcrAb = theApp.m_Properties.GetValueDefFalse(OCR_AB);
	((CButton*)GetDlgItem(IDC_CHECK_OCR_AB))->SetCheck(bOcrAb);
	(GetDlgItem(IDC_STATIC_FONT))->EnableWindow(bOcrAb);
	(GetDlgItem(IDC_COMBO_FONT))->EnableWindow(bOcrAb);

	((CComboBox*)GetDlgItem(IDC_COMBO_FONT))->SetCurSel(theApp.m_Properties.GetValueDefFalse(OCR_AB_FONT));

	return TRUE;
}

// This method is called when the user clicks the Apply button
void COcrAbDlg::Apply()
{
	theApp.m_Properties.SetProperty(&m_Properties);
}

// This method is called when the user clicks the OCR_AB checkbox
void COcrAbDlg::OnBnClickedCheckOcrAb()
{
	UpdateData(TRUE);

	m_pConfigure->SetEnableApply();

	BOOL bOcrAb = ((CButton*)GetDlgItem(IDC_CHECK_OCR_AB))->GetCheck();

	m_Properties.SetValue(OCR_AB, bOcrAb);

	(GetDlgItem(IDC_STATIC_FONT))->EnableWindow(bOcrAb);
	(GetDlgItem(IDC_COMBO_FONT))->EnableWindow(bOcrAb);
	m_pConfigure->SetOcrAbFlag(bOcrAb);
}

// This method is called when the user changed the Font combobx
void COcrAbDlg::OnCbnSelchangeComboFont()
{
	m_Properties.SetValue(OCR_AB_FONT, ((CComboBox*)GetDlgItem(IDC_COMBO_FONT))->GetCurSel());

	m_pConfigure->SetEnableApply();
}
