#include "StdAfx.h"
#include ".\properties.h"

#define NO_PROPERTY	-1

CProperties::CProperties(void)
{
	m_pProperty = NULL;
}

CProperties::~CProperties(void)
{
	PropertyList* pProperty = m_pProperty;
	while(pProperty != NULL){
		PropertyList* pTmp = pProperty;
		pProperty = pTmp->pNext;
		delete [] pTmp;
	}
}

// This method is settings value
BOOL CProperties::SetValue(LPCTSTR strProperty, int iValue)
{
	PropertyList* pProperty = m_pProperty;
	
	while(pProperty != NULL){
		if(_tcscmp(pProperty->strProperty, strProperty) == 0){

			if(pProperty->iValue != iValue){
				pProperty->iValue = iValue;
				return TRUE;
			}
			return FALSE;
		}
		pProperty = pProperty->pNext;
	}

	// Create property
	PropertyList* pNewProperty = new PropertyList();
	pNewProperty->strProperty = strProperty;
	pNewProperty->iValue = iValue;
	pNewProperty->pNext = m_pProperty;
	m_pProperty = pNewProperty;

	return TRUE;
}

// This method is return value
int CProperties::GetValue(LPCTSTR strProperty)
{
	PropertyList* pProperty = m_pProperty;
	
	while(pProperty != NULL){
		if(_tcscmp(pProperty->strProperty, strProperty) == 0){
			return (BYTE)pProperty->iValue;
		}
		pProperty = pProperty->pNext;
	}

	return NO_PROPERTY;
}

// this method is settings Properties
void CProperties::SetProperty(CProperties* pProperties)
{
	PropertyList* pList = pProperties->m_pProperty;
	while(pList != NULL){
		SetValue(pList->strProperty, pList->iValue);
		pList = pList->pNext;
	}
}

// this method is return the value
// default : return the TRUE
int CProperties::GetValueDefTrue(LPCTSTR strProperty)
{
	int nValue = GetValue(strProperty);
	if(nValue == -1){

		return TRUE;
	}
	return nValue;
}

// this method is return the value
// default : return the FALSE
int CProperties::GetValueDefFalse(LPCTSTR strProperty)
{
	int nValue = GetValue(strProperty);
	if(nValue == -1){

		return FALSE;
	}
	return nValue;
}
