#pragma once

#define SCAN_FUNC _T("ScanFunction")
#define ELEC_ENDORSE_TEXT _T("ElectronicEndorse Text")
#define ELEC_ENDORSE_IMAGE _T("ElectronicEndorse Image")
#define PAPER_MIS_INSERT_DETECT _T("PaperMisInsertionErrorDetect")
#define PAPER_MIS_INSERT_EJECT _T("PaperMisInsertionErrorEject")
#define PAPER_MIS_INSERT_STAMP _T("PaperMisInsertionStamp")
#define PAPER_MIS_INSERT_CANCEL _T("PaperMisInsertionCancel")
#define NOISE_DETECT _T("NoiseErrorDetect")
#define NOISE_EJECT _T("NoiseErrorEject")
#define NOISE_STAMP _T("NoiseStamp")
#define NOISE_CANCEL _T("NoiseCancel")
#define DOUBLE_FEED_DETECT _T("DoubleFeedErrorDetect")
#define DOUBLE_FEED_EJECT _T("DoubleFeedErrorEject")
#define DOUBLE_FEED_STAMP _T("DoubleFeedStamp")
#define DOUBLE_FEED_CANCEL _T("DoubleFeedCancel")
#define BADDATA_COUNT _T("BaddataCount")
#define BADDATA_DETECT _T("BaddataErrorDetect")
#define BADDATA_EJECT _T("BaddataErrorEject")
#define BADDATA_STAMP _T("BaddataStamp")
#define BADDATA_CANCEL _T("BaddataCancel")
#define NODATA_DETECT _T("NodataErrorDetect")
#define NODATA_EJECT _T("NodataErrorEject")
#define NODATA_STAMP _T("NodataStamp")
#define NODATA_CANCEL _T("NodataCancel")
#define ACTIVATE_MODE _T("ActivationMode")
#define RUN_TO_SCN_RESULT _T("Run ToScnResult")
#define NO_CALL_TO_SCN_RESULT _T("No Call ToScnResult")
#define CONFIRMATION_EJECT _T("ConfirmationEject")
#define CONFIRMATION_STAMP _T("ConfirmationStamp")
#define CONFIRMATION_NEXT_CHECK _T("ConfirmationNextCheck")
#define FRONT_SCAN _T("FrontScan")
#define FRONT_GRAYSCALE _T("FrontGrayscale")
#define FRONT_DISPLAY _T("FrontDisplayOnScreen")
#define FRONT_SAVE _T("FrontSaveToHarddisk")
#define BACK_SCAN _T("BackScan")
#define BACK_GRAYSCALE _T("BackGrayscale")
#define BACK_DISPLAY _T("BackDisplayOnScreen")
#define BACK_SAVE _T("BackSaveToHarddisk")
#define READ_MICR _T("ReadMicr")
#define MICR_CANCEL _T("MicrCancel")
#define MICR_SAVE _T("MicrSave")
#define MICR_SAVE_ENABLE _T("MicrSaveEnable")
#define MICR_FONT _T("Micr Font")
#define BEEP_SUCCESS_HZ _T("Beep SUCCESS Hz")
#define BEEP_SUCCESS_COUNT _T("Beep SUCCESS Count")
#define BEEP_ERROR_HZ _T("Beep Error Hz")
#define BEEP_ERROR_COUNT _T("Beep Error Count")
#define BEEP_WFEED_HZ _T("Beep WFeed Hz")
#define BEEP_WFEED_COUNT _T("Beep WFeed Count")
#define OCR_AB	_T("OCR AB")
#define OCR_AB_FONT _T("OCR AB Font")

struct PropertyList{
	LPCTSTR					strProperty;	// Property key
	int						iValue;			// Property value
	struct PropertyList*	pNext;			// Next property
};

class CProperties
{
public:
	CProperties(void);
	~CProperties(void);

	// Set property value
	BOOL SetValue(LPCTSTR strProperty, int iValue);
	// Get property value
	int GetValue(LPCTSTR strProperty);
	// Renewal property
	void SetProperty(CProperties* pProperties);
	int GetValueDefTrue(LPCTSTR strProperty);
	int GetValueDefFalse(LPCTSTR strProperty);

private:
	struct PropertyList* m_pProperty;
};
