// BaddataDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TM-S1000Sample.h"
#include "BaddataDlg.h"
#include ".\baddatadlg.h"
#include "ConfigureDlg.h"


// CBaddataDlg Dialog

IMPLEMENT_DYNAMIC(CBaddataDlg, CDialog)
CBaddataDlg::CBaddataDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBaddataDlg::IDD, pParent)
{
}

CBaddataDlg::~CBaddataDlg()
{
}

void CBaddataDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CBaddataDlg, CDialog)
	ON_BN_CLICKED(IDC_CHECK_DETECT, OnBnClickedCheckDetect)
	ON_CBN_SELCHANGE(IDC_COMBO_EJECT, OnCbnSelchangeComboEject)
	ON_BN_CLICKED(IDC_CHECK_STAMP, OnBnClickedCheckStamp)
	ON_BN_CLICKED(IDC_CHECK_CANCEL, OnBnClickedCheckCancel)
	ON_EN_CHANGE(IDC_EDIT_COUNT, OnEnChangeEditCount)
END_MESSAGE_MAP()


// CBaddataDlg message handlers
BOOL CBaddataDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	((CButton*)GetDlgItem(IDC_CHECK_DETECT))->SetCheck(
		theApp.m_Properties.GetValueDefTrue(BADDATA_DETECT));

	((CComboBox*)GetDlgItem(IDC_COMBO_EJECT))->SetCurSel(
		theApp.m_Properties.GetValueDefFalse(BADDATA_EJECT));

	((CButton*)GetDlgItem(IDC_CHECK_STAMP))->SetCheck(
		theApp.m_Properties.GetValueDefFalse(BADDATA_STAMP));

	((CButton*)GetDlgItem(IDC_CHECK_CANCEL))->SetCheck(
		theApp.m_Properties.GetValueDefFalse(BADDATA_CANCEL));

	CString strCount;
	strCount.Format("%d", theApp.m_Properties.GetValue(BADDATA_COUNT));
	((CEdit*)GetDlgItem(IDC_EDIT_COUNT))->SetWindowText(strCount);

	SetEnableItem(theApp.m_Properties.GetValueDefTrue(BADDATA_DETECT));

	return TRUE;
}

// This method is called when the user clicks the Apply button
void CBaddataDlg::Apply()
{
	theApp.m_Properties.SetProperty(&m_Properties);
}

void CBaddataDlg::SetEnableItem(BOOL bCheck)
{
	((CComboBox*)GetDlgItem(IDC_COMBO_EJECT))->EnableWindow(bCheck);
	((CButton*)GetDlgItem(IDC_CHECK_STAMP))->EnableWindow(bCheck);
	((CButton*)GetDlgItem(IDC_CHECK_CANCEL))->EnableWindow(bCheck);
	((CEdit*)GetDlgItem(IDC_EDIT_COUNT))->EnableWindow(bCheck);
}

// This method is called when the user clicks the Detect checkbox
void CBaddataDlg::OnBnClickedCheckDetect()
{
	UpdateData(TRUE);

	int iCheck = ((CButton*)GetDlgItem(IDC_CHECK_DETECT))->GetCheck();

	m_Properties.SetValue(BADDATA_DETECT, iCheck);

	m_pConfigure->SetEnableApply();

	SetEnableItem(iCheck);
}

// This method is called when the user changed the Eject combobx
void CBaddataDlg::OnCbnSelchangeComboEject()
{
	UpdateData(TRUE);

	m_Properties.SetValue(BADDATA_EJECT, ((CComboBox*)GetDlgItem(IDC_COMBO_EJECT))->GetCurSel());

	m_pConfigure->SetEnableApply();
}

// This method is called when the user clicks the Stamp checkbox
void CBaddataDlg::OnBnClickedCheckStamp()
{
	UpdateData(TRUE);

	int iCheck = ((CButton*)GetDlgItem(IDC_CHECK_STAMP))->GetCheck();

	m_Properties.SetValue(BADDATA_STAMP, iCheck);

	m_pConfigure->SetEnableApply();
}

// This method is called when the user clicks the Cancel checkbox
void CBaddataDlg::OnBnClickedCheckCancel()
{
	UpdateData(TRUE);

	int iCheck = ((CButton*)GetDlgItem(IDC_CHECK_CANCEL))->GetCheck();

	m_Properties.SetValue(BADDATA_CANCEL, iCheck);

	m_pConfigure->SetEnableApply();
}

void CBaddataDlg::OnEnChangeEditCount()
{
	UpdateData(TRUE);
	
	CString strCount;
	GetDlgItem(IDC_EDIT_COUNT)->GetWindowText(strCount);
	int iCount = atoi(strCount);

	m_Properties.SetValue(BADDATA_COUNT, iCount);

	m_pConfigure->SetEnableApply();
}
