// TM-S1000SampleDlg.h : header file
//

#pragma once
#include "APIUsage.h"
#include "ConfigureDlg.h"
#include "Conf.h"
#include "DeviceStatusDlg.h"

// CTMS1000SampleDlg dialog
class CTMS1000SampleDlg : public CDialog
{
// Construction
public:
	CTMS1000SampleDlg(CWnd* pParent = NULL);	// standard constructor
	virtual ~CTMS1000SampleDlg();

// Dialog Data
	enum { IDD = IDD_TMS1000SAMPLE_DIALOG };

	void SetMicrString(LPCTSTR lpMicr);
	void SetOcrString(LPCTSTR lpOcr);
	void SetImage(LPBYTE pBuffer, DWORD dwBufferSize, BOOL bFace);
	BOOL SetConfirmationMode();

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

public:
	CAPIUsage m_api;
	CConfigureDlg m_ConfigureDlg;
	CConf m_Conf;
	CDeviceStatusDlg m_DeviceStatusDlg;
	afx_msg void OnBnClickedButtonScan();

private:
	HBITMAP m_hbmpFront;
	HBITMAP m_hbmpBack;
	BOOL m_bDeviceStatus;

	void DisplayImage(CWnd* pWnd, HBITMAP hBmp);
public:
	afx_msg void OnBnClickedExit();
	afx_msg void OnBnClickedButtonConfigure();
	afx_msg void OnBnClickedButtonDeviceStatus();
	afx_msg void OnBnClickedButtonStopBuzzer();
	afx_msg void OnBnClickedButtonCleaning();
	afx_msg void OnBnClickedButtonCancel();
};
