// BarcodeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TM-S1000Sample.h"
#include "BarcodeDlg.h"
#include ".\barcodedlg.h"
#include "ConfigureDlg.h"


// CBarcodeDlg Dialog

IMPLEMENT_DYNAMIC(CBarcodeDlg, CDialog)
CBarcodeDlg::CBarcodeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBarcodeDlg::IDD, pParent)
{
}

CBarcodeDlg::~CBarcodeDlg()
{
}

void CBarcodeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CBarcodeDlg, CDialog)
	ON_BN_CLICKED(IDC_CHECK_DETECT_FRONT, OnBnClickedCheckDetectFront)
	ON_CBN_SELCHANGE(IDC_COMBO_EJECT_FRONT, OnCbnSelchangeComboEjectFront)
	ON_BN_CLICKED(IDC_CHECK_STAMP_FRONT, OnBnClickedCheckStampFront)
	ON_BN_CLICKED(IDC_CHECK_CANCEL_FRONT, OnBnClickedCheckCancelFront)
	ON_BN_CLICKED(IDC_CHECK_DETECT_BACK, OnBnClickedCheckDetectBack)
	ON_CBN_SELCHANGE(IDC_COMBO_EJECT_BACK, OnCbnSelchangeComboEjectBack)
	ON_BN_CLICKED(IDC_CHECK_STAMP_BACK, OnBnClickedCheckStampBack)
	ON_BN_CLICKED(IDC_CHECK_CANCEL_BACK, OnBnClickedCheckCancelBack)
END_MESSAGE_MAP()


// CBarcodeDlg message handlers

BOOL CBarcodeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	((CButton*)GetDlgItem(IDC_CHECK_DETECT_FRONT))->SetCheck(
		theApp.m_Properties.GetValueDefFalse(BARCODE_FRONT_DETECT));

	((CComboBox*)GetDlgItem(IDC_COMBO_EJECT_FRONT))->SetCurSel(
		theApp.m_Properties.GetValueDefFalse(BARCODE_FRONT_EJECT));

	((CButton*)GetDlgItem(IDC_CHECK_STAMP_FRONT))->SetCheck(
		theApp.m_Properties.GetValueDefFalse(BARCODE_FRONT_STAMP));

	((CButton*)GetDlgItem(IDC_CHECK_CANCEL_FRONT))->SetCheck(
		theApp.m_Properties.GetValueDefFalse(BARCODE_FRONT_CANCEL));


	((CButton*)GetDlgItem(IDC_CHECK_DETECT_BACK))->SetCheck(
		theApp.m_Properties.GetValueDefFalse(BARCODE_BACK_DETECT));

	((CComboBox*)GetDlgItem(IDC_COMBO_EJECT_BACK))->SetCurSel(
		theApp.m_Properties.GetValueDefFalse(BARCODE_BACK_EJECT));

	((CButton*)GetDlgItem(IDC_CHECK_STAMP_BACK))->SetCheck(
		theApp.m_Properties.GetValueDefFalse(BARCODE_BACK_STAMP));

	((CButton*)GetDlgItem(IDC_CHECK_CANCEL_BACK))->SetCheck(
		theApp.m_Properties.GetValueDefFalse(BARCODE_BACK_CANCEL));


	SetEnableFrontItem(theApp.m_Properties.GetValueDefFalse(BARCODE_FRONT_DETECT));
	SetEnableBackItem(theApp.m_Properties.GetValueDefFalse(BARCODE_BACK_DETECT));

	return TRUE;  // return TRUE unless you set the focus to a control
}

// This method is called when the user clicks the Apply button
void CBarcodeDlg::Apply()
{
	theApp.m_Properties.SetProperty(&m_Properties);
}

void CBarcodeDlg::SetEnableFrontItem(BOOL bCheck)
{
	((CComboBox*)GetDlgItem(IDC_COMBO_EJECT_FRONT))->EnableWindow(bCheck);
	((CButton*)GetDlgItem(IDC_CHECK_STAMP_FRONT))->EnableWindow(bCheck);
	((CButton*)GetDlgItem(IDC_CHECK_CANCEL_FRONT))->EnableWindow(bCheck);
}

void CBarcodeDlg::SetEnableBackItem(BOOL bCheck)
{
	((CComboBox*)GetDlgItem(IDC_COMBO_EJECT_BACK))->EnableWindow(bCheck);
	((CButton*)GetDlgItem(IDC_CHECK_STAMP_BACK))->EnableWindow(bCheck);
	((CButton*)GetDlgItem(IDC_CHECK_CANCEL_BACK))->EnableWindow(bCheck);
}

void CBarcodeDlg::OnBnClickedCheckDetectFront()
{
	UpdateData(TRUE);

	int iCheck = ((CButton*)GetDlgItem(IDC_CHECK_DETECT_FRONT))->GetCheck();

	m_Properties.SetValue(BARCODE_FRONT_DETECT, iCheck);

	m_pConfigure->SetEnableApply();

	SetEnableFrontItem(iCheck);
}

void CBarcodeDlg::OnCbnSelchangeComboEjectFront()
{
	UpdateData(TRUE);

	m_Properties.SetValue(BARCODE_FRONT_EJECT, ((CComboBox*)GetDlgItem(IDC_COMBO_EJECT_FRONT))->GetCurSel());

	m_pConfigure->SetEnableApply();
}

void CBarcodeDlg::OnBnClickedCheckStampFront()
{
	UpdateData(TRUE);

	int iCheck = ((CButton*)GetDlgItem(IDC_CHECK_STAMP_FRONT))->GetCheck();

	m_Properties.SetValue(BARCODE_FRONT_STAMP, iCheck);

	m_pConfigure->SetEnableApply();
}

void CBarcodeDlg::OnBnClickedCheckCancelFront()
{
	UpdateData(TRUE);

	int iCheck = ((CButton*)GetDlgItem(IDC_CHECK_CANCEL_FRONT))->GetCheck();

	m_Properties.SetValue(BARCODE_FRONT_CANCEL, iCheck);

	m_pConfigure->SetEnableApply();
}

void CBarcodeDlg::OnBnClickedCheckDetectBack()
{
	UpdateData(TRUE);

	int iCheck = ((CButton*)GetDlgItem(IDC_CHECK_DETECT_BACK))->GetCheck();

	m_Properties.SetValue(BARCODE_BACK_DETECT, iCheck);

	m_pConfigure->SetEnableApply();

	SetEnableBackItem(iCheck);
}

void CBarcodeDlg::OnCbnSelchangeComboEjectBack()
{
	UpdateData(TRUE);

	m_Properties.SetValue(BARCODE_BACK_EJECT, ((CComboBox*)GetDlgItem(IDC_COMBO_EJECT_BACK))->GetCurSel());

	m_pConfigure->SetEnableApply();
}

void CBarcodeDlg::OnBnClickedCheckStampBack()
{
	UpdateData(TRUE);

	int iCheck = ((CButton*)GetDlgItem(IDC_CHECK_STAMP_BACK))->GetCheck();

	m_Properties.SetValue(BARCODE_BACK_STAMP, iCheck);

	m_pConfigure->SetEnableApply();
}

void CBarcodeDlg::OnBnClickedCheckCancelBack()
{
	UpdateData(TRUE);

	int iCheck = ((CButton*)GetDlgItem(IDC_CHECK_CANCEL_BACK))->GetCheck();

	m_Properties.SetValue(BARCODE_BACK_CANCEL, iCheck);

	m_pConfigure->SetEnableApply();
}
