// ImageDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TM-S1000Sample.h"
#include "ImageDlg.h"
#include ".\imagedlg.h"
#include "ConfigureDlg.h"


// CImageDlg Dialog

IMPLEMENT_DYNAMIC(CImageDlg, CDialog)
CImageDlg::CImageDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CImageDlg::IDD, pParent)
{
}

CImageDlg::~CImageDlg()
{
}

void CImageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CImageDlg, CDialog)
	ON_CBN_SELCHANGE(IDC_COMBO_SCAN_FUNC, OnCbnSelchangeComboScanFunc)
	ON_BN_CLICKED(IDC_CHECK_FRONT_SCAN, OnBnClickedCheckFrontScan)
	ON_BN_CLICKED(IDC_CHECK_FRONT_GRAYSCALE, OnBnClickedCheckFrontGrayscale)
	ON_BN_CLICKED(IDC_CHECK_FRONT_DISPLAY, OnBnClickedCheckFrontDisplay)
	ON_BN_CLICKED(IDC_CHECK_FRONT_SAVE, OnBnClickedCheckFrontSave)
	ON_BN_CLICKED(IDC_CHECK_BACK_SCAN, OnBnClickedCheckBackScan)
	ON_BN_CLICKED(IDC_CHECK_BACK_GRAYSCALE, OnBnClickedCheckBackGrayscale)
	ON_BN_CLICKED(IDC_CHECK_BACK_DISPLAY, OnBnClickedCheckBackDisplay)
	ON_BN_CLICKED(IDC_CHECK_BACK_SAVE, OnBnClickedCheckBackSave)
END_MESSAGE_MAP()


// CImageDlg message handlers

BOOL CImageDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	((CComboBox*)GetDlgItem(IDC_COMBO_SCAN_FUNC))->SetCurSel(theApp.m_Properties.GetValueDefFalse(SCAN_FUNC));
	((CButton*)GetDlgItem(IDC_CHECK_FRONT_SCAN))->SetCheck(theApp.m_Properties.GetValueDefTrue(FRONT_SCAN));
	((CButton*)GetDlgItem(IDC_CHECK_FRONT_GRAYSCALE))->SetCheck(theApp.m_Properties.GetValueDefFalse(FRONT_GRAYSCALE));
	((CButton*)GetDlgItem(IDC_CHECK_FRONT_DISPLAY))->SetCheck(theApp.m_Properties.GetValueDefTrue(FRONT_DISPLAY));
	((CButton*)GetDlgItem(IDC_CHECK_FRONT_SAVE))->SetCheck(theApp.m_Properties.GetValueDefFalse(FRONT_SAVE));
	((CButton*)GetDlgItem(IDC_CHECK_BACK_SCAN))->SetCheck(theApp.m_Properties.GetValueDefTrue(BACK_SCAN));
	((CButton*)GetDlgItem(IDC_CHECK_BACK_GRAYSCALE))->SetCheck(theApp.m_Properties.GetValueDefFalse(BACK_GRAYSCALE));
	((CButton*)GetDlgItem(IDC_CHECK_BACK_DISPLAY))->SetCheck(theApp.m_Properties.GetValueDefTrue(BACK_DISPLAY));
	((CButton*)GetDlgItem(IDC_CHECK_BACK_SAVE))->SetCheck(theApp.m_Properties.GetValueDefFalse(BACK_SAVE));

	SetFrontEnable(theApp.m_Properties.GetValueDefTrue(FRONT_SCAN));
	SetBackEnable(theApp.m_Properties.GetValueDefTrue(BACK_SCAN));

	return TRUE;
}

// This method is called when the user changed the ScanFunction combobox
void CImageDlg::OnCbnSelchangeComboScanFunc()
{
	UpdateData(TRUE);

	m_Properties.SetValue(SCAN_FUNC, ((CComboBox*)GetDlgItem(IDC_COMBO_SCAN_FUNC))->GetCurSel());

	m_pConfigure->SetEnableApply();
}

// This method is called when the user clicks the Apply button
void CImageDlg::Apply()
{
	theApp.m_Properties.SetProperty(&m_Properties);
}

// 
void CImageDlg::OnBnClickedCheckFrontScan()
{
	UpdateData(TRUE);

	BOOL bScan = ((CButton*)GetDlgItem(IDC_CHECK_FRONT_SCAN))->GetCheck();

	m_Properties.SetValue(FRONT_SCAN, bScan);

	SetFrontEnable(bScan);

	m_pConfigure->SetEnableApply();
}

// 
void CImageDlg::OnBnClickedCheckFrontGrayscale()
{
	UpdateData(TRUE);

	m_Properties.SetValue(FRONT_GRAYSCALE, ((CButton*)GetDlgItem(IDC_CHECK_FRONT_GRAYSCALE))->GetCheck());

	m_pConfigure->SetEnableApply();
}

// 
void CImageDlg::OnBnClickedCheckFrontDisplay()
{
	UpdateData(TRUE);

	m_Properties.SetValue(FRONT_DISPLAY, ((CButton*)GetDlgItem(IDC_CHECK_FRONT_DISPLAY))->GetCheck());

	m_pConfigure->SetEnableApply();
}

// 
void CImageDlg::OnBnClickedCheckFrontSave()
{
	UpdateData(TRUE);

	m_Properties.SetValue(FRONT_SAVE, ((CButton*)GetDlgItem(IDC_CHECK_FRONT_SAVE))->GetCheck());

	m_pConfigure->SetEnableApply();
}

void CImageDlg::OnBnClickedCheckBackScan()
{
	UpdateData(TRUE);

	BOOL bScan = ((CButton*)GetDlgItem(IDC_CHECK_BACK_SCAN))->GetCheck();

	m_Properties.SetValue(BACK_SCAN, bScan);

	SetBackEnable(bScan);

	m_pConfigure->SetEnableApply();
}

void CImageDlg::OnBnClickedCheckBackGrayscale()
{
	UpdateData(TRUE);

	m_Properties.SetValue(BACK_GRAYSCALE, ((CButton*)GetDlgItem(IDC_CHECK_BACK_GRAYSCALE))->GetCheck());

	m_pConfigure->SetEnableApply();
}

void CImageDlg::OnBnClickedCheckBackDisplay()
{
	UpdateData(TRUE);

	m_Properties.SetValue(BACK_DISPLAY, ((CButton*)GetDlgItem(IDC_CHECK_BACK_DISPLAY))->GetCheck());

	m_pConfigure->SetEnableApply();
}

void CImageDlg::OnBnClickedCheckBackSave()
{
	UpdateData(TRUE);

	m_Properties.SetValue(BACK_SAVE, ((CButton*)GetDlgItem(IDC_CHECK_BACK_SAVE))->GetCheck());

	m_pConfigure->SetEnableApply();
}

void CImageDlg::SetFrontEnable(BOOL bEnable)
{
	GetDlgItem(IDC_CHECK_FRONT_GRAYSCALE)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECK_FRONT_DISPLAY)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECK_FRONT_SAVE)->EnableWindow(bEnable);
}

void CImageDlg::SetBackEnable(BOOL bEnable)
{
	GetDlgItem(IDC_CHECK_BACK_GRAYSCALE)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECK_BACK_DISPLAY)->EnableWindow(bEnable);
	GetDlgItem(IDC_CHECK_BACK_SAVE)->EnableWindow(bEnable);
}
