// IqaDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TM-S1000Sample.h"
#include "IqaDlg.h"
#include ".\iqadlg.h"
#include "ConfigureDlg.h"


// CIqaDlg Dialog

IMPLEMENT_DYNAMIC(CIqaDlg, CDialog)
CIqaDlg::CIqaDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIqaDlg::IDD, pParent)
{
}

CIqaDlg::~CIqaDlg()
{
}

void CIqaDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CIqaDlg, CDialog)
	ON_BN_CLICKED(IDC_CHECK_DETECT, OnBnClickedCheckDetect)
	ON_CBN_SELCHANGE(IDC_COMBO_EJECT, OnCbnSelchangeComboEject)
	ON_BN_CLICKED(IDC_CHECK_STAMP, OnBnClickedCheckStamp)
	ON_BN_CLICKED(IDC_CHECK_CANCEL, OnBnClickedCheckCancel)
	ON_BN_CLICKED(IDC_CHECK_GRAY, OnBnClickedCheckGray)
END_MESSAGE_MAP()


// CIqaDlg message handlers
BOOL CIqaDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	((CButton*)GetDlgItem(IDC_CHECK_DETECT))->SetCheck(
		theApp.m_Properties.GetValueDefFalse(IQA_DETECT));

	((CButton*)GetDlgItem(IDC_CHECK_GRAY))->SetCheck(
		theApp.m_Properties.GetValueDefFalse(IQA_GRAYSCALE));

	((CComboBox*)GetDlgItem(IDC_COMBO_EJECT))->SetCurSel(
		theApp.m_Properties.GetValueDefFalse(IQA_EJECT));

	((CButton*)GetDlgItem(IDC_CHECK_STAMP))->SetCheck(
		theApp.m_Properties.GetValueDefFalse(IQA_STAMP));

	((CButton*)GetDlgItem(IDC_CHECK_CANCEL))->SetCheck(
		theApp.m_Properties.GetValueDefFalse(IQA_CANCEL));

	SetEnableItem(theApp.m_Properties.GetValueDefFalse(IQA_DETECT));

	return TRUE;  // return TRUE unless you set the focus to a control
}

// This method is called when the user clicks the Apply button
void CIqaDlg::Apply()
{
	theApp.m_Properties.SetProperty(&m_Properties);
}

void CIqaDlg::SetEnableItem(BOOL bCheck)
{
	((CButton*)GetDlgItem(IDC_CHECK_GRAY))->EnableWindow(bCheck);
	((CComboBox*)GetDlgItem(IDC_COMBO_EJECT))->EnableWindow(bCheck);
	((CButton*)GetDlgItem(IDC_CHECK_STAMP))->EnableWindow(bCheck);
	((CButton*)GetDlgItem(IDC_CHECK_CANCEL))->EnableWindow(bCheck);
}


void CIqaDlg::OnBnClickedCheckDetect()
{
	UpdateData(TRUE);

	int iCheck = ((CButton*)GetDlgItem(IDC_CHECK_DETECT))->GetCheck();

	m_Properties.SetValue(IQA_DETECT, iCheck);

	m_pConfigure->SetEnableApply();

	SetEnableItem(iCheck);
}


void CIqaDlg::OnBnClickedCheckGray()
{
	UpdateData(TRUE);

	int iCheck = ((CButton*)GetDlgItem(IDC_CHECK_GRAY))->GetCheck();

	m_Properties.SetValue(IQA_GRAYSCALE, iCheck);

	m_pConfigure->SetEnableApply();
}

void CIqaDlg::OnCbnSelchangeComboEject()
{
	UpdateData(TRUE);

	m_Properties.SetValue(IQA_EJECT, ((CComboBox*)GetDlgItem(IDC_COMBO_EJECT))->GetCurSel());

	m_pConfigure->SetEnableApply();
}

void CIqaDlg::OnBnClickedCheckStamp()
{
	UpdateData(TRUE);

	int iCheck = ((CButton*)GetDlgItem(IDC_CHECK_STAMP))->GetCheck();

	m_Properties.SetValue(IQA_STAMP, iCheck);

	m_pConfigure->SetEnableApply();
}

void CIqaDlg::OnBnClickedCheckCancel()
{
	UpdateData(TRUE);

	int iCheck = ((CButton*)GetDlgItem(IDC_CHECK_CANCEL))->GetCheck();

	m_Properties.SetValue(IQA_CANCEL, iCheck);

	m_pConfigure->SetEnableApply();
}
