// Waterfall.cpp : implementation file
//

#include "stdafx.h"
#include "TM-S1000Sample.h"
#include "WaterfallDlg.h"
#include ".\waterfalldlg.h"
#include "ConfigureDlg.h"


// CWaterfallDlg Dialog

IMPLEMENT_DYNAMIC(CWaterfallDlg, CDialog)
CWaterfallDlg::CWaterfallDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWaterfallDlg::IDD, pParent)
{
}

CWaterfallDlg::~CWaterfallDlg()
{
}

void CWaterfallDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CWaterfallDlg, CDialog)
	ON_BN_CLICKED(IDC_CHECK_WATERFALL, OnBnClickedCheckWaterfall)
	ON_CBN_SELCHANGE(IDC_COMBO_WATERFALL_MODE, OnCbnSelchangeComboWaterfallMode)
END_MESSAGE_MAP()


// CWaterfallDlg message handlers
BOOL CWaterfallDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	((CButton*)GetDlgItem(IDC_CHECK_WATERFALL))->SetCheck(
		theApp.m_Properties.GetValueDefFalse(WATERFALL_ENABLE));

	((CComboBox*)GetDlgItem(IDC_COMBO_WATERFALL_MODE))->SetCurSel(
		theApp.m_Properties.GetValueDefFalse(WATERFALL_MODE));

	SetEnableItem(theApp.m_Properties.GetValueDefFalse(WATERFALL_ENABLE));

	return TRUE;  // return TRUE unless you set the focus to a control
}

// This method is called when the user clicks the Apply button
void CWaterfallDlg::Apply()
{
	theApp.m_Properties.SetProperty(&m_Properties);
}

void CWaterfallDlg::SetEnableItem(BOOL bCheck)
{
	((CComboBox*)GetDlgItem(IDC_COMBO_WATERFALL_MODE))->EnableWindow(bCheck);
}

void CWaterfallDlg::OnBnClickedCheckWaterfall()
{
	UpdateData(TRUE);

	int iCheck = ((CButton*)GetDlgItem(IDC_CHECK_WATERFALL))->GetCheck();

	m_Properties.SetValue(WATERFALL_ENABLE, iCheck);

	m_pConfigure->SetEnableApply();

	SetEnableItem(iCheck);
}


void CWaterfallDlg::OnCbnSelchangeComboWaterfallMode()
{
	UpdateData(TRUE);

	m_Properties.SetValue(WATERFALL_MODE, ((CComboBox*)GetDlgItem(IDC_COMBO_WATERFALL_MODE))->GetCurSel());

	m_pConfigure->SetEnableApply();
}
