Public Class Properties
    Protected m_Values As Hashtable

    Public Sub New()
        ' this is where we define our default properties
        ' except for this there is no real advantage to having this class defined
        m_Values = New Hashtable
        m_Values.Add("Scan Func", 0)
        m_Values.Add("Scan Front", True)
        m_Values.Add("Front Display", True)
        m_Values.Add("Scan Back", True)
        m_Values.Add("Back Display", True)
        m_Values.Add("MICR", True)
        m_Values.Add("OCR", True)
    End Sub

    Public Sub New(ByVal source As Properties)
        m_Values = source.m_Values
    End Sub

    ' Binding acquisition of each value
    Default Property Value(ByVal name As String) As Integer
        Get
            ' If name agrees return the value
            If (m_Values.Contains(name)) Then
                Return m_Values.Item(name)
            End If
            Return False
        End Get
        Set(ByVal Value As Integer)
            ' If name agrees I renew the value
            If (m_Values.Contains(name)) Then
                m_Values.Item(name) = Value
            ElseIf Value Then
                ' It adds it with the value, if name is not discovered
                m_Values.Add(name, Value)
            End If
        End Set
    End Property

End Class
