VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ApiUsage"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Dim ErrorCode As ErrorCode
Dim m_lHandle As Long
Dim m_objNull As Object
Dim m_objmfBase01 As MF_BASE01
Dim m_objmfMicr As MF_MICR
Dim m_objmfScanFront As MF_SCAN
Dim m_objmfScanBack As MF_SCAN
Dim m_objmfPrint01 As MF_PRINT01
Dim m_objmfProcess As MF_PROCESS
Public m_objMainFrom As TMS1000SampleForm
Dim m_errResultCode As Long
Dim m_lTransactionNumber As Long
Dim m_iMainStatus As Integer
Dim m_iSubStatus As Integer

Private Sub Class_Initialize()
    Set ErrorCode = New ErrorCode
            
    Call CopyMemory(m_objmfBase01.iSize(1), CLng(LenB(m_objmfBase01)), 4)
    Call CopyMemory(m_objmfBase01.iVersion(1), MF_BASE_VERSION01, 4)
    Call CopyMemory(m_objmfMicr.iSize(1), CLng(LenB(m_objmfMicr)), 4)
    Call CopyMemory(m_objmfMicr.iVersion(1), MF_MICR_VERSION, 4)
    Call CopyMemory(m_objmfScanFront.iSize(1), CLng(LenB(m_objmfScanFront)), 4)
    Call CopyMemory(m_objmfScanFront.iVersion(1), MF_SCAN_VERSION, 4)
    Call CopyMemory(m_objmfScanBack.iSize(1), CLng(LenB(m_objmfScanBack)), 4)
    Call CopyMemory(m_objmfScanBack.iVersion(1), MF_SCAN_VERSION, 4)
    Call CopyMemory(m_objmfPrint01.iSize(1), CLng(LenB(m_objmfPrint01)), 4)
    Call CopyMemory(m_objmfPrint01.iVersion(1), MF_PRINT_VERSION01, 4)
    Call CopyMemory(m_objmfProcess.iSize(1), CLng(LenB(m_objmfProcess)), 4)
    Call CopyMemory(m_objmfProcess.iVersion(1), MF_PROCESS_VERSION, 4)
    
    m_errResultCode = BiESCNEnable(CROP_STORE_MEMORY)
    
    ' Connect to the printer
    m_lHandle = BiOpenMonPrinter(TYPE_PRINTER, "TM-S1000U")
    If (m_lHandle < SUCCESS) Then
        If (CheckResponse(m_lHandle, "Unable to connect to printer" & vbNewLine & vbNewLine & _
                    "Ensure Driver installed correctly" & vbNewLine & "and Printer is powered on")) Then
            Exit Sub
        End If
    End If
End Sub

' this method configures the parameters used while scanning single checks
' primarily the BiSCNMICRFunctionPostPrint method is used
Public Sub Configure()

    ' Base
    If (CheckResponse(FunctionPostPrintBase(m_lHandle, m_objmfBase01, MF_GET_BASE_DEFAULT), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfBase01, MF_GET_BASE_DEFAULT)")) Then
        Exit Sub
    End If
    If (CheckResponse(FunctionPostPrintBase(m_lHandle, m_objmfBase01, MF_SET_BASE_PARAM), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfBase01, MF_SET_BASE_PARAM)")) Then
        Exit Sub
    End If

    ' Micr
    If (CheckResponse(FunctionPostPrintMicr(m_lHandle, m_objmfMicr, MF_GET_MICR_DEFAULT), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfMicr, MF_GET_MICR_DEFAULT)")) Then
        Exit Sub
    End If
    If (CheckResponse(FunctionPostPrintMicr(m_lHandle, m_objmfMicr, MF_SET_MICR_PARAM), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfMicr, MF_SET_MICR_PARAM)")) Then
        Exit Sub
    End If

    ' ScanFront
    If (CheckResponse(FunctionPostPrintScan(m_lHandle, m_objmfScanFront, MF_GET_SCAN_FRONT_DEFAULT), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfScanFront, MF_GET_SCAN_FRONT_DEFAULT)")) Then
        Exit Sub
    End If
    If (CheckResponse(FunctionPostPrintScan(m_lHandle, m_objmfScanFront, MF_SET_SCAN_FRONT_PARAM), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfScanFront, MF_SET_SCAN_FRONT_PARAM)")) Then
        Exit Sub
    End If

    ' ScanBack
    If (CheckResponse(FunctionPostPrintScan(m_lHandle, m_objmfScanBack, MF_GET_SCAN_BACK_DEFAULT), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfScanBack, MF_GET_SCAN_BACK_DEFAULT)")) Then
        Exit Sub
    End If
    If (CheckResponse(FunctionPostPrintScan(m_lHandle, m_objmfScanBack, MF_SET_SCAN_BACK_PARAM), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfScanBack, MF_SET_SCAN_BACK_PARAM)")) Then
        Exit Sub
    End If

    ' Print
    If (CheckResponse(FunctionPostPrintPrint(m_lHandle, m_objmfPrint01, MF_GET_PRINT_DEFAULT), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfPrint01, MF_GET_PRINT_DEFAULT)")) Then
        Exit Sub
    End If
    Dim strTmp As String
    strTmp = ""
    ' An error when the m_objmfPrint01.String array is all NULL
    Call CopyMemory(m_objmfPrint01.lpString(1), strTmp, 4) ' Specify blank characters
    If (CheckResponse(FunctionPostPrintPrint(m_lHandle, m_objmfPrint01, MF_SET_PRINT_PARAM), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfPrint01, MF_SET_PRINT_PARAM)")) Then
        Exit Sub
    End If

    ' Process
    If (CheckResponse(FunctionPostPrintProcess(m_lHandle, m_objmfProcess, MF_GET_PROCESS_DEFAULT), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfProcess, MF_GET_PROCESS_DEFAULT)")) Then
        Exit Sub
    End If
    If (CheckResponse(FunctionPostPrintProcess(m_lHandle, m_objmfProcess, MF_SET_PROCESS_PARAM), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfProcess, MF_SET_PROCESS_PARAM)")) Then
        Exit Sub
    End If

End Sub
    
' This method is called when the user clicks the scan button
' operation is offloaded to the correct Scan function
Public Sub Scan()
    If (CheckResponse(BiSCNMICRFunctionPostPrint(m_lHandle, m_objNull, MF_EXEC), _
                    "BiSCNMICRFunctionPostPrint(m_lHandle, Null, MF_EXEC)")) Then
        m_objMainFrom.Complate (0)
    End If
End Sub

' this method is called when the user click the cancel button
Public Sub Cancel()
    If (CheckResponse(BiSCNMICRCancelFunction(m_lHandle, MF_EJECT_DISCHARGE), _
                        "BiSCNMICRCancelFunction(m_lHandle, MF_EJECT_DISCHARGE)")) Then
    End If
End Sub

' this method is called when the user click the exit button
Public Sub ScanEnd()
    If Not (m_lHandle < 1) Then
        m_errResultCode = BiSCNMICRCancelStatusBack(m_lHandle)
        m_errResultCode = BiSCNMICRCancelFunction(m_lHandle, MF_EJECT_DISCHARGE)
        m_errResultCode = BiCloseMonPrinter(m_lHandle)
        m_lHandle = 0
    End If
End Sub

' This method is called whenever the scan state changes
Public Sub MICRStatusCallback()
    ' Finish scan process
    If (m_iMainStatus = MF_FUNCTION_DONE) Then
        m_objMainFrom.Complate (m_lTransactionNumber)
    End If
End Sub

' this method is return response
' SUCCESS : Return to FALSE
' ERROR : Display the message box, return TRUE
Private Property Get CheckResponse(ByVal Error As Long, ByVal str As String) As Boolean
    If Not (Error = 0) Then
        Dim strError As String
        strError = ErrorCode.ChangeErrorCode(Error)
        Call MsgBox(str, vbOKOnly, strError)
        CheckResponse = True
        Exit Property
    End If
    CheckResponse = False
End Property

' Register the callback destination
Public Sub SetStatusBackWnd()
    If (m_lHandle < SUCCESS) Then
        Exit Sub
    End If
    
    If (CheckResponse(BiSCNMICRSetStatusBackWnd(m_lHandle, m_objMainFrom.btnMicrStatusBack.hWnd, m_lTransactionNumber, m_iMainStatus, m_iSubStatus), _
                    "BiSCNMICRSetStatusBackWnd")) Then
        Exit Sub
    End If
End Sub

