VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ApiUsage"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Dim ErrorCode As ErrorCode
Dim m_lHandle As Long
Dim m_objNull As Object
Dim m_objmfBase01 As MF_BASE01
Dim m_objmfMicr As MF_MICR
Dim m_objmfScanFront As MF_SCAN
Dim m_objmfScanBack As MF_SCAN
Dim m_objmfPrint01 As MF_PRINT01
Dim m_objmfProcess As MF_PROCESS
Public m_objMainForm As TMS1000SampleForm
Dim m_lResultCode As Long
Dim m_lTransactionNumber As Long
Dim m_iMainStatus As Integer
Dim m_iSubStatus As Integer
Public m_objConfig As PropertiseClass

Private Sub Class_Initialize()
    Set ErrorCode = New ErrorCode
    
    Set m_objConfig = New PropertiseClass
            
    Call CopyMemory(m_objmfBase01.iSize(1), CLng(LenB(m_objmfBase01)), 4)
    Call CopyMemory(m_objmfBase01.iVersion(1), MF_BASE_VERSION01, 4)
    Call CopyMemory(m_objmfMicr.iSize(1), CLng(LenB(m_objmfMicr)), 4)
    Call CopyMemory(m_objmfMicr.iVersion(1), MF_MICR_VERSION, 4)
    Call CopyMemory(m_objmfScanFront.iSize(1), CLng(LenB(m_objmfScanFront)), 4)
    Call CopyMemory(m_objmfScanFront.iVersion(1), MF_SCAN_VERSION, 4)
    Call CopyMemory(m_objmfScanBack.iSize(1), CLng(LenB(m_objmfScanBack)), 4)
    Call CopyMemory(m_objmfScanBack.iVersion(1), MF_SCAN_VERSION, 4)
    Call CopyMemory(m_objmfPrint01.iSize(1), CLng(LenB(m_objmfPrint01)), 4)
    Call CopyMemory(m_objmfPrint01.iVersion(1), MF_PRINT_VERSION01, 4)
    Call CopyMemory(m_objmfProcess.iSize(1), CLng(LenB(m_objmfProcess)), 4)
    Call CopyMemory(m_objmfProcess.iVersion(1), MF_PROCESS_VERSION, 4)
    
    m_lResultCode = BiESCNEnable(CROP_STORE_MEMORY)
    
    ' Connect to the printer
    m_lHandle = BiOpenMonPrinter(TYPE_PRINTER, "TM-S1000U")
    If (m_lHandle < SUCCESS) Then
        If (CheckResponse(m_lHandle, "Unable to connect to printer" & vbNewLine & vbNewLine & _
                    "Ensure Driver installed correctly" & vbNewLine & "and Printer is powered on")) Then
            Exit Sub
        End If
    End If
End Sub

' this method configures the parameters used while scanning single checks
' primarily the BiSCNMICRFunctionPostPrint method is used
Public Sub Configure()

    ' DPI setting method
    ' Specify MF_SCAN_DPI_XXX in sResolution of the MF_SCAN structure
    ' Execute BiSCNMICRFunctionXXX
    ' * Execute before scanning

    ' Sharpening setting method
    ' Specify EPS_BI_SCN_XXX as the 5th parameter of BiSCNSetImageQuality and   execute it (other parameters are discretionary)
    ' * Execute before scanning

    ' Setting method for multiple electronic endorsements
    ' Execute MF_PRT_BUFFERING with BiBufferedPrint
    ' Set multiple electronic endorsements
    ' Execute MF_PRT_EXEC with BiBufferedPrint
    ' * Execute before scanning

    ' Set station electronic endorse
    If (CheckResponse(BiSetPrintStation(m_lHandle, MF_ST_E_ENDORSEMENT), "BiSetPrintStation(m_lHandle, MF_ST_E_ENDORSEMENT)")) Then
        Exit Sub
    End If
   

    ' the registered electronic endorsement
    If (CheckResponse(BiBufferedPrint(m_lHandle, MF_PRT_CLEAR), _
                        "BiBufferedPrint(m_lHandle, MF_PRT_CLEAR)")) Then
        Exit Sub
    End If

    Select Case (m_objConfig.GetValue(SCAN_FUNC))
    Case 0
        Call ConfigureMulti
    Case 1
        Call ConfigureSingle
    Case Else
         Call ConfigureMulti
   End Select
End Sub

' this method is settings of multi scan
' primarily the BiSCNMICRFunctionContinuously method is used
Private Sub ConfigureMulti()
    ' Base
    If (CheckResponse(FunctionContinuouslyBase(m_lHandle, m_objmfBase01, MF_GET_BASE_DEFAULT), _
                        "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfBase01, MF_GET_BASE_DEFAULT)")) Then
        Exit Sub
    End If
    If (CheckResponse(FunctionContinuouslyBase(m_lHandle, m_objmfBase01, MF_SET_BASE_PARAM), _
                        "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfBase01, MF_SET_BASE_PARAM)")) Then
        Exit Sub
    End If

    ' Micr
    If (CheckResponse(FunctionContinuouslyMicr(m_lHandle, m_objmfMicr, MF_GET_MICR_DEFAULT), _
                        "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfMicr, MF_GET_MICR_DEFAULT)")) Then
        Exit Sub
    End If
    If (CheckResponse(FunctionContinuouslyMicr(m_lHandle, m_objmfMicr, MF_SET_MICR_PARAM), _
                        "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfMicr, MF_SET_MICR_PARAM)")) Then
        Exit Sub
    End If

    ' ScanFront
    If (CheckResponse(FunctionContinuouslyScan(m_lHandle, m_objmfScanFront, MF_GET_SCAN_FRONT_DEFAULT), _
                        "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfScanFront, MF_GET_SCAN_FRONT_DEFAULT)")) Then
        Exit Sub
    End If
    If (CheckResponse(FunctionContinuouslyScan(m_lHandle, m_objmfScanFront, MF_SET_SCAN_FRONT_PARAM), _
                        "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfScanFront, MF_SET_SCAN_FRONT_PARAM)")) Then
        Exit Sub
    End If

    ' ScanBack
    If (CheckResponse(FunctionContinuouslyScan(m_lHandle, m_objmfScanBack, MF_GET_SCAN_BACK_DEFAULT), _
                        "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfScanBack, MF_GET_SCAN_BACK_DEFAULT)")) Then
        Exit Sub
    End If
    If (CheckResponse(FunctionContinuouslyScan(m_lHandle, m_objmfScanBack, MF_SET_SCAN_BACK_PARAM), _
                        "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfScanBack, MF_SET_SCAN_BACK_PARAM)")) Then
        Exit Sub
    End If

    ' Print
    If (CheckResponse(FunctionContinuouslyPrint(m_lHandle, m_objmfPrint01, MF_GET_PRINT_DEFAULT), _
                        "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfPrint01, MF_GET_PRINT_DEFAULT)")) Then
        Exit Sub
    End If
    Dim strTmp As String
    strTmp = ""
    ' An error when the m_objmfPrint01.String array is all NULL
    Call CopyMemory(m_objmfPrint01.lpString(1), strTmp, 4) ' Specify blank characters
    If (CheckResponse(FunctionContinuouslyPrint(m_lHandle, m_objmfPrint01, MF_SET_PRINT_PARAM), _
                        "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfPrint01, MF_SET_PRINT_PARAM)")) Then
        Exit Sub
    End If

    ' Process
    If (CheckResponse(FunctionContinuouslyProcess(m_lHandle, m_objmfProcess, MF_GET_PROCESS_DEFAULT), _
                        "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfProcess, MF_GET_PROCESS_DEFAULT)")) Then
        Exit Sub
    End If
    If (CheckResponse(FunctionContinuouslyProcess(m_lHandle, m_objmfProcess, MF_SET_PROCESS_PARAM), _
                        "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfProcess, MF_SET_PROCESS_PARAM)")) Then
        Exit Sub
    End If
    
    ' Set the endorsement
    If (m_objConfig.GetValue(ELE_ENDORSE_IMAGE)) Then
        ' Set the electronic endorsement
        If (CheckResponse(BiBufferedPrint(m_lHandle, MF_PRT_BUFFERING), "BiBufferedprint(m_lHandle, MF_PRT_BUFFERING)")) Then
            Exit Sub
        End If
        
        ' Set the image electronic endorsement
        ElectricEndorseImage
        
        ' Register the electronic endorsement set
        If (CheckResponse(BiBufferedPrint(m_lHandle, MF_PRT_EXEC), "Bibufferedprint(m_lHandle, MF_PRT_EXEC)")) Then
            Exit Sub
        End If
    End If
End Sub

' this method is settings of single scan
' primarily the BiSCNMICRFunctionPostPrint method is used
Private Sub ConfigureSingle()
    ' Base
    If (CheckResponse(FunctionPostPrintBase(m_lHandle, m_objmfBase01, MF_GET_BASE_DEFAULT), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfBase01, MF_GET_BASE_DEFAULT)")) Then
        Exit Sub
    End If
    If (CheckResponse(FunctionPostPrintBase(m_lHandle, m_objmfBase01, MF_SET_BASE_PARAM), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfBase01, MF_SET_BASE_PARAM)")) Then
        Exit Sub
    End If

    ' Micr
    If (CheckResponse(FunctionPostPrintMicr(m_lHandle, m_objmfMicr, MF_GET_MICR_DEFAULT), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfMicr, MF_GET_MICR_DEFAULT)")) Then
        Exit Sub
    End If
    If (CheckResponse(FunctionPostPrintMicr(m_lHandle, m_objmfMicr, MF_SET_MICR_PARAM), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfMicr, MF_SET_MICR_PARAM)")) Then
        Exit Sub
    End If

    ' ScanFront
    If (CheckResponse(FunctionPostPrintScan(m_lHandle, m_objmfScanFront, MF_GET_SCAN_FRONT_DEFAULT), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfScanFront, MF_GET_SCAN_FRONT_DEFAULT)")) Then
        Exit Sub
    End If
    If (CheckResponse(FunctionPostPrintScan(m_lHandle, m_objmfScanFront, MF_SET_SCAN_FRONT_PARAM), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfScanFront, MF_SET_SCAN_FRONT_PARAM)")) Then
        Exit Sub
    End If

    ' ScanBack
    If (CheckResponse(FunctionPostPrintScan(m_lHandle, m_objmfScanBack, MF_GET_SCAN_BACK_DEFAULT), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfScanBack, MF_GET_SCAN_BACK_DEFAULT)")) Then
        Exit Sub
    End If
    If (CheckResponse(FunctionPostPrintScan(m_lHandle, m_objmfScanBack, MF_SET_SCAN_BACK_PARAM), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfScanBack, MF_SET_SCAN_BACK_PARAM)")) Then
        Exit Sub
    End If

    ' Print
    If (CheckResponse(FunctionPostPrintPrint(m_lHandle, m_objmfPrint01, MF_GET_PRINT_DEFAULT), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfPrint01, MF_GET_PRINT_DEFAULT)")) Then
        Exit Sub
    End If
    Dim strTmp As String
    strTmp = ""
    ' An error when the m_objmfPrint01.String array is all NULL
    Call CopyMemory(m_objmfPrint01.lpString(1), strTmp, 4) ' Specify blank characters
    If (CheckResponse(FunctionPostPrintPrint(m_lHandle, m_objmfPrint01, MF_SET_PRINT_PARAM), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfPrint01, MF_SET_PRINT_PARAM)")) Then
        Exit Sub
    End If

    ' Process
    If (CheckResponse(FunctionPostPrintProcess(m_lHandle, m_objmfProcess, MF_GET_PROCESS_DEFAULT), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfProcess, MF_GET_PROCESS_DEFAULT)")) Then
        Exit Sub
    End If
    If (CheckResponse(FunctionPostPrintProcess(m_lHandle, m_objmfProcess, MF_SET_PROCESS_PARAM), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfProcess, MF_SET_PROCESS_PARAM)")) Then
        Exit Sub
    End If
    
    ' Set the endorsement
    If (m_objConfig.GetValue(ELE_ENDORSE_IMAGE)) Then
        ' Set the electronic endorsement
        If (CheckResponse(BiBufferedPrint(m_lHandle, MF_PRT_BUFFERING), "BiBufferedprint(m_lHandle, MF_PRT_BUFFERING)")) Then
            Exit Sub
        End If
        
        ' Set the image electronic endorsement
        ElectricEndorseImage
        
        ' Register the electronic endorsement set
        If (CheckResponse(BiBufferedPrint(m_lHandle, MF_PRT_EXEC), "Bibufferedprint(m_lHandle, MF_PRT_EXEC)")) Then
            Exit Sub
        End If
    End If
End Sub

    
' This method is called when the user clicks the scan button
' operation is offloaded to the correct Scan function
Public Sub Scan()
    Select Case (m_objConfig.GetValue(SCAN_FUNC))
    Case 0
        Call ScanMulti
    Case 1
        Call ScanSingle
    Case Else
        Call ScanMulti
    End Select
End Sub

' this method performs scanning of a multi check
Private Sub ScanMulti()
    If (CheckResponse(BiSCNMICRFunctionContinuously(m_lHandle, m_objNull, MF_EXEC), _
                    "BiSCNMICRFunctionContinuously(m_lHandle, Null, MF_EXEC)")) Then
        m_objMainForm.Complate (0)
    End If
End Sub

' this method performs scanning of a single check
Private Sub ScanSingle()
    If (CheckResponse(BiSCNMICRFunctionPostPrint(m_lHandle, m_objNull, MF_EXEC), _
                    "BiSCNMICRFunctionPostPrint(m_lHandle, Null, MF_EXEC)")) Then
        m_objMainForm.Complate (0)
    End If
End Sub

' this method is called when the user click the cancel button
Public Sub Cancel()
    If (CheckResponse(BiSCNMICRCancelFunction(m_lHandle, MF_EJECT_DISCHARGE), _
                        "BiSCNMICRCancelFunction(m_lHandle, MF_EJECT_DISCHARGE)")) Then
    End If
End Sub

' this method is called when the user click the exit button
Public Sub ScanEnd()
    If Not (m_lHandle < 1) Then
        m_lResultCode = BiSCNMICRCancelStatusBack(m_lHandle)
        m_lResultCode = BiSCNMICRCancelFunction(m_lHandle, MF_EJECT_DISCHARGE)
        m_lResultCode = BiCloseMonPrinter(m_lHandle)
        m_lHandle = 0
    End If
End Sub

' This method is called whenever the scan state changes
' Called when scanning with BiSCNMICRFunctionPostPrint/BiSCNMICRFunctionContinuously
Public Sub MicrStatusCallback()
    ' Finish scan process
    If (m_iMainStatus = MF_FUNCTION_DONE) Then
        m_objMainForm.Complate (m_lTransactionNumber)
    End If
    
    ' Data receive complete
    If (m_iMainStatus = MF_DATARECEIVE_DONE) Then
        ' get MICR data
        Dim nRet As Integer
        Dim strMicr As String
        Dim nCount As Integer
        Dim nResultCode As Long
        Dim lAddress As Long
        
        ' Specify the relevant item for MICR text
        m_objmfMicr.bMicOcrSelect = MF_MICR_USE_MICR
        Call CopyMemory(m_objmfMicr.blParsing(1), False, 4)
        ' Acquire MICR text
        m_lResultCode = BiGetMicrText(m_lHandle, m_lTransactionNumber, m_objmfMicr)
        ' Change string to ASCII
        m_objMainForm.MicrText.Text = StrToAsc(m_objmfMicr.szMicrStr, MF_MICR_CHAR_MAX)
        strMicr = m_objMainForm.MicrText.Text
        Call CopyMemory(nResultCode, m_objmfMicr.iRet(1), 4)
        If Not (nResultCode = SUCCESS) Then
            ' Add error code
            strMicr = strMicr + "(" + ErrorCode.ChangeErrorCode(nResultCode) + ")"
        End If
        m_objMainForm.MicrText.Text = strMicr
        
        ' get front image
        ' Set the relevant item for the front side image
        m_lResultCode = BiSCNSelectScanFace(m_lHandle, MF_SCAN_FACE_FRONT)
        If (m_lResultCode = SUCCESS) Then
            ' Specify the file format in BMP
            m_lResultCode = BiSCNSetImageFormat(m_lHandle, EPS_BI_SCN_BITMAP)
            If (m_lResultCode = SUCCESS) Then
                ' Acquire image data
                m_lResultCode = BiGetScanImage(m_lHandle, m_lTransactionNumber, m_objmfScanFront)
                If (m_lResultCode = SUCCESS) Then
                    Call CopyMemory(lAddress, m_objmfScanFront.lpbScanData(1), 4)
                    Call m_objMainForm.SetImage(lAddress, m_objmfScanFront.dwScanSize, True)
                    If Not (lAddress = 0) Then
                        Call GlobalFree(lAddress)
                    End If
                End If
            End If
        End If
        
        ' set endorse
        If (m_objConfig.GetValue(ELE_ENDORSE_TEXT)) Then
            ElectricEndorseText
        End If
        
        ' get back image
        ' Set the relevant item for the front side
        m_lResultCode = BiSCNSelectScanFace(m_lHandle, MF_SCAN_FACE_BACK)
        If (m_lResultCode = SUCCESS) Then
            ' Specify the file format in BMP
            m_lResultCode = BiSCNSetImageFormat(m_lHandle, EPS_BI_SCN_BITMAP)
            If (m_lResultCode = SUCCESS) Then
                ' Acquire image data
                m_lResultCode = BiGetScanImage(m_lHandle, m_lTransactionNumber, m_objmfScanBack)
                If (m_lResultCode = SUCCESS) Then
                    Call CopyMemory(lAddress, m_objmfScanBack.lpbScanData(1), 4)
                    Call m_objMainForm.SetImage(lAddress, m_objmfScanBack.dwScanSize, False)
                    If Not (lAddress = 0) Then
                        Call GlobalFree(lAddress)
                    End If
                End If
            End If
        End If
    End If
    
End Sub

' this method is return response
' SUCCESS : Return to FALSE
' ERROR : Display the message box, return TRUE
Private Property Get CheckResponse(ByVal Error As Long, ByVal str As String) As Boolean
    If Not (Error = 0) Then
        Dim strError As String
        strError = ErrorCode.ChangeErrorCode(Error)
        Call MsgBox(str, vbOKOnly, strError)
        CheckResponse = True
        Exit Property
    End If
    CheckResponse = False
End Property

' Register the callback destination
Public Sub SetStatusBackWnd()
    If (m_lHandle < SUCCESS) Then
        Exit Sub
    End If
    If (CheckResponse(BiSCNMICRSetStatusBackWnd(m_lHandle, m_objMainForm.btnMicrStatusBack.hwnd, m_lTransactionNumber, m_iMainStatus, m_iSubStatus), _
                    "BiSCNMICRSetStatusBackWnd")) Then
        Exit Sub
    End If
End Sub

' this method is return transaction number
Public Property Get GetTransactionNumber() As Long
    Dim m_lTransactionNumber As Long
    m_lResultCode = BiGetTransactionNumber(m_lHandle, m_lTransactionNumber)
    GetTransactionNumber = m_lTransactionNumber
End Property

' Byte is converted to ASCII
Private Property Get StrToAsc(ByRef byData() As Byte, ByVal lSize As Long) As String
    Dim lCount As Long
    Dim strAsc As String
    lCount = 0
    Do While (lCount < lSize)
        strAsc = strAsc + Chr(byData(lCount + 1))
        lCount = lCount + 1
    Loop
    StrToAsc = strAsc
End Property

' settings endorse text
Private Sub ElectricEndorseText()
    Dim mfDecorate As MF_DECORATE
    Dim strText As String

    Call CopyMemory(mfDecorate.lAttribute(1), MF_PRINT_COLOR, 4)
    Call CopyMemory(mfDecorate.wFont(1), MF_PRINT_SYSTEMFONT, 2)
    Call CopyMemory(mfDecorate.wFontSize(1), 30, 2)
    strText = "Transaction#:<00000000>"

    ' set position
    If (CheckResponse(BiSetPrintPosition(m_lHandle, 10, 60), "BiPrintPosition(m_lHandle, 10, 60)")) Then
        Exit Sub
    End If

    ' Call wrapper for VB
    ' BiPrintText calls it through BiPrintTextToVB of VBWrapper
    If (CheckResponse(BiPrintTextToVB(m_lHandle, strText, mfDecorate), "BiPrintText(m_lHandle, szText, mfDecorate)")) Then
        Exit Sub
    End If
End Sub
    
' settings endorse image
Private Sub ElectricEndorseImage()
    ' set position
    If (CheckResponse(BiSetPrintPosition(m_lHandle, 100, 30), "BiPrintPosition(m_lHandle, 100, 30)")) Then
        Exit Sub
    End If
    
    ' set size
    If (CheckResponse(BiSetPrintSize(m_lHandle, 30, 30), "BiSetPrintSize(m_lHandle, 30, 30)")) Then
        Exit Sub
    End If
    
    If (CheckResponse(BiPrintImage(m_lHandle, App.Path + "\Image.JPG"), "BiPrintImage(m_lHandle, Image.JPG")) Then
        Exit Sub
    End If
End Sub

Public Property Get GetStartWaitTime() As Long
    Dim lStartWaitTime As Long
    lStartWaitTime = 0
    Call CopyMemory(lStartWaitTime, m_objmfProcess.dwStartWaitTime(1), 4)
    If lStartWaitTime > 6400 Then
        lStartWaitTime = 6400
    End If
    GetStartWaitTime = lStartWaitTime
End Property
