VERSION 5.00
Begin VB.Form TMS1000SampleForm 
   BorderStyle     =   1  'Fixed (unbroken line)
   Caption         =   "TM-S1000SampleStep4"
   ClientHeight    =   7650
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   7110
   Icon            =   "TMS1000SampleForm.frx":0000
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   7650
   ScaleWidth      =   7110
   Begin VB.CommandButton btnCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   3840
      TabIndex        =   3
      Top             =   6960
      Width           =   1215
   End
   Begin VB.CommandButton btnConfigure 
      Caption         =   "Configure"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   6960
      Width           =   1215
   End
   Begin VB.PictureBox BackPicture 
      Height          =   3135
      Left            =   120
      ScaleHeight     =   3075
      ScaleWidth      =   6795
      TabIndex        =   8
      TabStop         =   0   'False
      Top             =   3720
      Width           =   6855
   End
   Begin VB.PictureBox FrontPicture 
      Height          =   3135
      Left            =   120
      ScaleHeight     =   3075
      ScaleWidth      =   6795
      TabIndex        =   7
      TabStop         =   0   'False
      Top             =   600
      Width           =   6855
   End
   Begin VB.TextBox MicrText 
      Height          =   375
      Left            =   960
      Locked          =   -1  'True
      TabIndex        =   5
      TabStop         =   0   'False
      Top             =   120
      Width           =   6015
   End
   Begin VB.CommandButton btnExit 
      Caption         =   "Exit"
      Height          =   375
      Left            =   5760
      TabIndex        =   4
      Top             =   6960
      Width           =   1215
   End
   Begin VB.CommandButton btnScan 
      Caption         =   "Scan"
      Height          =   375
      Left            =   1920
      TabIndex        =   2
      Top             =   6960
      Width           =   1215
   End
   Begin VB.CommandButton btnMicrStatusBack 
      Caption         =   "MSB"
      Height          =   255
      Left            =   6600
      TabIndex        =   0
      Top             =   7440
      Width           =   495
   End
   Begin VB.Label Label1 
      Caption         =   "MICR data"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   240
      Width           =   855
   End
End
Attribute VB_Name = "TMS1000SampleForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim m_objApi As ApiUsage
Dim m_objConfig As PropertiseClass
Dim m_lTransactionNumber As Long
Dim m_lScanStartTime As Long

Private Sub btnCancel_Click()
    m_objApi.Cancel
End Sub

' this method is called when the user click the configure button
Private Sub btnConfigure_Click()
    Dim Dlg As ConfigureForm
    Set Dlg = New ConfigureForm
    Set Dlg.m_objConfig = m_objConfig
    Dlg.Show vbModal
    Set m_objConfig = Dlg.GetProp()
    Set m_objApi.m_objConfig = m_objConfig
    m_objApi.Configure
End Sub

' Called when scanning with BiSCNMICRFunctionPostPrint/BiSCNMICRFunctionContinuously
Private Sub btnMicrStatusBack_Click()
    m_objApi.MicrStatusCallback
End Sub

Private Sub Form_Load()
    btnMicrStatusBack.Enabled = False
    Set m_objApi = New ApiUsage
    Set m_objConfig = New PropertiseClass
    Set m_objApi.m_objMainForm = Me
    Set m_objApi.m_objConfig = m_objConfig
    m_objApi.SetStatusBackWnd
    m_objApi.Configure
End Sub

' this method is called when the user click the scan button
Private Sub btnScan_Click()
    btnScan.Enabled = False
    btnConfigure.Enabled = False
    Me.Caption = "TM-S1000SampleStep4"
    MicrText.Text = ""
    FrontPicture.Cls
    BackPicture.Cls

    m_lTransactionNumber = m_objApi.GetTransactionNumber
    m_lScanStartTime = GetTickCount()

    m_objApi.Scan
End Sub

' This method is called when the Complete scan
Public Sub Complate(ByVal lastTransactionNumber As Integer)
    Dim ProcessTime As Long
    Dim rate As Double
    Dim Count As Integer
    
    ' Calculation as a result of measuring
    ProcessTime = GetTickCount() - m_lScanStartTime
    If Not (ProcessTime = 0) Then
        ProcessTime = ProcessTime - m_objApi.GetStartWaitTime
        Count = lastTransactionNumber - m_lTransactionNumber + 1
        rate = 60000 * Count / ProcessTime
    End If
    Me.Caption = "TM-S1000SampleStep4 - Scan Complete(" + CStr(Count) + " @ " + Format(rate, "0.00") + " DPM )"
    btnScan.Enabled = True
    btnConfigure.Enabled = True
End Sub

' this method is called when the user click the exit button
Private Sub btnExit_Click()
    Unload Me
End Sub

' this method is called when the user click the close button
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    FrontPicture.Cls
    BackPicture.Cls
    m_objApi.ScanEnd
End Sub

' this method is settings image data
Public Sub SetImage(ByVal DataPoint As Long, ByRef pSize() As Byte, ByVal bFace As Boolean)
    Dim pDC As Long
    Dim lRet As Long
    Dim lSize As Long
    Dim pBI As BITMAPINFO
    Dim pBFH As BITMAPFILEHEADER
    Dim pRGB As RGBQUAD
    Dim lImageData As Long
    Dim Image As Long
    Dim BIbuf(LenB(pBI)) As Byte
    
    Call CopyMemory(lSize, pSize(1), 4)

    If Not (DataPoint = 0) Then
        If Not (lSize = 0) Then
            Dim hdc As Long
            hdc = GetDC(Me.hwnd)
            Dim lReadSize As Long
            ' Copy BITMAPINFO data to pBI
            Dim lProcessID As Long
            Call GetWindowThreadProcessId(hwnd, lProcessID)
            Dim ProcessHandle As Long
            ProcessHandle = OpenProcess(16, False, lProcessID)
            Call ReadProcessMemory(ProcessHandle, ByVal DataPoint + LenB(pBFH), BIbuf(0), LenB(pBI), lReadSize)

            Call CopyMemory(pBI, BIbuf(0), LenB(pBI))
            
            ' Starting position of image data is bound to lImageData
            lImageData = DataPoint + (LenB(pBFH) + pBI.bmiHeader.biSize + (2 * LenB(pRGB)))
            Image = CreateDIBitmap(hdc, pBI.bmiHeader, CBM_INIT, lImageData, pBI, DIB_RGB_COLORS)
            Call ReleaseDC(Me.hwnd, hdc)
        End If
    End If

    If (bFace) Then
        ' Front
        Call DisplayImage(FrontPicture, Image)
    Else
        ' Back
        Call DisplayImage(BackPicture, Image)
    End If

    If Not (Image = 0) Then
        Call DeleteObject(Image)
        Image = 0
    End If
    
End Sub

' this method is display Image
Private Sub DisplayImage(ByVal Picture As PictureBox, ByVal lImage As Long)
    Picture.Cls
    If (lImage = 0) Then
        Exit Sub
    End If

    Dim lRet As Long
    Dim ImageDC As Long
    Dim Bmp As BITMAP
        
    ImageDC = CreateCompatibleDC(Picture.hdc)
    lRet = SelectObject(ImageDC, lImage)
    
    Picture.AutoRedraw = True
    If Not (GetObject(lImage, LenB(Bmp), Bmp) = 0) Then
        Dim lPicWidth As Long
        Dim lPicHeight As Long
        Dim rectPict As RECT
        
        Call GetClientRect(Picture.hwnd, rectPict)
        lPicWidth = rectPict.Right - rectPict.Left
        lPicHeight = rectPict.Bottom - rectPict.Top
        
        
        Call SetStretchBltMode(Picture.hdc, COLORONCOLOR)
        Call StretchBlt(Picture.hdc, _
                        0, _
                        0, _
                        lPicWidth, _
                        lPicHeight, _
                        ImageDC, _
                        0, _
                        0, _
                        Bmp.bmWidth, _
                        Bmp.bmHeight, _
                        SRCCOPY)
        Call SelectObject(lImageDC, lRet)
        Call DeleteObject(lImageDC)
        Picture.Refresh
    End If
    Call DeleteDC(ImageDC)
End Sub

' This method is called when the confirmaiton mode
' Display the Setting Dialog for BiSetBehaviorToScnResult
Public Property Get ConfirmationMode()
    Dim Dlg As ConfirmationModeForm
    Set Dlg = New ConfirmationModeForm
    Set Dlg.m_objConfig = m_objConfig
    Dlg.Show vbModal
    Set m_objConfig = Dlg.GetProp()
    Set m_objApi.m_objConfig = m_objConfig
    ConfirmationMode = m_objConfig.GetValue(CONFIRMATION_OK)
End Property


Private Sub Label2_Click()

End Sub
