VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ApiUsage"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Dim ErrorCode As ErrorCode
Dim m_lHandle As Long
Dim m_objNull As Object
Dim m_objmfBase01 As MF_BASE01
Dim m_objmfMicr As MF_MICR
Dim m_objmfScanFront As MF_SCAN
Dim m_objmfScanBack As MF_SCAN
Dim m_objmfPrint01 As MF_PRINT01
Dim m_objmfProcess As MF_PROCESS
Public m_objMainForm As TMS1000SampleForm
Dim m_lResultCode As Long
Dim m_lTransactionNumber As Long
Dim m_iMainStatus As Integer
Dim m_iSubStatus As Integer
Public m_objConfig As PropertiseClass

Private Sub Class_Initialize()
    Set ErrorCode = New ErrorCode
    
    Set m_objConfig = New PropertiseClass
            
    Call CopyMemory(m_objmfBase01.iSize(1), CLng(LenB(m_objmfBase01)), 4)
    Call CopyMemory(m_objmfBase01.iVersion(1), MF_BASE_VERSION01, 4)
    Call CopyMemory(m_objmfMicr.iSize(1), CLng(LenB(m_objmfMicr)), 4)
    Call CopyMemory(m_objmfMicr.iVersion(1), MF_MICR_VERSION, 4)
    Call CopyMemory(m_objmfScanFront.iSize(1), CLng(LenB(m_objmfScanFront)), 4)
    Call CopyMemory(m_objmfScanFront.iVersion(1), MF_SCAN_VERSION, 4)
    Call CopyMemory(m_objmfScanBack.iSize(1), CLng(LenB(m_objmfScanBack)), 4)
    Call CopyMemory(m_objmfScanBack.iVersion(1), MF_SCAN_VERSION, 4)
    Call CopyMemory(m_objmfPrint01.iSize(1), CLng(LenB(m_objmfPrint01)), 4)
    Call CopyMemory(m_objmfPrint01.iVersion(1), MF_PRINT_VERSION01, 4)
    Call CopyMemory(m_objmfProcess.iSize(1), CLng(LenB(m_objmfProcess)), 4)
    Call CopyMemory(m_objmfProcess.iVersion(1), MF_PROCESS_VERSION, 4)
    
    m_lResultCode = BiESCNEnable(CROP_STORE_MEMORY)
    
    ' Connect to the printer
    m_lHandle = BiOpenMonPrinter(TYPE_PRINTER, "TM-S1000U")
    If (m_lHandle < SUCCESS) Then
        If (CheckResponse(m_lHandle, "Unable to connect to printer" & vbNewLine & vbNewLine & _
                    "Ensure Driver installed correctly" & vbNewLine & "and Printer is powered on")) Then
            Exit Sub
        End If
    End If
End Sub

' this method configures the parameters used while scanning single checks
' primarily the BiSCNMICRFunctionXXX method is used
Public Sub Configure()

    ' DPI setting method
    ' Specify MF_SCAN_DPI_XXX in sResolution of the MF_SCAN structure
    ' Execute BiSCNMICRFunctionXXX
    ' * Execute before scanning

    ' Sharpening setting method
    ' Specify EPS_BI_SCN_XXX as the 5th parameter of BiSCNSetImageQuality and   execute it (other parameters are discretionary)
    ' * Execute before scanning

    ' Setting method for multiple electronic endorsements
    ' Execute MF_PRT_BUFFERING with BiBufferedPrint
    ' Set multiple electronic endorsements
    ' Execute MF_PRT_EXEC with BiBufferedPrint
    ' * Execute before scanning

    ' Set station electronic endorse
    If (CheckResponse(BiSetPrintStation(m_lHandle, MF_ST_E_ENDORSEMENT), "BiSetPrintStation(m_lHandle, MF_ST_E_ENDORSEMENT)")) Then
        Exit Sub
    End If
   

    ' the registered electronic endorsement
    If (CheckResponse(BiBufferedPrint(m_lHandle, MF_PRT_CLEAR), "BiBufferedPrint(m_lHandle, MF_PRT_CLEAR)")) Then
        Exit Sub
    End If

    Select Case (m_objConfig.GetValue(SCAN_FUNC))
    Case 0
        Call ConfigureMulti
    Case 1
        Call ConfigureSingle
    Case Else
         Call ConfigureMulti
   End Select
End Sub

' this method is settings of multi scan
' primarily the BiSCNMICRFunctionContinuously method is used
Private Sub ConfigureMulti()
    ' Base
    If (CheckResponse(FunctionContinuouslyBase(m_lHandle, m_objmfBase01, MF_GET_BASE_DEFAULT), _
                        "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfBase01, MF_GET_BASE_DEFAULT)")) Then
        Exit Sub
    End If
    Call SetBaseStruct
    If (CheckResponse(FunctionContinuouslyBase(m_lHandle, m_objmfBase01, MF_SET_BASE_PARAM), _
                        "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfBase01, MF_SET_BASE_PARAM)")) Then
        Exit Sub
    End If

    ' Micr
    If (CheckResponse(FunctionContinuouslyMicr(m_lHandle, m_objmfMicr, MF_GET_MICR_DEFAULT), _
                        "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfMicr, MF_GET_MICR_DEFAULT)")) Then
        Exit Sub
    End If
    ' MICR font designation
    Select Case (m_objConfig.GetValue(MICR_FONT))
    Case 0:
        m_objmfMicr.bFont = MF_MICR_FONT_E13B
    Case 1:
        m_objmfMicr.bFont = MF_MICR_FONT_CMC7
    End Select
    If (CheckResponse(FunctionContinuouslyMicr(m_lHandle, m_objmfMicr, MF_SET_MICR_PARAM), _
                        "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfMicr, MF_SET_MICR_PARAM)")) Then
        Exit Sub
    End If

    ' ScanFront
    If (m_objConfig.GetValue(FRONT_SCAN)) Then
        If (CheckResponse(FunctionContinuouslyScan(m_lHandle, m_objmfScanFront, MF_GET_SCAN_FRONT_DEFAULT), _
                            "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfScanFront, MF_GET_SCAN_FRONT_DEFAULT)")) Then
            Exit Sub
        End If
        If (CheckResponse(FunctionContinuouslyScan(m_lHandle, m_objmfScanFront, MF_SET_SCAN_FRONT_PARAM), _
                            "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfScanFront, MF_SET_SCAN_FRONT_PARAM)")) Then
            Exit Sub
        End If
    Else
        ' Delete the structure set in MF_CLEAR_SCAN_FRONT_PARAM when the front side will not be scanned
        If (CheckResponse(FunctionContinuouslyScan(m_lHandle, m_objmfScanFront, MF_CLEAR_SCAN_FRONT_PARAM), _
                            "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfScanFront, MF_CLEAR_SCAN_FRONT_PARAM)")) Then
            Exit Sub
        End If
    End If

    ' ScanBack
    If (m_objConfig.GetValue(BACK_SCAN)) Then
        If (CheckResponse(FunctionContinuouslyScan(m_lHandle, m_objmfScanBack, MF_GET_SCAN_BACK_DEFAULT), _
                            "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfScanBack, MF_GET_SCAN_BACK_DEFAULT)")) Then
            Exit Sub
        End If
        If (CheckResponse(FunctionContinuouslyScan(m_lHandle, m_objmfScanBack, MF_SET_SCAN_BACK_PARAM), _
                            "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfScanBack, MF_SET_SCAN_BACK_PARAM)")) Then
            Exit Sub
        End If
    Else
        ' Delete the structure set in MF_CLEAR_SCAN_BACK_PARAM when the reverse side will not be scanned
        If (CheckResponse(FunctionContinuouslyScan(m_lHandle, m_objmfScanBack, MF_CLEAR_SCAN_BACK_PARAM), _
                            "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfScanBack, MF_CLEAR_SCAN_BACK_PARAM)")) Then
            Exit Sub
        End If
    End If

    ' Print
    If (CheckResponse(FunctionContinuouslyPrint(m_lHandle, m_objmfPrint01, MF_GET_PRINT_DEFAULT), _
                        "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfPrint01, MF_GET_PRINT_DEFAULT)")) Then
        Exit Sub
    End If
    Dim strTmp As String
    strTmp = ""
    ' An error when the m_objmfPrint01.String array is all NULL
    Call CopyMemory(m_objmfPrint01.lpString(1), strTmp, 4) ' Specify blank characters
    If (CheckResponse(FunctionContinuouslyPrint(m_lHandle, m_objmfPrint01, MF_SET_PRINT_PARAM), _
                        "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfPrint01, MF_SET_PRINT_PARAM)")) Then
        Exit Sub
    End If

    ' Operational settings when an error occurs
    ' Process
    If (CheckResponse(FunctionContinuouslyProcess(m_lHandle, m_objmfProcess, MF_GET_PROCESS_DEFAULT), _
                        "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfProcess, MF_GET_PROCESS_DEFAULT)")) Then
        Exit Sub
    End If
    SetProcessStruct
    If (CheckResponse(FunctionContinuouslyProcess(m_lHandle, m_objmfProcess, MF_SET_PROCESS_PARAM), _
                        "BiSCNMICRFunctionContinuously(m_lHandle, m_objmfProcess, MF_SET_PROCESS_PARAM)")) Then
        Exit Sub
    End If
    
    ' Set the endorsement
    If (m_objConfig.GetValue(ELE_ENDORSE_IMAGE)) Then
        ' Set the electronic endorsement
        If (CheckResponse(BiBufferedPrint(m_lHandle, MF_PRT_BUFFERING), "BiBufferedprint(m_lHandle, MF_PRT_BUFFERING)")) Then
            Exit Sub
        End If
        
        ' Set the image electronic endorsement
        ElectricEndorseImage
        
        ' Register the electronic endorsement set
        If (CheckResponse(BiBufferedPrint(m_lHandle, MF_PRT_EXEC), "Bibufferedprint(m_lHandle, MF_PRT_EXEC)")) Then
            Exit Sub
        End If
    End If
End Sub

' this method is settings of single scan
' primarily the BiSCNMICRFunctionPostPrint method is used
Private Sub ConfigureSingle()
    ' Base
    If (CheckResponse(FunctionPostPrintBase(m_lHandle, m_objmfBase01, MF_GET_BASE_DEFAULT), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfBase01, MF_GET_BASE_DEFAULT)")) Then
        Exit Sub
    End If
    Call SetBaseStruct
    If (CheckResponse(FunctionPostPrintBase(m_lHandle, m_objmfBase01, MF_SET_BASE_PARAM), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfBase01, MF_SET_BASE_PARAM)")) Then
        Exit Sub
    End If

    ' Micr
    If (CheckResponse(FunctionPostPrintMicr(m_lHandle, m_objmfMicr, MF_GET_MICR_DEFAULT), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfMicr, MF_GET_MICR_DEFAULT)")) Then
        Exit Sub
    End If
    ' MICR font designation
    Select Case (m_objConfig.GetValue(MICR_FONT))
    Case 0:
        m_objmfMicr.bFont = MF_MICR_FONT_E13B
    Case 1:
        m_objmfMicr.bFont = MF_MICR_FONT_CMC7
    End Select
    If (CheckResponse(FunctionPostPrintMicr(m_lHandle, m_objmfMicr, MF_SET_MICR_PARAM), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfMicr, MF_SET_MICR_PARAM)")) Then
        Exit Sub
    End If

    ' ScanFront
    If (m_objConfig.GetValue(FRONT_SCAN)) Then
        If (CheckResponse(FunctionPostPrintScan(m_lHandle, m_objmfScanFront, MF_GET_SCAN_FRONT_DEFAULT), _
                            "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfScanFront, MF_GET_SCAN_FRONT_DEFAULT)")) Then
            Exit Sub
        End If
        If (CheckResponse(FunctionPostPrintScan(m_lHandle, m_objmfScanFront, MF_SET_SCAN_FRONT_PARAM), _
                            "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfScanFront, MF_SET_SCAN_FRONT_PARAM)")) Then
            Exit Sub
        End If
    Else
        ' Delete the structure set in MF_CLEAR_SCAN_FRONT_PARAM when the front side will not be scanned
        If (CheckResponse(FunctionPostPrintScan(m_lHandle, m_objmfScanFront, MF_CLEAR_SCAN_FRONT_PARAM), _
                            "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfScanFront, MF_CLEAR_SCAN_FRONT_PARAM)")) Then
            Exit Sub
        End If
    End If

    ' ScanBack
    If (m_objConfig.GetValue(BACK_SCAN)) Then
        If (CheckResponse(FunctionPostPrintScan(m_lHandle, m_objmfScanBack, MF_GET_SCAN_BACK_DEFAULT), _
                            "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfScanBack, MF_GET_SCAN_BACK_DEFAULT)")) Then
            Exit Sub
        End If
        If (CheckResponse(FunctionPostPrintScan(m_lHandle, m_objmfScanBack, MF_SET_SCAN_BACK_PARAM), _
                            "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfScanBack, MF_SET_SCAN_BACK_PARAM)")) Then
            Exit Sub
        End If
    Else
        ' Delete the structure set in MF_CLEAR_SCAN_BACK_PARAM when the reverse side will not be scanned
        If (CheckResponse(FunctionPostPrintScan(m_lHandle, m_objmfScanBack, MF_CLEAR_SCAN_BACK_PARAM), _
                            "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfScanBack, MF_CLEAR_SCAN_BACK_PARAM)")) Then
            Exit Sub
        End If
    End If

    ' Print
    If (CheckResponse(FunctionPostPrintPrint(m_lHandle, m_objmfPrint01, MF_GET_PRINT_DEFAULT), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfPrint01, MF_GET_PRINT_DEFAULT)")) Then
        Exit Sub
    End If
    Dim strTmp As String
    strTmp = ""
    ' An error when the m_objmfPrint01.String array is all NULL
    Call CopyMemory(m_objmfPrint01.lpString(1), strTmp, 4) ' Specify blank characters
    If (CheckResponse(FunctionPostPrintPrint(m_lHandle, m_objmfPrint01, MF_SET_PRINT_PARAM), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfPrint01, MF_SET_PRINT_PARAM)")) Then
        Exit Sub
    End If

    ' Operational settings when an error occurs
    ' Process
    If (CheckResponse(FunctionPostPrintProcess(m_lHandle, m_objmfProcess, MF_GET_PROCESS_DEFAULT), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfProcess, MF_GET_PROCESS_DEFAULT)")) Then
        Exit Sub
    End If
    SetProcessStruct
    If (CheckResponse(FunctionPostPrintProcess(m_lHandle, m_objmfProcess, MF_SET_PROCESS_PARAM), _
                        "BiSCNMICRFunctionPostPrint(m_lHandle, m_objmfProcess, MF_SET_PROCESS_PARAM)")) Then
        Exit Sub
    End If
    
    ' Set the endorsement
    If (m_objConfig.GetValue(ELE_ENDORSE_IMAGE)) Then
        ' Set the electronic endorsement
        If (CheckResponse(BiBufferedPrint(m_lHandle, MF_PRT_BUFFERING), "BiBufferedprint(m_lHandle, MF_PRT_BUFFERING)")) Then
            Exit Sub
        End If
        
        ' Set the image electronic endorsement
        ElectricEndorseImage
        
        ' Register the electronic endorsement set
        If (CheckResponse(BiBufferedPrint(m_lHandle, MF_PRT_EXEC), "Bibufferedprint(m_lHandle, MF_PRT_EXEC)")) Then
            Exit Sub
        End If
    End If
End Sub
    
' This method is called when the user clicks the scan button
' operation is offloaded to the correct Scan function
Public Sub Scan()
    Select Case (m_objConfig.GetValue(SCAN_FUNC))
    Case 0
        Call ScanMulti
    Case 1
        Call ScanSingle
    Case Else
        Call ScanMulti
    End Select
End Sub

' this method performs scanning of a multi check
Private Sub ScanMulti()
    If (CheckResponse(BiSCNMICRFunctionContinuously(m_lHandle, m_objNull, MF_EXEC), _
                    "BiSCNMICRFunctionContinuously(m_lHandle, Null, MF_EXEC)")) Then
        m_objMainForm.Complate (0)
    End If
End Sub

' this method performs scanning of a single check
Private Sub ScanSingle()
    If (CheckResponse(BiSCNMICRFunctionPostPrint(m_lHandle, m_objNull, MF_EXEC), _
                    "BiSCNMICRFunctionPostPrint(m_lHandle, Null, MF_EXEC)")) Then
        m_objMainForm.Complate (0)
    End If
End Sub

' this method is called when the user click the exit button
Public Sub Cancel()
    If (CheckResponse(BiSCNMICRCancelFunction(m_lHandle, MF_EJECT_DISCHARGE), _
                        "BiSCNMICRCancelFunction(m_lHandle, MF_EJECT_DISCHARGE)")) Then
    End If
End Sub

' this method is called when the user click the cancel button
Public Sub ScanEnd()
    If Not (m_lHandle < 1) Then
        m_lResultCode = BiSCNMICRCancelStatusBack(m_lHandle)
        m_lResultCode = BiSCNMICRCancelFunction(m_lHandle, MF_EJECT_DISCHARGE)
        m_lResultCode = BiCloseMonPrinter(m_lHandle)
        m_lHandle = 0
    End If
End Sub

' This method is called whenever the scan state changes
' Called when scanning with BiSCNMICRFunctionPostPrint/BiSCNMICRFunctionContinuously
Public Sub MicrStatusCallback()
    ' Finish scan process
    If (m_iMainStatus = MF_FUNCTION_DONE) Then
        m_objMainForm.Complate (m_lTransactionNumber)
        
        ' Data receive complete
    ElseIf (m_iMainStatus = MF_DATARECEIVE_DONE) Then
        ' get MICR data
        Dim nRet As Integer
        Dim strMicr As String
        Dim nResultCode As Long
        Dim lAddress As Long
        
        If (m_objConfig.GetValue(MICR)) Then
            ' Specify the relevant item for MICR text
            m_objmfMicr.bMicOcrSelect = MF_MICR_USE_MICR
            Call CopyMemory(m_objmfMicr.blParsing(1), False, 4)
            ' Acquire MICR text
            m_lResultCode = BiGetMicrText(m_lHandle, m_lTransactionNumber, m_objmfMicr)
            ' Change string to ASCII
            m_objMainForm.MicrText.Text = StrToAsc(m_objmfMicr.szMicrStr, MF_MICR_CHAR_MAX)
            strMicr = m_objMainForm.MicrText.Text
            Call CopyMemory(nResultCode, m_objmfMicr.iRet(1), 4)
            If Not (nResultCode = SUCCESS) Then
                ' Add error code
                strMicr = strMicr + "(" + ErrorCode.ChangeErrorCode(nResultCode) + ")"
            End If
            m_objMainForm.MicrText.Text = strMicr
        End If
        
        If (m_objConfig.GetValue(OCR_AB) And m_objConfig.GetValue(FRONT_SCAN)) Then
            ' OCR AB
            Dim mfOcrAb As MF_OCR_AB
            Dim strOcrAb As String
            Call CopyMemory(mfOcrAb.iSize(1), CLng(LenB(mfOcrAb)), 4)
            Call CopyMemory(mfOcrAb.iVersion(1), MF_OCR_AB_VERSION, 4)
            ' Font designation
            If (m_objConfig.GetValue(OCR_AB_FONT) = 0) Then
                mfOcrAb.bOcrType = MF_OCR_FONT_OCRA_ALPHANUM
                strOcrAb = "OCR_A:"
            Else
                mfOcrAb.bOcrType = MF_OCR_FONT_OCRB_ALPHANUM
                 strOcrAb = "OCR_B:"
           End If
            mfOcrAb.bDirection = MF_OCR_LEFTRIGHT
            Call CopyMemory(mfOcrAb.wStartX(1), OCR_AB_START_X, 2)
            Call CopyMemory(mfOcrAb.wStartY(1), OCR_AB_START_Y, 2)
            Call CopyMemory(mfOcrAb.wEndX(1), OCR_AB_END_X, 2)
            Call CopyMemory(mfOcrAb.wEndY(1), OCR_AB_END_Y, 2)
            mfOcrAb.bSpaceHandling = OCR_SPACE_ENABLE
	        ' select front side
	        nResultCode = BiSCNSelectScanFace(m_lHandle, MF_SCAN_FACE_FRONT)
            ' Acquire OCR_AB text
            nResultCode = BiGetOcrABText(m_lHandle, m_lTransactionNumber, OCR_SOURCE_TRANSACTION_NUMBER, "", mfOcrAb)
            ' Change string to ASCII
            m_objMainForm.OcrText.Text = StrToAsc(mfOcrAb.szOcrStr, MF_OCR_AB_CHAR_MAX)
            strOcrAb = strOcrAb + m_objMainForm.OcrText.Text
            If Not (nResultCode = SUCCESS) Then
                ' Add error code
                strOcrAb = strOcrAb + "(" + ErrorCode.ChangeErrorCode(nResultCode) + ")"
            End If
            m_objMainForm.OcrText.Text = strOcrAb
        End If
        
        ' save MICR data
        If (m_objConfig.GetValue(MICR_SAVE) And m_objConfig.GetValue(MICR_SAVE_ENABLE)) Then
            SaveMicr (m_lTransactionNumber)
        End If
        
        ' get front image
        If (m_objConfig.GetValue(FRONT_SCAN)) Then
            ' Set the relevant item for the front side image
            m_lResultCode = BiSCNSelectScanFace(m_lHandle, MF_SCAN_FACE_FRONT)
            If (m_lResultCode = SUCCESS) Then
                ' Set grayscale
                If (m_objConfig.GetValue(FRONT_GRAYSCALE)) Then
                    m_lResultCode = BiSCNSetImageQuality(m_lHandle, EPS_BI_SCN_8BIT, 0, EPS_BI_SCN_MONOCHROME, EPS_BI_SCN_SHARP)
                Else
                    m_lResultCode = BiSCNSetImageQuality(m_lHandle, EPS_BI_SCN_1BIT, 0, EPS_BI_SCN_MONOCHROME, EPS_BI_SCN_SHARP)
                End If
                ' display front image
                If (m_objConfig.GetValue(FRONT_DISPLAY)) Then
                    ' Specify the file format in BMP
                    m_lResultCode = BiSCNSetImageFormat(m_lHandle, EPS_BI_SCN_BITMAP)
                    If (m_lResultCode = SUCCESS) Then
                        ' Acquire image data
                        m_lResultCode = BiGetScanImage(m_lHandle, m_lTransactionNumber, m_objmfScanFront)
                        If (m_lResultCode = SUCCESS) Then
                            ' Copy address for image data to type long
                            Call CopyMemory(lAddress, m_objmfScanFront.lpbScanData(1), 4)
                            ' Display image
                            Call m_objMainForm.SetImage(lAddress, m_objmfScanFront.dwScanSize, True)
                            ' Delete image data
                            If Not (lAddress = 0) Then
                                Call GlobalFree(lAddress)
                                lAddress = 0
                                Call CopyMemory(m_objmfScanFront.lpbScanData(1), lAddress, 4)
                            End If
                        End If
                    End If
                End If
                
                ' save front image
                If (m_objConfig.GetValue(FRONT_SAVE)) Then
                    Dim filename As String
                    ' set grayscale
                    If (m_objConfig.GetValue(FRONT_GRAYSCALE)) Then
                        m_lResultCode = BiSCNSetImageFormat(m_lHandle, EPS_BI_SCN_JPEGNORMAL)
                        filename = Format(m_lTransactionNumber, "000") + ".front.jpg"
                    Else
                        m_lResultCode = BiSCNSetImageFormat(m_lHandle, EPS_BI_SCN_TIFF)
                        filename = Format(m_lTransactionNumber, "000") + ".front.tif"
                    End If
                    Dim dataSize As Long
                    lAddress = 0
                    dataSize = 0
                    ' Acquire image data
                    Call BiGetScanImage(m_lHandle, m_lTransactionNumber, m_objmfScanFront)
                    ' Copy address for image data to type long
                    Call CopyMemory(lAddress, m_objmfScanFront.lpbScanData(1), 4)
                    Call CopyMemory(dataSize, m_objmfScanFront.dwScanSize(1), 4)
                    If Not (dataSize = 0 Or lAddress = 0) Then
                        Dim byData() As Byte
                        ReDim byData(dataSize)
                        ' Copy image data to byte array
                        Call memcpy(byData(0), ByVal lAddress, dataSize)
                        ' Save in file
                        Open filename For Binary As #1
                        Put #1, 1, byData
                        Close #1
                    End If
                    ' Delete image data
                    If Not (lAddress = 0) Then
                        Call GlobalFree(lAddress)
                        lAddress = 0
                        Call CopyMemory(m_objmfScanFront.lpbScanData(1), lAddress, 4)
                    End If
                End If
            End If
        End If
        
        ' set endorse
        If (m_objConfig.GetValue(ELE_ENDORSE_TEXT)) Then
            ElectricEndorseText
        End If
        
        ' get back image
        If (m_objConfig.GetValue(BACK_SCAN)) Then
            ' Set the relevant item for the front side
            m_lResultCode = BiSCNSelectScanFace(m_lHandle, MF_SCAN_FACE_BACK)
            If (m_lResultCode = SUCCESS) Then
                ' set grayscale
                If (m_objConfig.GetValue(BACK_GRAYSCALE)) Then
                    m_lResultCode = BiSCNSetImageQuality(m_lHandle, EPS_BI_SCN_8BIT, 0, EPS_BI_SCN_MONOCHROME, EPS_BI_SCN_SHARP)
                Else
                    m_lResultCode = BiSCNSetImageQuality(m_lHandle, EPS_BI_SCN_1BIT, 0, EPS_BI_SCN_MONOCHROME, EPS_BI_SCN_SHARP)
                End If
                ' display back image
                If (m_objConfig.GetValue(BACK_DISPLAY)) Then
                    ' Specify the file format in BMP
                    m_lResultCode = BiSCNSetImageFormat(m_lHandle, EPS_BI_SCN_BITMAP)
                    If (m_lResultCode = SUCCESS) Then
                        ' Acquire image data
                        m_lResultCode = BiGetScanImage(m_lHandle, m_lTransactionNumber, m_objmfScanBack)
                        If (m_lResultCode = SUCCESS) Then
                            Call CopyMemory(lAddress, m_objmfScanBack.lpbScanData(1), 4)
                            Call m_objMainForm.SetImage(lAddress, m_objmfScanBack.dwScanSize, False)
                            If Not (lAddress = 0) Then
                                Call GlobalFree(lAddress)
                                lAddress = 0
                                Call CopyMemory(m_objmfScanBack.lpbScanData(1), lAddress, 4)
                            End If
                        End If
                    End If
                End If
                
                'save back image
                If (m_objConfig.GetValue(BACK_SAVE)) Then
                    ' set grayscale
                    If (m_objConfig.GetValue(BACK_GRAYSCALE)) Then
                        filename = Format(m_lTransactionNumber, "000") + ".back.jpg"
                        m_lResultCode = BiSCNSetImageFormat(m_lHandle, EPS_BI_SCN_JPEGNORMAL)
                    Else
                        filename = Format(m_lTransactionNumber, "000") + ".back.tif"
                        m_lResultCode = BiSCNSetImageFormat(m_lHandle, EPS_BI_SCN_TIFF)
                    End If
                    lAddress = 0
                    dataSize = 0
                    ' Acquire image data
                    Call BiGetScanImage(m_lHandle, m_lTransactionNumber, m_objmfScanBack)
                    ' copy address for image data to type long
                    Call CopyMemory(lAddress, m_objmfScanBack.lpbScanData(1), 4)
                    Call CopyMemory(dataSize, m_objmfScanBack.dwScanSize(1), 4)
                    If Not (dataSize = 0 Or lAddress = 0) Then
                        ReDim byData(dataSize)
                        ' Copy image data to byte array
                        Call memcpy(byData(0), ByVal lAddress, dataSize)
                        ' Save in file
                        Open filename For Binary As #1
                        Put #1, 1, byData
                        Close #1
                    End If
                    ' Delete image data
                    If Not (lAddress = 0) Then
                        Call GlobalFree(lAddress)
                        lAddress = 0
                        Call CopyMemory(m_objmfScanBack.lpbScanData(1), lAddress, 4)
                    End If
                End If
            End If
        End If
        
        ' Is it Confirmation Mode?
        If (m_objConfig.GetValue(CONFIRMATION) = 1) Then
            ' Execute BiSetBehaviorToScnResult?
            If (m_objConfig.GetValue(RUN_SCN_TO_RESULT) = 1) Then
                ' Call BiSetBehaviorToScnResult?
                If Not (m_objConfig.GetValue(NO_CALL_SCN_TO_RESULT) = 1) Then
                    ' Display BiSetBehaviorToScnResult dialog box
                    ' Do no execute if it is canceled in the dialog box
                    If (m_objMainForm.ConfirmationMode) Then
                        m_lResultCode = BiSetBehaviorToScnResult(m_lHandle, _
                                                                GetEject(m_objConfig.GetValue(CONFIRMATION_EJECT)), _
                                                                GetStamp(m_objConfig.GetValue(CONFIRMATION_STAMP)), _
                                                                GetNextCheck(m_objConfig.GetValue(CONFIRMATION_NEXT)))
                    End If
                Else
                    ' Use the value set without calling BiSetBehaviorToScnResult
                    m_lResultCode = BiSetBehaviorToScnResult(m_lHandle, _
                                                            GetEject(m_objConfig.GetValue(CONFIRMATION_EJECT)), _
                                                            GetStamp(m_objConfig.GetValue(CONFIRMATION_STAMP)), _
                                                            GetNextCheck(m_objConfig.GetValue(CONFIRMATION_NEXT)))
                End If
            End If
        End If
    End If
End Sub

' this method is return response
' SUCCESS : Return to FALSE
' ERROR : Display the message box, return TRUE
Private Property Get CheckResponse(ByVal Error As Long, ByVal str As String) As Boolean
    If Not (Error = 0) Then
        Dim strError As String
        strError = ErrorCode.ChangeErrorCode(Error)
        Call MsgBox(str, vbOKOnly, strError)
        CheckResponse = True
        Exit Property
    End If
    CheckResponse = False
End Property

' Register the callback destination
Public Sub SetStatusBackWnd()
    If (m_lHandle < SUCCESS) Then
        Exit Sub
    End If
    
    If (CheckResponse(BiSCNMICRSetStatusBackWnd(m_lHandle, m_objMainForm.btnMicrStatusBack.hwnd, m_lTransactionNumber, m_iMainStatus, m_iSubStatus), _
                    "BiSCNMICRSetStatusBackWnd")) Then
        Exit Sub
    End If
End Sub

' this method is return transaction number
Public Property Get GetTransactionNumber() As Long
    Dim m_lTransactionNumber As Long
    m_lResultCode = BiGetTransactionNumber(m_lHandle, m_lTransactionNumber)
    GetTransactionNumber = m_lTransactionNumber
End Property

' Byte is converted to ASCII
Private Property Get StrToAsc(ByRef byData() As Byte, ByVal lSize As Long) As String
    Dim lCount As Long
    Dim strAsc As String
    lCount = 0
    Do While (lCount < lSize)
        strAsc = strAsc + Chr(byData(lCount + 1))
        lCount = lCount + 1
    Loop
    StrToAsc = strAsc
End Property

' settings endorse text
Private Sub ElectricEndorseText()
    Dim mfDecorate As MF_DECORATE
    Dim strText As String

    Call CopyMemory(mfDecorate.lAttribute(1), MF_PRINT_COLOR, 4)
    Call CopyMemory(mfDecorate.wFont(1), MF_PRINT_SYSTEMFONT, 2)
    Call CopyMemory(mfDecorate.wFontSize(1), 30, 2)
    strText = "Transaction#:<00000000>"

    ' set position
    If (CheckResponse(BiSetPrintPosition(m_lHandle, 10, 60), "BiPrintPosition(m_lHandle, 10, 60)")) Then
        Exit Sub
    End If

    ' Call wrapper for VB
    ' BiPrintText calls it through BiPrintTextToVB of VBWrapper
    If (CheckResponse(BiPrintTextToVB(m_lHandle, strText, mfDecorate), "BiPrintText(m_lHandle, szText, mfDecorate)")) Then
        Exit Sub
    End If
End Sub
    
' settings endorse image
Private Sub ElectricEndorseImage()
    ' set position
    If (CheckResponse(BiSetPrintPosition(m_lHandle, 100, 30), "BiPrintPosition(m_lHandle, 100, 30)")) Then
        Exit Sub
    End If
    
    ' set size
    If (CheckResponse(BiSetPrintSize(m_lHandle, 30, 30), "BiSetPrintSize(m_lHandle, 30, 30)")) Then
        Exit Sub
    End If
    
    If (CheckResponse(BiPrintImage(m_lHandle, App.Path + "\Image.JPG"), "BiPrintImage(m_lHandle, Image.JPG")) Then
        Exit Sub
    End If
End Sub

' this method is return the value of MF_BUZZER_HZ_XXX
Private Property Get BuzzerHz(ByVal HzValue As Integer) As Byte
    Select Case (HzValue)
    Case 0:
        BuzzerHz = MF_BUZZER_HZ_440
    Case 1:
        BuzzerHz = MF_BUZZER_HZ_880
    Case 2:
        BuzzerHz = MF_BUZZER_HZ_4000
    Case Else:
        BuzzerHz = MF_BUZZER_HZ_440
    End Select
End Property

' this method is return the value of MF_BUZZER_XXX
Private Property Get BuzzerCount(ByVal count As Integer) As Byte
    Select Case (count)
    Case 0:
        BuzzerCount = MF_BUZZER_DISABLE
    Case 1:
        BuzzerCount = 1
    Case 2:
        BuzzerCount = 2
    Case 3:
        BuzzerCount = MF_BUZZER_COUNT_MAX
    Case Else:
        BuzzerCount = MF_BUZZER_DISABLE
    End Select
End Property

' settings Base structre
Private Sub SetBaseStruct()
    m_objmfBase01.bBuzzerHz(1) = BuzzerHz(m_objConfig.GetValue(BUZZER_SUCCESS_HZ))
    m_objmfBase01.bBuzzerCount(1) = BuzzerCount(m_objConfig.GetValue(BUZZER_SUCCESS_COUNT))
    
    m_objmfBase01.bBuzzerHz(2) = BuzzerHz(m_objConfig.GetValue(BUZZER_ERROR_HZ))
    m_objmfBase01.bBuzzerCount(2) = BuzzerCount(m_objConfig.GetValue(BUZZER_ERROR_COUNT))
    
    m_objmfBase01.bBuzzerHz(3) = BuzzerHz(m_objConfig.GetValue(BUZZER_WFEED_HZ))
    m_objmfBase01.bBuzzerCount(3) = BuzzerCount(m_objConfig.GetValue(BUZZER_WFEED_COUNT))
End Sub

' settings Process structure
Private Sub SetProcessStruct()
    ' Activate Modes
    If (m_objConfig.GetValue(CONFIRMATION)) Then
        m_objmfProcess.bActivationMode = MF_ACTIVATE_MODE_CONFIRMATION
    Else
        m_objmfProcess.bActivationMode = MF_ACTIVATE_MODE_HIGH_SPEED
    End If
    
    ' PaperMisInsertion
    m_objmfProcess.bPaperMisInsertionErrorSelect = GetDetect(m_objConfig.GetValue(PAPER_MIS_INSERT_DETECT))
    m_objmfProcess.bPaperMisInsertionErrorEject = GetEject(m_objConfig.GetValue(PAPER_MIS_INSERT_EJECT_TYPE))
    m_objmfProcess.bPaperMisInsertionStamp = GetStamp(m_objConfig.GetValue(PAPER_MIS_INSERT_STAMP))
    m_objmfProcess.bPaperMisInsertionCancel = GetCancel(m_objConfig.GetValue(PAPER_MIS_INSERT_CANCEL))
    
    ' Noise
    m_objmfProcess.bNoiseErrorSelect = GetDetect(m_objConfig.GetValue(NOISE_DETECT))
    m_objmfProcess.bNoiseErrorEject = GetEject(m_objConfig.GetValue(NOISE_EJECT_TYPE))
    m_objmfProcess.bNoiseStamp = GetStamp(m_objConfig.GetValue(NOISE_STAMP))
    m_objmfProcess.bNoiseCancel = GetCancel(m_objConfig.GetValue(NOISE_CANCEL))
    
    ' DoubleFeed
    m_objmfProcess.bDoubleFeedErrorSelect = GetDetect(m_objConfig.GetValue(DOUBLE_DETECT))
    m_objmfProcess.bDoubleFeedErrorEject = GetEject(m_objConfig.GetValue(DOUBLE_EJECT_TYPE))
    m_objmfProcess.bDoubleFeedStamp = GetStamp(m_objConfig.GetValue(DOUBLE_STAMP))
    m_objmfProcess.bDoubleFeedCancel = GetCancel(m_objConfig.GetValue(DOUBLE_CANCEL))
    
    ' Baddata
    m_objmfProcess.bBaddataCount = m_objConfig.GetValue(BADDATA_COUNT)
    m_objmfProcess.bBaddataErrorSelect = GetDetect(m_objConfig.GetValue(BADDATA_DETECT))
    m_objmfProcess.bBaddataErrorEject = GetEject(m_objConfig.GetValue(BADDATA_EJECT_TYPE))
    m_objmfProcess.bBaddataStamp = GetStamp(m_objConfig.GetValue(BADDATA_STAMP))
    m_objmfProcess.bBaddataCancel = GetCancel(m_objConfig.GetValue(BADDATA_CANCEL))
    
    ' Nodata
    m_objmfProcess.bNodataErrorSelect = GetDetect(m_objConfig.GetValue(NODATA_DETECT))
    m_objmfProcess.bNodataErrorEject = GetEject(m_objConfig.GetValue(NODATA_EJECT_TYPE))
    m_objmfProcess.bNodataStamp = GetStamp(m_objConfig.GetValue(NODATA_STAMP))
    m_objmfProcess.bNodataCancel = GetCancel(m_objConfig.GetValue(NODATA_CANCEL))
End Sub

' this method is return the value of ErrorEject
Private Property Get GetEject(ByVal bEject As Byte) As Byte
    Select Case (bEject)
    Case 0:
    GetEject = MF_EJECT_MAIN_POCKET
    
    Case 1:
    GetEject = MF_EJECT_SUB_POCKET
    
    Case 2:
    GetEject = MF_EJECT_NOEJECT
    
    Case Else:
    GetEject = MF_EJECT_MAIN_POCKET
    
    End Select
    
End Property

' this method is return the value of Stamp
Private Property Get GetStamp(ByVal bStamp As Byte) As Byte
    Select Case (bStamp)
    Case 0:
    GetStamp = MF_STAMP_DISABLE
    
    Case 1:
    GetStamp = MF_STAMP_ENABLE
    
    Case Else:
    GetStamp = MF_STAMP_DISABLE
    
    End Select
End Property

' this method is return MF_PROCESS_CONTINUE_XXXXX
Private Property Get GetNextCheck(ByVal bNext As Byte) As Byte
    Select Case (bNext)
    Case 0:
    GetNextCheck = MF_PROCESS_CONTINUE_OVERLAP
    
    Case 1:
    GetNextCheck = MF_PROCESS_CONTINUE_NOOVERLAP
    
    Case 2:
    GetNextCheck = MF_PROCESS_CONTINUE_CANCEL
    
    Case Else:
    GetNextCheck = MF_PROCESS_CONTINUE_OVERLAP

    End Select
End Property

' this method is return the value of ErrorSelect
Private Property Get GetDetect(ByVal bDetect As Byte) As Byte
    Select Case (bDetect)
    Case 0:
    GetDetect = MF_ERROR_SELECT_NODETECT
    
    Case 1:
    GetDetect = MF_ERROR_SELECT_DETECT
    
    Case Else:
    GetDetect = MF_ERROR_SELECT_DETECT
    
    End Select
End Property

' this method is return the value of Cancel
Private Property Get GetCancel(ByVal bCancel As Byte) As Byte
    Select Case (bCancel)
    Case 0:
    GetCancel = MF_CANCEL_DISABLE
    
    Case 1:
    GetCancel = MF_CANCEL_ENABLE
    
    Case Else:
    GetCancel = MF_CANCEL_DISABLE
    
    End Select
End Property

' MICR data is preserved
Private Sub SaveMicr(ByVal m_lTransactionNumber As Long)
    
    ' Create log file name
    Open CStr(m_lTransactionNumber) & ".Micr.txt" For Output As #1
    ' Values that are always printed out
    Print #1, ("# MICR Data Output")
    Print #1, ""
    Print #1, ("# General Transaction Information:")
    Print #1, ""
    Print #1, ("m_lTransactionNumber = " & CStr(m_lTransactionNumber))
    ' Micr
    If (m_objConfig.GetValue(MICR)) Then
        Dim CheckType As Long
        Dim CountryCode As Long
        Call CopyMemory(m_objmfMicr.blParsing(1), True, 4)
        ' Acquire MICR text
        m_objmfMicr.bMicOcrSelect = MF_MICR_USE_MICR
        ' Get the text acquired
        Call BiGetMicrText(m_lHandle, m_lTransactionNumber, m_objmfMicr)
        Dim Error As Long
        Call CopyMemory(Error, m_objmfMicr.iRet(1), 4)
        Print #1, ("Result = " & ErrorCode.ChangeErrorCode(Error))
        Print #1, ("Status = " & CStr(m_objmfMicr.bStatus))
        Print #1, ("Detail = " & CStr(m_objmfMicr.bDetail))
        Print #1, ""
        Print #1, ""
        Print #1, ("# Magnetic Character Results:")
        Print #1, ""
        ' StrToAsc : Change string to ASCII
        Print #1, ("Raw Data       = " & StrToAsc(m_objmfMicr.szMicrStr, MF_MICR_CHAR_MAX))
        Print #1, ("Account Number = " & StrToAsc(m_objmfMicr.szAccountNumber, MF_MICR_CHAR_MAX))
        Print #1, ("Amount         = " & StrToAsc(m_objmfMicr.szAmount, MF_MICR_CHAR_MAX))
        Print #1, ("Bank Number    = " & StrToAsc(m_objmfMicr.szBankNumber, MF_MICR_CHAR_MAX))
        Print #1, ("Serial Number  = " & StrToAsc(m_objmfMicr.szSerialNumber, MF_MICR_CHAR_MAX))
        Print #1, ("EPC Property   = " & StrToAsc(m_objmfMicr.szEPC, MF_MICR_CHAR_MAX))
        Print #1, ("Transit Number = " & StrToAsc(m_objmfMicr.szTransitNumber, MF_MICR_CHAR_MAX))
        
        Call CopyMemory(CheckType, m_objmfMicr.lCheckType(1), 4)
        Select Case (CheckType)
        Case 1:
        Print #1, ("Check Type     = CHECK_PERSONAL")
        Case 2:
        Print #1, ("Check Type     = CHECK_BUSINESS")
        Case 99:
        Print #1, ("Check Type     = CHECK_UNKNOWN")
        Case Else:
        Print #1, ("Check Type     = " & CStr(CheckType))
        End Select
        
        Call CopyMemory(CountryCode, m_objmfMicr.lCountryCode(1), 4)
        Select Case (CountryCode)
        Case 1:
        Print #1, ("Country Code   = COUNTRY_USA")
        Case 2:
        Print #1, ("Country Code   = COUNTRY_CANADA")
        Case 3:
        Print #1, ("Country Code   = COUNTRY_MEXICO")
        Case 99:
        Print #1, ("Country Code   = COUNTRY_UNKNOWN")
        Case Else:
        Print #1, ("Country Code   = " & CStr(CountryCode))
        End Select
    End If
    
    If (m_objConfig.GetValue(OCR_AB)) Then
        On Error Resume Next
        ' OCR AB
        Dim nResultCode As Integer
        Dim index As Long
        Dim min As Long
        Dim max As Long
        Dim sum As Long
        Dim MicrSum As Long
        Dim count As Long
        Dim strOutput(0 To MF_MICR_CHAR_MAX) As Byte
        Dim lPosition As Long
        min = 100
        max = 0
        sum = 0
        count = 0
        
        Dim mfOcrAb As MF_OCR_AB
        Call CopyMemory(mfOcrAb.iSize(1), CLng(LenB(mfOcrAb)), 4)
        Call CopyMemory(mfOcrAb.iVersion(1), MF_OCR_AB_VERSION, 4)
        Print #1, ""
        Print #1, ""
        ' Font designation
        If (m_objConfig.GetValue(OCR_AB_FONT) = 0) Then
            Print #1, ("# OCR A character probabilities:")
            mfOcrAb.bOcrType = MF_OCR_FONT_OCRA_ALPHANUM
        Else
            Print #1, ("# OCR B character probabilities:")
            mfOcrAb.bOcrType = MF_OCR_FONT_OCRB_ALPHANUM
        End If
        mfOcrAb.bDirection = MF_OCR_LEFTRIGHT
        Call CopyMemory(mfOcrAb.wStartX(1), OCR_AB_START_X, 2)
        Call CopyMemory(mfOcrAb.wStartY(1), OCR_AB_START_Y, 2)
        Call CopyMemory(mfOcrAb.wEndX(1), OCR_AB_END_X, 2)
        Call CopyMemory(mfOcrAb.wEndY(1), OCR_AB_END_Y, 2)
        mfOcrAb.bSpaceHandling = OCR_SPACE_ENABLE
        ' select front side
        nResultCode = BiSCNSelectScanFace(m_lHandle, MF_SCAN_FACE_FRONT)
        ' Acquire OCR_AB text
        nResultCode = BiGetOcrABText(m_lHandle, m_lTransactionNumber, OCR_SOURCE_TRANSACTION_NUMBER, "", mfOcrAb)
        Print #1, ""
        Print #1, "OcrAbResult = " & ErrorCode.ChangeErrorCode(nResultCode)

        ' Acquire reliability percentage (maximum value/minimum value)
        For index = 1 To MF_OCR_AB_CHAR_MAX
            If Not (mfOcrAb.stOcrReliableInfo(index).stFirstSelect.cRecogChar = 0) Then
                Call CopyMemory(MicrSum, mfOcrAb.stOcrReliableInfo(index).stFirstSelect.lPercentage(1), 4)
                sum = sum + MicrSum
                If (min > MicrSum) Then
                    min = MicrSum
                End If
                If (max < MicrSum) Then
                    max = MicrSum
                End If
                count = count + 1
                Call CopyMemory(lPosition, mfOcrAb.stOcrReliableInfo(index).lPosition(1), 4)
                strOutput(lPosition) = mfOcrAb.stOcrReliableInfo(index).stFirstSelect.cRecogChar
            End If
        Next
        
        If Not (count = 0) Then
            average = sum / count
    
           Print #1, ""
           Print #1, ("OcrString = " + StrToAsc(strOutput, MF_MICR_CHAR_MAX))
           Print #1, ("NumberOfCharacters = " & CStr(count))
           Print #1, ("HighestPercentage  = " & CStr(max))
           Print #1, ("LowestPercentage   = " & CStr(min))
           Print #1, ("AveragePercentage  = " & Format(average, "0.00"))
           Print #1, ""
           ' Output the OCR_AB Text and reliability
           For index = 1 To MF_OCR_AB_CHAR_MAX
                If Not (index < mfOcrAb.stOcrReliableInfo(index).stFirstSelect.cRecogChar = 0) Then
                    Print #1, ("OcrPrimaryCharacter" & CStr(index) & "    = '" & Chr(mfOcrAb.stOcrReliableInfo(index).stFirstSelect.cRecogChar) & "'")
                    Call CopyMemory(lPosition, mfOcrAb.stOcrReliableInfo(index).stFirstSelect.lPercentage(1), 4)
                    Print #1, ("OcrPrimaryPercentage" & CStr(index) & "   = " & CStr(lPosition))
                End If
                If Not (index < mfOcrAb.stOcrReliableInfo(index).stSecondSelect.cRecogChar = 0) Then
                    Print #1, ("OcrSecondaryCharacter" & CStr(index) & "  = '" & Chr(mfOcrAb.stOcrReliableInfo(index).stSecondSelect.cRecogChar) & "'")
                    Call CopyMemory(lPosition, mfOcrAb.stOcrReliableInfo(index).stSecondSelect.lPercentage(1), 4)
                    Print #1, ("OcrSecondaryPercentage" & CStr(index) & " = " & CStr(lPosition))
                End If
                Print #1, ""
            Next
        End If
        On Error GoTo 0
        If Not (Err.Number = 0) Then
            Call MsgBox(Err.Description, vbOKOnly, CStr(Err.Number))
        End If
    End If

    Close #1
End Sub

' Stop buzzer during ringing
Public Sub StopBuzzer()
    If (CheckResponse(BiRingBuzzer(m_lHandle, 0, 0, 0, 0), "BiRingBuzzer(m_lHandle, 0, 0, 0, 0)")) Then
    End If
End Sub

Public Property Get GetStartWaitTime() As Long
    Dim lStartWaitTime As Long
    lStartWaitTime = 0
    Call CopyMemory(lStartWaitTime, m_objmfProcess.dwStartWaitTime(1), 4)
    If lStartWaitTime > 6400 Then
        lStartWaitTime = 6400
    End If
    GetStartWaitTime = lStartWaitTime
End Property
