Attribute VB_Name = "EpsStmApiInterface"
Option Explicit

Rem://///////////////////////////////////////////////////////////////////
Rem://
Rem:// EPSStmApiInterface.h
Rem://
Rem:// Interface definition of API
Rem://
Rem:// Modification history
Rem:// ------------------------------------------------------------------
Rem:// 2006-01-13   New
Rem:// 2007-01-16   Modified
Rem://///////////////////////////////////////////////////////////////////

Rem://#if !defined(_EPSSTMAPIINTERFACE_H)
Rem://Public Const _EPSSTMAPIINTERFACE_H


Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// ERROR CODE :
Public Const SUCCESS& = 0                                                       ' Success
Public Const ERR_TYPE& = -10                                                    ' nType error
Public Const ERR_OPENED& = -20                                                  ' Already opened
Public Const ERR_NO_PRINTER& = -30                                              ' There is not printer driver
Public Const ERR_NO_TARGET& = -40                                               ' Printer out of object
Public Const ERR_NO_MEMORY& = -50                                               ' No memory
Public Const ERR_HANDLE& = -60                                                  ' Invalid handle
Public Const ERR_TIMEOUT& = -70                                                 ' Ttime out
Public Const ERR_ACCESS& = -80                                                  ' cannot read/write
Public Const ERR_PARAM& = -90                                                   ' param error
Public Const ERR_NOT_SUPPORT& = -100                                            ' not support
Public Const ERR_OFFLINE& = -110                                                ' now offline
Public Const ERR_NOT_EPSON& = -120                                              ' not epson printer
Public Const ERR_WITHOUT_CB& = -130                                             ' without callback function
Public Const ERR_BUFFER_OVER_FLOW& = -140                                       ' Read buffer over flow
Public Const ERR_REGISTRY& = -150                                               ' Regstry error
Public Const ERR_ENABLE& = -160                                                 ' BiOpenMonPrinter() is already called
Public Const ERR_DISK_FULL& = -170                                              ' Capacity of a disk is insufficient
Public Const ERR_NO_IMAGE& = -180                                               ' No image data
Public Const ERR_ENTRY_OVER& = -190                                             ' Registration number-of-cases over
Public Const ERR_CROPAREAID& = -200                                             ' No specific CropAreaID
Public Const ERR_EXIST& = -210                                                  ' Already the same thing
Public Const ERR_NOT_FOUND& = -220                                              ' Not found
Public Const ERR_IMAGE_FILEOPEN& = -230                                         ' Open failure
Public Const ERR_IMAGE_UNKNOWNFORMAT& = -240                                    ' Format injustice
Public Const ERR_IMAGE_FAILED& = -250                                           ' Image creation failure
Public Const ERR_WORKAREA_NO_MEMORY& = -260                                     ' No memory for WORKAREA
Public Const ERR_WORKAREA_UNKNOWNFORMAT& = -270                                 ' Image creation failure because of format injustice
Public Const ERR_WORKAREA_FAILED& = -280                                        ' WORKAREA creation failure
Public Const ERR_IMAGE_FILEREAD& = -290                                         ' Image file read error
Public Const ERR_PAPERINSERT_TIMEOUT& = -300                                    ' Image paper insert error of timeout
Public Const ERR_EXEC_FUNCTION& = -310                                          ' Other API is running (3.01)
Public Const ERR_EXEC_MICR& = -320                                              ' Now reading MICR (3.01)
Public Const ERR_EXEC_SCAN& = -330                                              ' Now scaning image(3.01)
Public Const ERR_SS_NOT_EXIST& = -340                                           ' Status service not started (3.01)
Public Const ERR_SPL_NOT_EXIST& = -350                                          ' Spooler service not started (3.01)
Public Const ERR_SPL_PAUSED& = -370                                             ' Spooler service paused (3.01)
Public Const ERR_RESET& = -400                                                  ' Now printer is reseting (3.01)
Public Const ERR_THREAD& = -420                                                 ' Failure to the start of Thread (3.03)
Public Const ERR_ABORT& = -430                                                  ' Because BiSCNMICRCancelFunction was called, processing was stopped (3.03)
Public Const ERR_MICR& = -440                                                   ' Error occurred during MICR processing (3.03)
Public Const ERR_SCAN& = -450                                                   ' Error occurred during the image scan (3.03)
Public Const ERR_LINE_OVERFLOW& = -460                                          ' A line overflow has occurred during transaction printing (3.03)
Public Const ERR_NOT_EXEC& = -470                                               ' Processing is not executed (3.03)
Public Const ERR_SIZE& = -1000                                                  ' Size excess error
Public Const ERR_PAPER_PILED& = -1010                                           ' Paper pilling error
Public Const ERR_PAPER_JAM& = -1020                                             ' Paper jam has occurred
Public Const ERR_COVER_OPEN& = -1030                                            ' Cover open error
Public Const ERR_MICR_NODATA& = -1040                                           ' MICR data is not existing
Public Const ERR_MICR_BADDATA& = -1050                                          ' MICR data is not able to recognize
Public Const ERR_MICR_PARSE& = -1060                                            ' MICR data can not be parsed
Public Const ERR_MICR_NOISE& = -1070                                            ' Noise error has ocurred during MICR reading
Public Const ERR_SCN_COMPRESS& = -1080                                          ' Scan image data compressing error
Public Const ERR_PAPER_EXIST& = -1090                                           ' Because there is a paper on the path, API can not be execute
Public Const ERR_PAPER_INSERT& = -1100                                          ' Paper insertion error
Public Const ERR_LESS_CHECKS& = -1110                                           '
Public Const ERR_SCN_IQA& = -1120                                               ' IQA not pass
Public Const ERR_BARCODE_NODATA& = -1130                                        ' Barcode data is not existing
Public Const ERR_EXEC_SCAN_CHECK_CONTINUOUS& = -2000                            ' Now scanning check continuous mode
Public Const ERR_EXEC_SCAN_CHECK_ONEBYONE& = -2010                              ' Now scanning check one by one mode
Public Const ERR_EXEC_SCAN_IDCARD& = -2020                                      ' Now scanning ID card
Public Const ERR_EXEC_PRINT_ROLLPAPER& = -2030                                  ' Now printing text, image or barcode on roll paper.
Public Const ERR_EXEC_PRINT_VALIDATION& = -2040                                 ' Now printing text, image or barcode on validation.
Public Const ERR_FORM_LENGTH& = -2050                                           ' Paper Length error
Public Const ERR_MECHANICAL& = -2060                                            ' Mechanical error

Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// DeviceStatus Bit :
Public Const ASB_NO_RESPONSE& = &H1                                              'No response
Public Const ASB_PRINT_SUCCESS& = &H2                                            'Finish to print
Public Const ASB_UNRECOVER_ERR& = &H2000                                         'Unrecoverable error
Public Const ASB_AUTORECOVER_ERR& = &H4000                                       'Auto-Recoverable error
Public Const ASB_OFF_LINE& = &H8                                                 'Off-line
Public Const ASB_WAIT_ON_LINE& = &H100                                           'Waiting for on-line recovery
Public Const ASB_WAIT_PEPRT_EJECT& = &H100                                       'Waiting for slip remove  (3.03)
Public Const ASB_PANEL_SWITCH& = &H200                                           'Panel switch
Public Const ASB_PRINTER_FEED& = &H40                                            'Paper is being fed by using the PAPER FEED button
Public Const ASB_HEAD_TEMPERATURE_ERR& = &H4000                                  'Mechanical error
Public Const ASB_MECHANICAL_ERR& = &H400                                         'Mechanical error
Public Const ASB_LABEL_ERR& = &H400                                              'LABEL check error
Public Const ASB_AUTOCUTTER_ERR& = &H800                                         'Auto cutter error

Public Const ASB_DRAWER_KICK& = &H4                                              'Drawer kick-out connector pin3 is HIGH
Public Const ASB_PRESENTER_COVER& = &H4                                          'Presenter cover is open

Public Const ASB_JOURNAL_END& = &H40000                                          'Journal paper roll end
Public Const ASB_EJECT_SENSOR_NO_PAPER& = &H40000                                'Eject sensor no paper   (3.03)
Public Const ASB_RECEIPT_END& = &H80000                                          'Receipt paper roll end

Public Const ASB_COVER_OPEN& = &H20                                              'Cover is open
Public Const ASB_PLATEN_OPEN& = &H20                                             'Platen is open

Public Const ASB_JOURNAL_NEAR_END& = &H10000                                     'Journal paper roll near-end
Public Const ASB_JOURNAL_NEAR_END_FIRST& = &H10000                               'Journal paper roll near-end-first
Public Const ASB_NOT_CARD_INSERT& = &H10000                                      'Not card insert (3.03)

Public Const ASB_RECEIPT_NEAR_END& = &H20000                                     'Receipt paper roll near-end
Public Const ASB_RECEIPT_NEAR_END_FIRST& = &H20000                               'Receipt paper roll near-end-first

Public Const ASB_SLIP_TOF& = &H200000                                            'SLIP TOF
Public Const ASB_SLIP_TOF_2& = &H400000                                          'SLIP TOF 2
Public Const ASB_PSUPPLIER_END& = &H200000                                       'Paper supply end

Public Const ASB_SLIP_BOF& = &H400000                                            'SLIP BOF
Public Const ASB_SLIP_BOF_2& = &H200000                                          'SLIP BOF 2
Public Const ASB_RECEIPT_NEAR_END_SECOND& = &H400000                             'Receipt paper roll near-end-second
Public Const ASB_ASF_PAPER& = &H400000                                           'No paper ASF(3.03)

Public Const ASB_SLIP_SELECTED& = &H1000000                                      'Slip is not selected
Public Const ASB_PRESENTER_TE& = &H1000000                                       'Presenter T/E receipt end

Public Const ASB_PRINT_SLIP& = &H2000000                                         'Cannot print on slip
Public Const ASB_PRESENTER_TT& = &H2000000                                       'Presenter T/T receipt end

Public Const ASB_VALIDATION_SELECTED& = &H4000000                                'Validation is not selected
Public Const ASB_RETRACTOR_R1JAM& = &H4000000                                    'Retractor receipt end R1JAM

Public Const ASB_PRINT_VALIDATION& = &H8000000                                   'Cannot print on validation
Public Const ASB_RETRACTOR_BOX& = &H8000000                                      'Retractor box

Public Const ASB_VALIDATION_TOF& = &H20000000                                    'Validation TOF
Public Const ASB_RETRACTOR_R2JAM& = &H20000000                                   'Retractor receipt end R2JAM
Public Const ASB_WAIT_INSERT& = &H20000000                                       'Wait insert (3.03)

Public Const ASB_VALIDATION_BOF& = &H40000000                                    'Validation BOF
Public Const ASB_RETRACTOR_SENSOR3& = &H40000000                                 'Retractor sensor NO.3
Public Const ASB_VALIDATION_NO_PAPER& = &H40000000                               'Validation no paper (3.03)

Public Const ASB_BATTERY_OFFLINE& = &H4                                          'Off-line for BATTERY QUANTITY

Public Const ASB_PAPER_FEED& = &H40                                              'Paper is now feeding by PF FW (3.01)
Public Const ASB_PAPER_END& = &H40000                                            'Detected paper roll end (3.01)

Public Const ASB_PAPER_INTERMEDIATE& = &H10000                                   'Not paper in Paper intermediate sensor
Public Const ASB_MAIN_NEAR_FULL& = &H20000                                       'Main Pocket not Near Full
Public Const ASB_SUB_NEAR_FULL& = &H80000                                        'Sub Pocket not Near Full
Public Const ASB_SLIP_PAPER_SIZE& = &H200000                                     'Not paper in Slip Paper size sensor
Public Const ASB_STAMP_EXIST& = &H2000000                                        'Stamp not Exist
Public Const ASB_FRANKING_SENSOR& = &H40000000                                   'Not paper in Franking sensor

Public Const INK_ASB_NEAR_END& = &H1                                             'Ink near-end
Public Const INK_ASB_END& = &H2                                                  'Ink end
Public Const INK_ASB_NO_CARTRIDGE& = &H4                                         'Cartridge is not present
Public Const INK_ASB_NO_CARTRIDGE2& = &H8                                        'Cartridge2 is not present
Public Const INK_ASB_CLEANING& = &H20                                            'Being cleaned
Public Const INK_ASB_NEAR_END2& = &H100                                          'Ink near-end2
Public Const INK_ASB_END2& = &H200                                               'Ink end2

Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// BiOpenMonPrinter() :

Rem:// Type
Public Const TYPE_PORT& = 1                                                     ' use port name
Public Const TYPE_PRINTER& = 2                                                  ' use printer driver name

Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// BiSCNSetImageQuality() :

Rem:// Scale Option
Public Const EPS_BI_SCN_1BIT& = 1                                               ' Monochrome
Public Const EPS_BI_SCN_8BIT& = 8                                               ' Glay scale

Rem:// Color Option
Public Const EPS_BI_SCN_MONOCHROME& = 48                                        ' Monochrome
Public Const EPS_BI_SCN_COLOR& = 49                                             ' Color

Rem:// Extensive Option
Public Const EPS_BI_SCN_AUTO& = 48                                              ' Auto
Public Const EPS_BI_SCN_MANUAL& = 49                                            ' Manual
Public Const EPS_BI_SCN_SHARP& = 50                                             ' Sharpness
Public Const EPS_BI_SCN_SHARP_CUSTOM& = 51                                      ' Custom sharpness
Public Const EPS_BI_SCN_SHARP_CUSTOM2& = 52                                     ' Combination of sharpness and custom sharpness
Public Const EPS_BI_SCN_SHARP_CUSTOM3& = 53                                     ' Sharpness(eliminate checkered patterns)

Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// BiSCNSetImageFormat() :

Rem:// Format Option
Public Const EPS_BI_SCN_TIFF& = 1                                               ' TIFF format(CCITT Group 4)
Public Const EPS_BI_SCN_RASTER& = 2                                             ' Raster Image
Public Const EPS_BI_SCN_BITMAP& = 3                                             ' Bitmap
Public Const EPS_BI_SCN_TIFF256& = 4                                            ' TIFF format(Glay scale)
Public Const EPS_BI_SCN_JPEGHIGH& = 5                                           ' Jpeg format(High complessed)
Public Const EPS_BI_SCN_JPEGNORMAL& = 6                                         ' Jpeg format(Normal)
Public Const EPS_BI_SCN_JPEGLOW& = 7                                            ' Jpeg format(Low complessed)
Public Const EPS_BI_SCN_JTIFF& = 8                                              ' TIFF format(Jpeg complessed)

Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// BiSCNSelectScanUnit() :

Rem:// Scan unit ID
Public Const EPS_BI_SCN_UNIT_CHECKPAPER& = 48                           ' Checkpaper scanner unit
Public Const EPS_BI_SCN_UNIT_CARD& = 49                                 ' Card scanner unit

Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// BiESCNEnable() :

Rem:// Saved Method
Public Const CROP_STORE_MEMORY& = 0                                                     ' Saved memory
Public Const CROP_STORE_FILE& = 1                                                       ' Saved file

Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// BiESCNSetAutoSize() :

Rem:// Enable/Disable Autosize
Public Const CROP_AUTOSIZE_DISABLE& = 0                                         ' Enabled auto size
Public Const CROP_AUTOSIZE_ENABLE& = 1                                          ' Disabled auto size

Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// BiESCNSetRotate() :

Rem:// Enable/Disable Rotate
Public Const CROP_ROTATE_DISABLE& = 0                                                   ' Enabled rotate
Public Const CROP_ROTATE_ENABLE& = 1                                                    ' Disabled rotate

Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// BiESCNDefineCropArea() :

Rem:// CropArea Setting
Public Const CROP_AREA_RESET_ALL& = 0                                           ' Delete all crop area
Public Const CROP_AREA_ENTIRE_IMAGE& = 1                                        ' CropArea entire image
Public Const CROP_AREA_RIGHT& = 65535                                           ' End X Point
Public Const CROP_AREA_BOTTOM& = 65535                                          ' End Y Point

Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// BiESCNClearImage() :

Rem:// Delete Method
Public Const CROP_CLEAR_ALL_IMAGE& = 0                                          ' Delete all image
Public Const CROP_CLEAR_BY_FILEINDEX& = 1                                       ' Clear by fileIndex
Public Const CROP_CLEAR_BY_FILEID& = 2                                          ' Clear by fileId
Public Const CROP_CLEAR_BY_IMAGETAGDATA& = 4                                    ' by imageTagData

Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// BiSetPrintStation() :

Rem:// Printing Station
Public Const MF_ST_ROLLPAPER& = &H1                                             ' Roll paper printing
Public Const MF_ST_VALIDATION& = &H2                                            ' Validation printing
Public Const MF_ST_E_ENDORSEMENT& = &H4                                         ' Electric endorse printing
Public Const MF_ST_E_ENDORSEMENT_BACK& = &H4                                    ' Electric endorse printing(back side)
Public Const MF_ST_E_ENDORSEMENT_FRONT& = &H8                                   ' Electric endorse printing(front side)

Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// BiPrintText

'#pragma pack(push, 1)

Type MF_DECORATE
        lAttribute(1 To 4) As Byte
        wFont(1 To 2) As Byte
        szFontName(1 To 4) As Byte
        wFontSize(1 To 2) As Byte
End Type

'#pragma pack(pop)

Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// BiMICRSelectDataHandling

Rem:// bErrorSelect
Public Const ES_STOP_ALL& = &H0
Public Const ES_CONTINUE_ALL& = &H1
Public Const ES_CONTINUE_DOUBLEFEED& = &H2
Public Const ES_CONTINUE_NODATA& = &H4
Public Const ES_CONTINUE_BADDATA& = &H8
Public Const ES_CONTINUE_NOISE& = &H10

Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// BiBufferedPrint
Public Const MF_PRT_BUFFERING& = 1
Public Const MF_PRT_EXEC& = 2
Public Const MF_PRT_CLEAR& = 3

Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// BiRingBuzzer
Public Const MF_BUZZER_TONE_HIGH& = 0
Public Const MF_BUZZER_TONE_MIDDLE& = 2
Public Const MF_BUZZER_TONE_LOW& = 1

Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// BiSCNSetBehaviorToScnResult
Public Const MF_PROCESS_CONTINUE_OVERLAP& = 1
Public Const MF_PROCESS_CONTINUE_NOOVERLAP& = 2
Public Const MF_PROCESS_CONTINUE_CANCEL& = 3

Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// BiGetOcrABText
Public Const OCR_SOURCE_TRANSACTION_NUMBER& = 0
Public Const OCR_SOURCE_IMAGE_FILE& = 1

Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// BiGetVersion
Public Const DRIVER_TYPE_J9000& = 1
Public Const DRIVER_TYPE_S1000& = 2

Public Const VERSION_TYPE_DRIVER& = &H1
Public Const VERSION_TYPE_USB& = &H2
Public Const VERSION_TYPE_MICR& = &H3
Public Const VERSION_TYPE_MICR_E13B& = &H3
Public Const VERSION_TYPE_MICR_CMC7& = &H10003
Public Const VERSION_TYPE_OCR& = &H4
Public Const VERSION_TYPE_IMAGE& = &H5
Public Const VERSION_TYPE_IQA& = &H6
Public Const VERSION_TYPE_BARCODE& = &H7

Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// BiESCNGetDeSkew, BiESCNSetDeSkew
Public Const DESKEW_ALL& = 0
Public Const DESKEW_DISABLE& = 65535


Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// BiMICRClearSpaces
Public Const CLEAR_SPACE_DISABLE& = 0
Public Const CLEAR_SPACE_ENABLE& = 1

Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// BiSetOcrABAreaOrigin
Public Const OCR_ORIGIN_TOP_LEFT& = 0
Public Const OCR_ORIGIN_BOTTOM_LEFT& = 1
Public Const OCR_ORIGIN_TOP_RIGHT& = 2
Public Const OCR_ORIGIN_BOTTOM_RIGHT& = 3

Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// BiSetWaterfallMode
Public Const WATERFALL_MODE_DISABLE& = 0
Public Const WATERFALL_MODE_STANDARD& = 1
Public Const WATERFALL_MODE_INHERIT_POCKET& = 2

Rem:///////////////////////////////////////////////////////////////////////////////
Rem:// BiSetEndorseDirection
Public Const EENDORSE_DIRECTION_LEFTRIGHT& = 1
Public Const EENDORSE_DIRECTION_TOPBOTTOM& = 2
Public Const EENDORSE_DIRECTION_RIGHTLEFT& = 3
Public Const EENDORSE_DIRECTION_BOTTOMTOP& = 4


'typedef int (WINAPI* DLL_BiOpenMonPrinter)( int, LPSTR);
'typedef int (WINAPI* DLL_BiSetMonInterval)( int, WORD, WORD);
'typedef int (WINAPI* DLL_BiGetStatus)( int, LPDWORD);
'typedef int (WINAPI* DLL_BiSetStatusBackFunction)( int, int (CALLBACK EXPORT *pStatusCB)(DWORD dwStatus));
'typedef int (WINAPI* DLL_BiSetStatusBackWnd)( int, long, LPDWORD);
'typedef int (WINAPI* DLL_BiSetStatusBackFunctionEx)( int, int (CALLBACK EXPORT *pStatusCB)(DWORD dwStatus, LPSTR lpcPortName));
'typedef int (WINAPI* DLL_BiCancelStatusBack)( int );
'typedef int (WINAPI* DLL_BiResetPrinter)( int);
'typedef int (WINAPI* DLL_BiGetCounter)( int, WORD, LPDWORD);
'typedef int (WINAPI* DLL_BiResetCounter)( int, WORD);
'typedef int (WINAPI* DLL_BiCancelError)( int);
'typedef int (WINAPI* DLL_BiGetType)( int, LPBYTE, LPBYTE, LPBYTE, LPBYTE);
'typedef int (WINAPI* DLL_BiGetOfflineCode)( int, LPBYTE);
'typedef int (WINAPI* DLL_BiGetOfflineCodeByIndex)( int, int, LPBYTE);
'typedef int (WINAPI* DLL_BiMICRSelectDataHandling)( int, BYTE, BYTE, BYTE);
'typedef int (WINAPI* DLL_BiMICRGetStatus)( int, LPBYTE);
'typedef int (WINAPI* DLL_BiMICRCleaning)( int);
'typedef int (WINAPI* DLL_BiSCNSetImageQuality)( int, BYTE, char, BYTE, BYTE);
'typedef int (WINAPI* DLL_BiSCNSetImageFormat)( int, BYTE);
'typedef int (WINAPI* DLL_BiSCNSetScanArea)( int, BYTE, BYTE, BYTE, BYTE);
'typedef int (WINAPI* DLL_BiSCNGetImageQuality)( int, LPBYTE, char *, LPBYTE, LPBYTE);
'typedef int (WINAPI* DLL_BiSCNGetImageFormat)( int, LPBYTE);
'typedef int (WINAPI* DLL_BiSCNGetScanArea)( int, LPBYTE, LPBYTE, LPBYTE, LPBYTE);
'typedef int (WINAPI* DLL_BiSCNSetCroppingArea)( int, BYTE, BYTE, BYTE, BYTE, BYTE);
'typedef int (WINAPI* DLL_BiSCNGetCroppingArea)( int, LPWORD, LPBYTE);
'typedef int (WINAPI* DLL_BiSCNDeleteCroppingArea)( int, BYTE);
'typedef int (WINAPI* DLL_BiSCNSelectScanUnit)( int, BYTE);
'typedef int (WINAPI* DLL_BiSCNMICRFunction)(int iHandle, LPVOID lpvStruct, WORD wFunction);
'typedef int (WINAPI* DLL_BiSCNMICRCancelFunction)(int iHandle, WORD wEjectType);
'typedef int (WINAPI* DLL_BiSCNSelectScanFace)(int iHandle, BYTE bFace);
'typedef int (WINAPI* DLL_BiGetPrnCapability)( int, BYTE, LPBYTE, LPBYTE);
'typedef int (WINAPI* DLL_BiCloseMonPrinter)( int );
'typedef int (WINAPI* DLL_BiGetRealStatus)( int, LPDWORD);
'typedef int (WINAPI* DLL_BiSCNMICRFunctionContinuously)(int iHandle, LPVOID lpvStruct, WORD wFunction);
'typedef int (WINAPI* DLL_BiSCNMICRFunctionPostPrint)(int iHandle, LPVOID lpvStruct, WORD wFunction);
'typedef int (WINAPI* DLL_BiSCNMICRSetStatusBackFunction)(int, int (CALLBACK EXPORT *pScnMicrCB)(DWORD dwTransactionNumber, WORD wMainStatus, WORD wSubStatus, LPSTR lpPortName));
'typedef int (WINAPI* DLL_BiSCNMICRSetStatusBackWnd)(int, long, LPDWORD, LPWORD, LPWORD);
'typedef int (WINAPI* DLL_BiSCNMICRCancelStatusBack)(int);
'typedef int (WINAPI* DLL_BiGetMicrText)(int, DWORD, LPMF_MICR);
'typedef int (WINAPI* DLL_BiGetScanImage)(int, DWORD, LPMF_SCAN);
'typedef int (WINAPI* DLL_BiGetTransactionNumber)(int, LPDWORD);
'typedef int (WINAPI* DLL_BiSetTransactionNumber)(int, DWORD);
'typedef int (WINAPI* DLL_BiGetPrintStation)(int, LPWORD);
'typedef int (WINAPI* DLL_BiSetPrintStation)(int, WORD);
'typedef int (WINAPI* DLL_BiPrintText)(int, LPSTR, MF_DECORATE);
'typedef int (WINAPI* DLL_BiPrintImage)(int, LPSTR);
'typedef int (WINAPI* DLL_BiGetPrintSize)(int, LPWORD, LPWORD);
'typedef int (WINAPI* DLL_BiSetPrintSize)(int, WORD, WORD);
'typedef int (WINAPI* DLL_BiGetPrintPosition)(int, LPWORD, LPWORD);
'typedef int (WINAPI* DLL_BiSetPrintPosition)(int, WORD, WORD);
'typedef int (WINAPI* DLL_BiBufferedPrint)(int, DWORD);
'typedef int (WINAPI* DLL_BiSetTransactionNumberWithIncremental)(int, DWORD, DWORD);
'typedef int (WINAPI* DLL_BiSetBehaviorToScnResult)(int, BYTE, BYTE, BYTE);
'typedef int (WINAPI* DLL_BiRingBuzzer)(int, BYTE, BYTE, WORD, WORD);
'typedef int (WINAPI* DLL_BiGetVersion)(int, int, LPVERSION_INFO);
'typedef int (WINAPI* DLL_BiSetNumberOfDocuments)(int, BYTE);
'typedef int (WINAPI* DLL_BiMICRClearSpaces)(int, BYTE);
'typedef int (WINAPI* DLL_BiSetOcrABAreaOrigin)(int, BYTE);
'typedef int (WINAPI* DLL_BiSetPaperThickness)(int, WORD);
'typedef int (WINAPI* DLL_BiSetWaterfallMode)(int, BYTE);
'typedef int (WINAPI* DLL_BiGetIqaResult)(int, DWORD, LPMF_IQA_RESULT);
'typedef int (WINAPI* DLL_BiSetEndorseDirection)(int, BYTE);
'typedef int (WINAPI* DLL_BiGetBarcodeData)(int, DWORD, LPMF_BARCODE);
'typedef int (WINAPI* DLL_BiDecodeBarcode)(int, LPCSTR, LPMF_BARCODE);
'typedef int (WINAPI* DLL_BiDecodeBarcodeMemory)(int, LPBYTE, DWORD, LPMF_BARCODE);

'typedef int (WINAPI* DLL_BiESCNEnable)(BYTE);
'typedef int (WINAPI* DLL_BiESCNGetAutoSize)(int, LPBYTE);
'typedef int (WINAPI* DLL_BiESCNSetAutoSize)(int, BYTE);
'typedef int (WINAPI* DLL_BiESCNGetCutSize)(int, LPWORD);
'typedef int (WINAPI* DLL_BiESCNSetCutSize)(int, WORD);
'typedef int (WINAPI* DLL_BiESCNGetRotate)(int, LPBYTE);
'typedef int (WINAPI* DLL_BiESCNSetRotate)(int, BYTE);
'typedef int (WINAPI* DLL_BiESCNGetDocumentSize)(int, LPWORD, LPWORD);
'typedef int (WINAPI* DLL_BiESCNSetDocumentSize)(int, WORD, WORD);
'typedef int (WINAPI* DLL_BiESCNDefineCropArea)(int, BYTE, WORD, WORD, WORD, WORD);
'typedef int (WINAPI* DLL_BiESCNGetMaxCropAreas)(int, LPBYTE);
'typedef int (WINAPI* DLL_BiESCNStoreImage)(int, DWORD, LPSTR, LPSTR, BYTE);
'typedef int (WINAPI* DLL_BiESCNRetrieveImage)(int, DWORD, LPSTR, LPSTR, LPDWORD, LPBYTE);
'typedef int (WINAPI* DLL_BiESCNClearImage)(int, BYTE, DWORD, LPSTR, LPSTR);
'typedef int (WINAPI* DLL_BiESCNGetRemainingImages)(int, LPBYTE);

Rem://#End If // !defined(_EPSSTMAPIINTERFACE_H)

