VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ErrorCode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Private Const SUCCESS                         As Integer = 0           ' Success
Private Const ERR_TYPE                        As Integer = -10         ' nType error
Private Const ERR_OPENED                      As Integer = -20         ' Already opened
Private Const ERR_NO_PRINTER                  As Integer = -30         ' There is not printer driver
Private Const ERR_NO_TARGET                   As Integer = -40         ' Printer out of object
Private Const ERR_NO_MEMORY                   As Integer = -50         ' No memory
Private Const ERR_HANDLE                      As Integer = -60         ' Invalid handle
Private Const ERR_TIMEOUT                     As Integer = -70         ' Ttime out
Private Const ERR_ACCESS                      As Integer = -80         ' cannot read/write
Private Const ERR_PARAM                       As Integer = -90         ' param error
Private Const ERR_NOT_SUPPORT                 As Integer = -100        ' not support
Private Const ERR_OFFLINE                     As Integer = -110        ' now offline
Private Const ERR_NOT_EPSON                   As Integer = -120        ' not epson printer
Private Const ERR_WITHOUT_CB                  As Integer = -130        ' without callback function
Private Const ERR_BUFFER_OVER_FLOW            As Integer = -140        ' Read buffer over flow
Private Const ERR_REGISTRY                    As Integer = -150        ' Regstry error
Private Const ERR_ENABLE                      As Integer = -160        ' BiOpenMonPrinter() is already called
Private Const ERR_DISK_FULL                   As Integer = -170        ' Capacity of a disk is insufficient
Private Const ERR_NO_IMAGE                    As Integer = -180        ' No image data
Private Const ERR_ENTRY_OVER                  As Integer = -190        ' Registration numberAs Integer = -ofAs Integer = -cases over
Private Const ERR_CROPAREAID                  As Integer = -200        ' No specific CropAreaID
Private Const ERR_EXIST                       As Integer = -210        ' Already the same thing
Private Const ERR_NOT_FOUND                   As Integer = -220        ' Not found
Private Const ERR_IMAGE_FILEOPEN              As Integer = -230        ' Open failure
Private Const ERR_IMAGE_UNKNOWNFORMAT         As Integer = -240        ' Format injustice
Private Const ERR_IMAGE_FAILED                As Integer = -250        ' Image creation failure
Private Const ERR_WORKAREA_NO_MEMORY          As Integer = -260        ' No memory for WORKAREA
Private Const ERR_WORKAREA_UNKNOWNFORMAT      As Integer = -270        ' Image creation failure because of format injustice
Private Const ERR_WORKAREA_FAILED             As Integer = -280        ' WORKAREA creation failure
Private Const ERR_IMAGE_FILEREAD              As Integer = -290        ' Image file read error
Private Const ERR_PAPERINSERT_TIMEOUT         As Integer = -300        ' Image paper insert error of timeout
Private Const ERR_EXEC_FUNCTION               As Integer = -310        ' Other API is running (3.01)
Private Const ERR_EXEC_MICR                   As Integer = -320        ' Now reading MICR (3.01)
Private Const ERR_EXEC_SCAN                   As Integer = -330        ' Now scaning image(3.01)
Private Const ERR_SS_NOT_EXIST                As Integer = -340        ' Status service not started (3.01)
Private Const ERR_SPL_NOT_EXIST               As Integer = -350        ' Spooler service not started (3.01)
Private Const ERR_SPL_PAUSED                  As Integer = -370        ' Spooler service paused (3.01)
Private Const ERR_RESET                       As Integer = -400        ' Now printer is reseting (3.01)
Private Const ERR_THREAD                      As Integer = -420        ' Failure to the start of Thread (3.03)
Private Const ERR_ABORT                       As Integer = -430        ' Because BiSCNMICRCancelFunction was called, processing was stopped (3.03)
Private Const ERR_MICR                        As Integer = -440        ' Error occurred during MICR processing (3.03)
Private Const ERR_SCAN                        As Integer = -450        ' Error occurred during the image scan (3.03)
Private Const ERR_LINE_OVERFLOW               As Integer = -460        ' A line overflow has occurred during transaction printing (3.03)
Private Const ERR_NOT_EXEC                    As Integer = -470        ' Processing is not executed (3.03)
Private Const ERR_SIZE                        As Integer = -1000       ' Size excess error
Private Const ERR_PAPER_PILED                 As Integer = -1010       ' Paper pilling error
Private Const ERR_PAPER_JAM                   As Integer = -1020       ' Paper jam has occurred
Private Const ERR_COVER_OPEN                  As Integer = -1030       ' Cover open error
Private Const ERR_MICR_NODATA                 As Integer = -1040       ' MICR data is not existing
Private Const ERR_MICR_BADDATA                As Integer = -1050       ' MICR data is not able to recognize
Private Const ERR_MICR_PARSE                  As Integer = -1060       ' MICR data can not be parsed
Private Const ERR_MICR_NOISE                  As Integer = -1070       ' Noise error has ocurred during MICR reading
Private Const ERR_SCN_COMPRESS                As Integer = -1080       ' Scan image data compressing error
Private Const ERR_PAPER_EXIST                 As Integer = -1090       ' Because there is a paper on the path, API can not be execute
Private Const ERR_PAPER_INSERT                As Integer = -1100       ' Paper insertion error
Private Const ERR_LESS_CHECKS                 As Integer = -1110       '
Private Const ERR_SCN_IQA                     As Integer = -1120       ' IQA not pass
Private Const ERR_BARCODE_NODATA              As Integer = -1130       ' Barcode data is not existing
Private Const ERR_EXEC_SCAN_CHECK_CONTINUOUS      As Integer = -2000   ' Now scanning check continuous mode
Private Const ERR_EXEC_SCAN_CHECK_ONEBYONE        As Integer = -2010   ' Now scanning check one by one mode
Private Const ERR_EXEC_SCAN_IDCARD                As Integer = -2020   ' Now scanning ID card
Private Const ERR_EXEC_PRINT_ROLLPAPER            As Integer = -2030   ' Now printing text, image or barcode on roll paper.
Private Const ERR_EXEC_PRINT_VALIDATION           As Integer = -2040   ' Now printing text, image or barcode on validation.
Private Const ERR_FORM_LENGTH                     As Integer = -2050   ' Paper Length error
Private Const ERR_MECHANICAL                      As Integer = -2060   ' Mechanical error

Public Property Get ChangeErrorCode(ByVal Error As Long) As String
    Select Case Error
    Case SUCCESS
        ChangeErrorCode = "SUCCESS"

    Case ERR_TYPE
        ChangeErrorCode = "ERR_TYPE"

    Case ERR_OPENED
        ChangeErrorCode = "ERR_OPENED"

    Case ERR_NO_PRINTER
        ChangeErrorCode = "ERR_NO_PRINTER"

    Case ERR_NO_TARGET
        ChangeErrorCode = "ERR_NO_TARGET"

    Case ERR_NO_MEMORY
        ChangeErrorCode = "ERR_NO_MEMORY"

    Case ERR_HANDLE
        ChangeErrorCode = "ERR_HANDLE"

    Case ERR_TIMEOUT
        ChangeErrorCode = "ERR_TIMEOUT"

    Case ERR_ACCESS
        ChangeErrorCode = "ERR_ACCESS"

    Case ERR_PARAM
        ChangeErrorCode = "ERR_PARAM"

    Case ERR_NOT_SUPPORT
        ChangeErrorCode = "ERR_NOT_SUPPORT"

    Case ERR_OFFLINE
        ChangeErrorCode = "ERR_OFFLINE"

    Case ERR_NOT_EPSON
        ChangeErrorCode = "ERR_NOT_EPSON"

    Case ERR_WITHOUT_CB
        ChangeErrorCode = "ERR_WITHOUT_CB"

    Case ERR_BUFFER_OVER_FLOW
        ChangeErrorCode = "ERR_BUFFER_OVER_FLOW"

    Case ERR_REGISTRY
        ChangeErrorCode = "ERR_REGISTRY"

    Case ERR_ENABLE
        ChangeErrorCode = "ERR_ENABLE"

    Case ERR_DISK_FULL
        ChangeErrorCode = "ERR_DISK_FULL"

    Case ERR_NO_IMAGE
        ChangeErrorCode = "ERR_NO_IMAGE"

    Case ERR_ENTRY_OVER
        ChangeErrorCode = "ERR_ENTRY_OVER"

    Case ERR_CROPAREAID
        ChangeErrorCode = "ERR_CROPAREAID"

    Case ERR_EXIST
        ChangeErrorCode = "ERR_EXIST"

    Case ERR_NOT_FOUND
        ChangeErrorCode = "ERR_NOT_FOUND"

    Case ERR_IMAGE_FILEOPEN
        ChangeErrorCode = "ERR_IMAGE_FILEOPEN"

    Case ERR_IMAGE_UNKNOWNFORMAT
        ChangeErrorCode = "ERR_IMAGE_UNKNOWNFORMAT"

    Case ERR_IMAGE_FAILED
        ChangeErrorCode = "ERR_IMAGE_FAILED"

    Case ERR_WORKAREA_NO_MEMORY
        ChangeErrorCode = "ERR_WORKAREA_NO_MEMORY"

    Case ERR_WORKAREA_UNKNOWNFORMAT
        ChangeErrorCode = "ERR_WORKAREA_UNKNOWNFORMAT"

    Case ERR_WORKAREA_FAILED
        ChangeErrorCode = "ERR_WORKAREA_FAILED"

    Case ERR_IMAGE_FILEREAD
        ChangeErrorCode = "ERR_IMAGE_FILEREAD"

    Case ERR_PAPERINSERT_TIMEOUT
        ChangeErrorCode = "ERR_PAPERINSERT_TIMEOUT"

    Case ERR_EXEC_FUNCTION
        ChangeErrorCode = "ERR_EXEC_FUNCTION"

    Case ERR_EXEC_MICR
        ChangeErrorCode = "ERR_EXEC_MICR"

    Case ERR_EXEC_SCAN
        ChangeErrorCode = "ERR_EXEC_SCAN"

    Case ERR_SS_NOT_EXIST
        ChangeErrorCode = "ERR_SS_NOT_EXIST"

    Case ERR_SPL_NOT_EXIST
        ChangeErrorCode = "ERR_SPL_NOT_EXIST"

    Case ERR_SPL_PAUSED
        ChangeErrorCode = "ERR_SPL_PAUSED"

    Case ERR_RESET
        ChangeErrorCode = "ERR_RESET"

    Case ERR_THREAD
        ChangeErrorCode = "ERR_THREAD"

    Case ERR_ABORT
        ChangeErrorCode = "ERR_ABORT"

    Case ERR_MICR
        ChangeErrorCode = "ERR_MICR"

    Case ERR_SCAN
        ChangeErrorCode = "ERR_SCAN"

    Case ERR_LINE_OVERFLOW
        ChangeErrorCode = "ERR_LINE_OVERFLOW"

    Case ERR_NOT_EXEC
        ChangeErrorCode = "ERR_NOT_EXEC"

    Case ERR_SIZE
        ChangeErrorCode = "ERR_SIZE"

    Case ERR_PAPER_PILED
        ChangeErrorCode = "ERR_PAPER_PILED"

    Case ERR_PAPER_JAM
        ChangeErrorCode = "ERR_PAPER_JAM"

    Case ERR_COVER_OPEN
        ChangeErrorCode = "ERR_COVER_OPEN"

    Case ERR_MICR_NODATA
        ChangeErrorCode = "ERR_MICR_NODATA"

    Case ERR_MICR_BADDATA
        ChangeErrorCode = "ERR_MICR_BADDATA"

    Case ERR_MICR_PARSE
        ChangeErrorCode = "ERR_MICR_PARSE"

    Case ERR_MICR_NOISE
        ChangeErrorCode = "ERR_MICR_NOISE"

    Case ERR_SCN_COMPRESS
        ChangeErrorCode = "ERR_SCN_COMPRESS"

    Case ERR_PAPER_EXIST
        ChangeErrorCode = "ERR_PAPER_EXIST"

    Case ERR_PAPER_INSERT
        ChangeErrorCode = "ERR_PAPER_INSERT"

    Case ERR_LESS_CHECKS
        ChangeErrorCode = "ERR_LESS_CHECKS"
        
    Case ERR_SCN_IQA
        ChangeErrorCode = "ERR_SCN_IQA"
        
    Case ERR_BARCODE_NODATA
        ChangeErrorCode = "ERR_BARCODE_NODATA"
        
    Case ERR_EXEC_SCAN_CHECK_CONTINUOUS
        ChangeErrorCode = "ERR_EXEC_SCAN_CHECK_CONTINUOUS"

    Case ERR_EXEC_SCAN_CHECK_ONEBYONE
        ChangeErrorCode = "ERR_EXEC_SCAN_CHECK_ONEBYONE"

    Case ERR_EXEC_SCAN_IDCARD
        ChangeErrorCode = "ERR_EXEC_SCAN_IDCARD"

    Case ERR_EXEC_PRINT_ROLLPAPER
        ChangeErrorCode = "ERR_EXEC_PRINT_ROLLPAPER"

    Case ERR_EXEC_PRINT_VALIDATION
        ChangeErrorCode = "ERR_EXEC_PRINT_VALIDATION"

    Case ERR_FORM_LENGTH
        ChangeErrorCode = "ERR_FORM_LENGTH"

    Case ERR_MECHANICAL
        ChangeErrorCode = "ERR_MECHANICAL"

    Case Else
        ChangeErrorCode = Error
    End Select
End Property
