Attribute VB_Name = "MultiFunction"
Option Explicit

Rem://///////////////////////////////////////////////////////////////////
Rem://
Rem:// MultiFunction.h
Rem://
Rem:// Definition of the constants and also data type.
Rem://
Rem:// Modification history
Rem:// ------------------------------------------------------------------
Rem:// 2006-01-13   New
Rem:// 2007-01-16   Modified
Rem://///////////////////////////////////////////////////////////////////

Rem:#if !defined(_MULTI_FUNCTION_H)
Rem:Public Const _MULTI_FUNCTION_H

'#pragma pack(push, 1)
Public Const WM_USER& = &H400


Rem:// Message ID
Public Const WM_MF_DONE& = (WM_USER + 1)
Public Const WM_MF_PROGRESS& = (WM_USER + 2)

Rem:// wParam
'Public Const MF_MACRO_GETUNITID(wParam)              LOBYTE(HIWORD(wParam))
'Public Const MF_MACRO_GETPHASE(wParam)               LOBYTE(LOWORD(wParam))
'Public Const MF_MACRO_GETFACE(lParam)                LOBYTE(HIWORD(lParam))
'Public Const MF_MACRO_PERCENT(lParam)                LOBYTE(LOWORD(lParam))

Public Const MF_PHASE_INIT& = 0
Public Const MF_PHASE_MICR& = 1
Public Const MF_PHASE_SCAN& = 2
Public Const MF_PHASE_PRINT& = 3
Public Const MF_PHASE_EXIT& = 4

Public Const MF_PROGRESS_START& = 0
Public Const MF_PROGRESS_DONE& = 100
Public Const MF_PROGRESS_WAIT_PAPER& = 101
Public Const MF_PROGRESS_CLUMP_PAPER& = 102
Public Const MF_PROGRESS_PAPER_PILED& = 103

Rem:// BiSCNMICRSetStatusBackFunction or BiSCNMICRSetStatusBackWnd
Rem:// wMainStatus
Public Const MF_FUNCTION_START& = 200
Public Const MF_CHECKPAPER_PROCESS_START& = 201
Public Const MF_DATARECEIVE_START& = 202
Public Const MF_DATARECEIVE_DONE& = 203
Public Const MF_CHECKPAPER_PROCESS_DONE& = 204
Public Const MF_FUNCTION_DONE& = 205
Public Const MF_ERROR_OCCURED& = 299

Rem:// Function define
Public Const MF_EXEC& = &H0
Public Const MF_CONTINUE& = &H1
Public Const MF_MICR_RETRANS& = &H2
Public Const MF_SCAN_FRONT_RETRANS& = &H3
Public Const MF_SCAN_BACK_RETRANS& = (MF_SCAN_FRONT_RETRANS + 1)

Public Const MF_SET_BASE_PARAM& = &H10
Public Const MF_SET_MICR_PARAM& = &H11
Public Const MF_SET_SCAN_FRONT_PARAM& = &H12
Public Const MF_SET_SCAN_PARAM& = &H12
Public Const MF_SET_SCAN_BACK_PARAM& = (MF_SET_SCAN_FRONT_PARAM + 1)
Public Const MF_SET_PRINT_PARAM& = &H14
Public Const MF_SET_PROCESS_PARAM& = &H15                              ' (kabuto)
Public Const MF_SET_IQA_PARAM& = &H16      ' (TM-S1000 Version1.03)
Public Const MF_SET_BARCODE_FRONT_PARAM& = &H17      ' (TM-S1000 Version1.04)
Public Const MF_SET_BARCODE_PARAM& = &H17            ' (TM-S1000 Version1.04)
Public Const MF_SET_BARCODE_BACK_PARAM& = (MF_SET_BARCODE_FRONT_PARAM + 1)        ' (TM-S1000 Version1.04)

Public Const MF_CLEAR_BASE_PARAM& = &H20
Public Const MF_CLEAR_MICR_PARAM& = &H21
Public Const MF_CLEAR_SCAN_FRONT_PARAM& = &H22
Public Const MF_CLEAR_SCAN_PARAM& = &H22
Public Const MF_CLEAR_SCAN_BACK_PARAM& = (MF_CLEAR_SCAN_FRONT_PARAM + 1)
Public Const MF_CLEAR_PRINT_PARAM& = &H24
Public Const MF_CLEAR_PROCESS_PARAM& = &H25                             ' (kabuto)
Public Const MF_CLEAR_IQA_PARAM& = &H26      ' (TM-S1000 Version1.03)
Public Const MF_CLEAR_BARCODE_FRONT_PARAM& = &H27      ' (TM-S1000 Version1.04)
Public Const MF_CLEAR_BARCODE_PARAM& = &H27            ' (TM-S1000 Version1.04)
Public Const MF_CLEAR_BARCODE_BACK_PARAM& = (MF_CLEAR_BARCODE_FRONT_PARAM + 1)      ' (TM-S1000 Version1.04)

Public Const MF_GET_BASE_DEFAULT& = &H30
Public Const MF_GET_MICR_DEFAULT& = &H31
Public Const MF_GET_SCAN_DEFAULT& = &H32
Public Const MF_GET_SCAN_FRONT_DEFAULT& = &H32
Public Const MF_GET_SCAN_BACK_DEFAULT& = (MF_GET_SCAN_FRONT_DEFAULT + 1)
Public Const MF_GET_PRINT_DEFAULT& = &H34
Public Const MF_GET_PROCESS_DEFAULT& = &H35                             ' (kabuto)
Public Const MF_GET_IQA_DEFAULT& = &H36      ' (TM-S1000 Version1.03)
Public Const MF_GET_BARCODE_DEFAULT& = &H37            ' (TM-S1000 Version1.04)
Public Const MF_GET_BARCODE_FRONT_DEFAULT& = &H37      ' (TM-S1000 Version1.04)
Public Const MF_GET_BARCODE_BACK_DEFAULT& = (MF_GET_BARCODE_FRONT_DEFAULT + 1)      ' (TM-S1000 Version1.04)

Rem:/**********************/
Rem:/* Base parameters    */
Rem:/**********************/
Rem:// struct version(for iVersion)
Public Const MF_FIRST_VERSION& = &H100
Public Const MF_BASE_VERSION01& = &H101
Public Const MF_BASE_VERSION& = &H100

Rem:// Event notice type(for dwNotifyType)
Public Const MF_BASE_MESSAGE_NO_MESSAGE& = 1
Public Const MF_BASE_MESSAGE_EVENT& = 2
Public Const MF_BASE_MESSAGE_HWND& = 3
Public Const MF_BASE_MESSAGE_BUTTON_CLICK& = 4
Public Const MF_BASE_MESSAGE_NOTIFY_MAX& = MF_BASE_MESSAGE_BUTTON_CLICK

Rem:// Paper insertion timeout(for dwTimeout)
Public Const MF_BASE_TIMEOUT_MAX& = 300                 ' 5 min
Public Const MF_BASE_TIMEOUT_DEFAULT& = 0               ' INFINITE

Rem:// NV memory use type(for bUseNVMemory)
Public Const MF_BASE_NVMEMORY_NOT_USE& = 0
Public Const MF_BASE_NVMEMORY_USE& = 1

Rem:// Paper eject type(for wErrorEject and wSuccessEject)
Public Const MF_EJECT_DISCHARGE& = &H0
Public Const MF_EJECT_RELEASE& = &H1
Public Const MF_EXIT_ERROR_DISCHARGE& = MF_EJECT_DISCHARGE
Public Const MF_EXIT_ERROR_RELEASE& = MF_EJECT_RELEASE
Public Const MF_EXIT_SUCCESS_DISCHARGE& = MF_EJECT_DISCHARGE
Public Const MF_EXIT_SUCCESS_RELEASE& = MF_EJECT_RELEASE
Public Const MF_EXIT_ERROR_CONTINUE_DISCHARGE& = &H10
Public Const MF_EXIT_ERROR_CONTINUE_RELEASE& = &H11

Rem:// Buzzer factor type(for bBuzzerHz and bBuzzerCount)
Public Const MF_BUZZER_TYPE_SUCCESS& = 0
Public Const MF_BUZZER_TYPE_ERROR& = 1
Public Const MF_BUZZER_TYPE_WFEED& = 2
Public Const MF_BUZZER_TYPE_MAX& = 3

Rem:// Buzzer type(for bBuzzerHz)
Public Const MF_BUZZER_HZ_4000& = 0
Public Const MF_BUZZER_HZ_440& = 1
Public Const MF_BUZZER_HZ_880& = 2

Rem:// Buzzer count(for bBuzzerCount)
Public Const MF_BUZZER_DISABLE& = 0
Public Const MF_BUZZER_COUNT_MAX& = 3

Rem:// Base Structure (Version &H0101)
Public Type MF_BASE01
Rem:// Base Section
        iSize(1 To 4) As Byte
        iVersion(1 To 4) As Byte
        iRet(1 To 4) As Byte
        dwNotifyType(1 To 4) As Byte
        dwTimeout(1 To 4) As Byte
        uNotifyHandle(1 To 4) As Byte
        hProgressWnd(1 To 4) As Byte
        wErrorEject(1 To 2) As Byte
        bBuzzerHz(1 To MF_BUZZER_TYPE_MAX) As Byte
        bBuzzerCount(1 To MF_BUZZER_TYPE_MAX) As Byte
        bUseNVMemory As Byte
        cPortName(1 To 256) As Byte
        wSuccessEject(1 To 2) As Byte
End Type

Rem:// Base Structure (OLD:Version &H0100)
Public Type MF_BASE
Rem:// Base Section
        iSize As Long
        iVersion As Long
        iRet As Long
        dwNotifyType As Long
        dwTimeout As Long
        uNotifyHandle As Long
        hProgressWnd As Object
        wErrorEject As Integer
        bBuzzerHz(MF_BUZZER_TYPE_MAX) As Byte
        bBuzzerCount(MF_BUZZER_TYPE_MAX) As Byte
        bUseNVMemory As Byte
        cPortName(256) As Byte
End Type

Rem:/**********************/
Rem:/* MICR parameters    */
Rem:/**********************/
Rem:// Structure version(for iVersion)
Public Const MF_MICR_VERSION& = &H100

Rem:// MICR type(for bMicOcrSelect)
Public Const MF_MICR_USE_MICR& = 1
Public Const MF_MICR_USE_OCR& = 2

Rem:// Font(for bFont)
Public Const MF_MICR_FONT_E13B& = 0
Public Const MF_MICR_FONT_CMC7& = 1

Public Const MF_MICR_CHAR_MAX& = 81
Public Const MF_MICR_CHAR_LEN& = 80

Rem:// Reliability structure
Public Type MF_OCR_RELIABILITY
        cRecogChar As Byte                ' Recognized character
        lPercentage(1 To 4) As Byte       ' Reliability(%)
End Type

Rem:// Reliability information structure
Public Type MF_OCR_RELIABLE_INFO
        lPosition(1 To 4) As Byte               ' Position(0 is left edge)
        stFirstSelect As MF_OCR_RELIABILITY     ' First recognition candidate
        stSecondSelect As MF_OCR_RELIABILITY    ' Second recognition candidate
End Type

Rem:// MICR/OCR structure
Public Type MF_MICR
Rem:// MIC_OCR Section
        iSize(1 To 4) As Byte
        iVersion(1 To 4) As Byte
        iRet(1 To 4) As Byte
        bFont As Byte
        bMicOcrSelect As Byte
        blParsing(1 To 4) As Byte

        bStatus As Byte
        bDetail As Byte
        szMicrStr(1 To MF_MICR_CHAR_MAX) As Byte
        stOcrReliableInfo(1 To MF_MICR_CHAR_MAX) As MF_OCR_RELIABLE_INFO
        szAccountNumber(1 To MF_MICR_CHAR_MAX) As Byte
        szAmount(1 To MF_MICR_CHAR_MAX) As Byte
        szBankNumber(1 To MF_MICR_CHAR_MAX) As Byte
        szSerialNumber(1 To MF_MICR_CHAR_MAX) As Byte
        szEPC(1 To MF_MICR_CHAR_MAX) As Byte
        szTransitNumber(1 To MF_MICR_CHAR_MAX) As Byte
        lCheckType(1 To 4) As Byte
        lCountryCode(1 To 4) As Byte
End Type

Rem:/**********************/
Rem:/* Scan parameters    */
Rem:/**********************/
Rem:// Structure version
Public Const MF_SCAN_VERSION& = &H100

Rem:// Scan face type(for BiSCNSelectScanFace)
Public Const MF_SCAN_FACE_FRONT& = 0
Public Const MF_SCAN_FACE_BACK& = 1
Public Const MF_SCAN_FACE_BOTH& = 2

Rem:// Scan resolution(for sResolution)
Public Const MF_SCAN_DPI_DEFAULT& = 0
Public Const MF_SCAN_DPI_100& = 100
Public Const MF_SCAN_DPI_120& = 120
Public Const MF_SCAN_DPI_200& = 200

Rem:// Scan structure
Public Type MF_SCAN
Rem:// Scan Section
        iSize(1 To 4) As Byte
        iVersion(1 To 4) As Byte
        iRet(1 To 4) As Byte
        wImageID(1 To 2) As Byte
        sResolution(1 To 2) As Byte
        bAddInfoDataSize As Byte
        pAddInfoData(1 To 4) As Byte
        
        bStatus As Byte
        bDetail As Byte
        dwXSize(1 To 4) As Byte
        dwYSize(1 To 4) As Byte
        dwScanSize(1 To 4) As Byte
        lpbScanData(1 To 4) As Byte
End Type

Rem:/**********************/
Rem:/* Print parameters   */
Rem:/**********************/
Rem:// Structure version(for iVersion)
Public Const MF_PRINT_VERSION01& = &H101
Public Const MF_PRINT_VERSION& = &H100

Rem:// Line number(for lpString,dwAttribute,wFont and wfontSize)
Public Const MF_PRINT_LINE_1& = 0
Public Const MF_PRINT_LINE_2& = 1
Public Const MF_PRINT_LINE_3& = 2
Public Const MF_PRINT_LINE_MAX& = MF_PRINT_LINE_3

Rem:// Charactor attribute(for dwAttribute)
Public Const MF_PRINT_NO_ATTRIBUTE& = &H0
Public Const MF_PRINT_BOLD& = &H1
Public Const MF_PRINT_UNDERLINE_1& = &H10
Public Const MF_PRINT_UNDERLINE_2& = &H20
Public Const MF_PRINT_BLACK& = &H100
Public Const MF_PRINT_1ST_COLOR& = &H100
Public Const MF_PRINT_COLOR& = &H200
Public Const MF_PRINT_2ND_COLOR& = &H200
Public Const MF_PRINT_MIXED& = &H300
Public Const MF_PRINT_REVERSEVIDEO& = &H1000

Rem:// Font type(for wFont)
Public Const MF_PRINT_FONT_A& = 1
Public Const MF_PRINT_FONT_B& = 2
Public Const MF_PRINT_SYSTEMFONT& = 3

Rem:// Font size(for wFontSize)
Public Const MF_PRINT_FONT_W1_H1& = &H11
Public Const MF_PRINT_FONT_W1_H2& = &H12
Public Const MF_PRINT_FONT_W2_H1& = &H21
Public Const MF_PRINT_FONT_W2_H2& = &H22

Rem:// Printing speed(for bSpeed)
Public Const MF_PRINT_SPEED_NORMAL& = 0
Public Const MF_PRINT_SPEED_HIGH& = 1
Public Const MF_PRINT_SPEED_ECONOMY& = 2

Rem:// PrintDirection(for bDirection)
Public Const MF_PRINT_DERECTION_DOUBLE& = 0
Public Const MF_PRINT_DIRECTION_DOUBLE& = 0
Public Const MF_PRINT_DERECTION_SINGLE& = 1
Public Const MF_PRINT_DIRECTION_SINGLE& = 1

Rem:// Endorse type
Public Const MF_PRINT_TYPE_ENDORSE_ONLY& = 0
Public Const MF_PRINT_TYPE_ENDORSE_NORMAL& = 1
Public Const MF_PRINT_TYPE_ELECTRIC_ENDORSE_ONLY& = 2
Public Const MF_PRINT_TYPE_ENDORSE_EXTEND& = 3
Public Const MF_PRINT_TYPE_ELECTRIC_ENDORSE_EXTEND& = 4

Rem:// print structure(version &H0101)
Public Type MF_PRINT01
Rem:// Print Section
        iSize(1 To 4) As Byte
        iVersion(1 To 4) As Byte
        iRet(1 To 4) As Byte
        blDummy(1 To 4) As Byte
        lpString(1 To 12) As Byte
        dwAttribute(1 To 12) As Byte
        wFont(1 To 6) As Byte
        wFontSize(1 To 6) As Byte
        bSpeed As Byte
        bDirection(1 To 4) As Byte
        dwEndorseType(1 To 4) As Byte
End Type

Rem:// print structure(OLD: version &H0100)
Public Type MF_PRINT
Rem:// Print Section
        iSize As Long
        iVersion As Long
        iRet As Long
        blElectricEndorse As Boolean
        lpString(3) As Object
        dwAttribute(3) As Long
        wFont(3) As Integer
        wFontSize(3) As Integer
        bSpeed As Byte
        bDirection As Boolean
End Type


Rem:/********************************/
Rem:/* BiMICRResultBeep             */
Rem:/********************************/
Rem:// define
Public Const MICR_BEEP_SUCCESS& = 0
Public Const MICR_BEEP_ERROR& = 1
Public Const MICR_BEEP_PAPER& = 2
Public Const MICR_BEEP_LOW& = 0
Public Const MICR_BEEP_HIGH& = 1
Public Const MICR_BEEP_COUNT_MAX& = 3


Rem:/********************************/
Rem:/* Process parameters           */
Rem:/********************************/
Rem:// Structure version(for iVersion)
Public Const MF_PROCESS_VERSION& = &H100

Rem:// Activation mode(For bActivationMode)
Public Const MF_ACTIVATE_MODE_CONFIRMATION& = 0
Public Const MF_ACTIVATE_MODE_HIGH_SPEED& = 1

Rem:// Paper type(For bPaperType)
Public Const MF_PAPER_TYPE_OTHER& = 0
Public Const MF_PAPER_TYPE_CHECK& = 1

Rem:// Stamp status(For bSuccessStamp, bPaperMisInsertionStamp, bNoiseStamp
Rem://                              , bDoubleFeedStamp, bBaddataStamp, bNodataStamp)
Public Const MF_STAMP_DISABLE& = 0
Public Const MF_STAMP_ENABLE& = 1

Rem:// Error detect(For bPaperMisInsertionErrorSelect, bNoiseErrorSelect
Rem://                              , bDoubleFeedErrorSelect, bBaddataErrorSelect, bNodataErrorSelect)
Public Const MF_ERROR_SELECT_NODETECT& = 0
Public Const MF_ERROR_SELECT_DETECT& = 1

Rem:// Eject select(For bPaperMisInsertionErrorEject, bNoiseErrorEject
Rem://                              , bDoubleFeedErrorEject, bBaddataErrorEject, bNodataErrorEject)
Public Const MF_EJECT_MAIN_POCKET& = &H22
Public Const MF_EJECT_SUB_POCKET& = &H24
Public Const MF_EJECT_NOEJECT& = &H28

Rem:// Cancel status(For bPaperMisInsertionCancel, bNoiseCancel, bDoubleFeedCancel
Rem://                              , bBaddataCancel, bNodataCancel)
Public Const MF_CANCEL_DISABLE& = 0
Public Const MF_CANCEL_ENABLE& = 1

Rem:// Nearfull parmit(For bNearFullSelect)
Public Const MF_NEARFULL_NOT_PERMIT& = &H0
Public Const MF_NEARFULL_MAIN_PERMIT& = &H1
Public Const MF_NEARFULL_SUB_PERMIT& = &H2
Public Const MF_NEARFULL_PERMIT& = &H3

Rem:// Result partial(For bResultPartialData)
Public Const MF_RESULT_NONE& = 0
Public Const MF_RESULT_PARTIAL& = 1

Rem:// Process structure
Public Type MF_PROCESS
Rem:// Process Section
        iSize(1 To 4) As Byte
        iVersion(1 To 4) As Byte
        bActivationMode As Byte
        bPaperType As Byte
        dwStartWaitTime(1 To 4) As Byte
        bSuccessStamp As Byte
        bPaperMisInsertionErrorSelect As Byte
        bPaperMisInsertionErrorEject As Byte
        bPaperMisInsertionStamp As Byte
        bPaperMisInsertionCancel As Byte
        bNoiseErrorSelect As Byte
        bNoiseErrorEject As Byte
        bNoiseStamp As Byte
        bNoiseCancel As Byte
        bDoubleFeedErrorSelect As Byte
        bDoubleFeedErrorEject As Byte
        bDoubleFeedStamp As Byte
        bDoubleFeedCancel As Byte
        bBaddataErrorSelect As Byte
        bBaddataCount As Byte
        bBaddataErrorEject As Byte
        bBaddataStamp As Byte
        bBaddataCancel As Byte
        bNodataErrorSelect As Byte
        bNodataErrorEject As Byte
        bNodataStamp As Byte
        bNodataCancel As Byte
        bNearFullSelect As Byte
        bResultPartialData As Byte
End Type

Rem:/********************************/
Rem:/* IQA parameters               */
Rem:/********************************/
Rem:// Structure version(for iVersion)
Public Const MF_IQA_VERSION& = &H100

Rem:// IQA test status(For bUndersize,bOversize,bMincompressed,bMaxcompressed,
Rem://                     bFront_rear,bToolight,bToodark,bStreaks,bNoise,bFocus,
Rem://                     bCorners,bEdges,bFraming,bSkew,bCarbon,bPiggyback)
Public Const MF_IQA_TEST_DISABLE& = 0
Public Const MF_IQA_TEST_ENABLE& = 1

Rem:// IQA structure
Public Type MF_IQA
Rem:// IQA Section
    iSize(1 To 4) As Byte
    iVersion(1 To 4) As Byte
    bErrorSelect As Byte
    bErrorEject As Byte
    bStamp As Byte
    bCancel As Byte

    bImageFormat As Byte
    bColorDepth As Byte
    bThreshold As Byte
    bColor As Byte
    bExOption As Byte
    sResolution(1 To 2) As Byte

    bUndersize As Byte
    bOversize As Byte
    bMincompressed As Byte
    bMaxcompressed As Byte
    bFront_rear As Byte
    bToolight As Byte
    bToodark As Byte
    bStreaks As Byte
    bNoise As Byte
    bFocus As Byte
    bCorners As Byte
    bEdges As Byte
    bFraming As Byte
    bSkew As Byte
    bCarbon As Byte
    bPiggyback As Byte
End Type

Rem:/********************************/
Rem:/* IQA result parameters        */
Rem:/********************************/
Rem:// Structure version(for iVersion)
Public Const MF_IQARESULT_VERSION& = &H100

Rem:// IQA result value.
Public Const IQARESULT_NOT_TESTED& = 0
Public Const IQARESULT_PASS& = 1
Public Const IQARESULT_NOT_PASS& = 2

Rem:// UndersizeImage structure
Public Type IQARESULT_UNDERSIZE_IMAGE
    bResult As Byte
    iWidth(1 To 4) As Byte             '// width in tenths of inches
    iHeight(1 To 4) As Byte            '// height in tenths of inches
End Type

Rem:// OversizeImage structure
Public Type IQARESULT_OVERSIZE_IMAGE
    bResult As Byte
    iWidth(1 To 4) As Byte             '// width in tenths of inches
    iHeight(1 To 4) As Byte            '// height in tenths of inches
End Type

Rem:// MinCompressedImageSize structure
Public Type IQARESULT_MIN_COMPRESSED_IMAGE_SIZE
    bResult As Byte
    iSize(1 To 4) As Byte              '// compressed image size in bytes
End Type

Rem:// MaxCompressedImageSize structure
Public Type IQARESULT_MAX_COMPRESSED_IMAGE_SIZE
    bResult As Byte
    iSize(1 To 4) As Byte              '// compressed image size in bytes
End Type

Rem:// FrontRearImageMismatch structure
Public Type IQARESULT_FRONT_REAR_IMAGE_MISMATCH
    bResult As Byte
    iAbsWidthDiff(1 To 4) As Byte      '// absolute value of width difference between front and rear in tenths of inches
    iAbsHeightDiff(1 To 4) As Byte     '// absolute value of height difference between front and rear in tenths of inches
End Type

Rem:// ImageTooLight structure
Public Type IQARESULT_IMAGE_TOO_LIGHT
    bResult As Byte
    iBlackPixels(1 To 4) As Byte       '// percenage of black pixels in the image in units of 0.1 percent
    iBrightness(1 To 4) As Byte        '// percent image brightness in units of 0.1 percent
    iContrast(1 To 4) As Byte          '// percent image contrast in units of 0.1 percent
End Type

Rem:// ImageTooDark structure
Public Type IQARESULT_IMAGE_TOO_DARK
    bResult As Byte
    iBlackPixels(1 To 4) As Byte       '// percenage of black pixels in the image in units of 0.1 percent
    iBrightness(1 To 4) As Byte        '// percent image brightness in units of 0.1 percent
End Type

Rem:// HorizontalStreaksPresent structure
Public Type IQARESULT_HORIZONTAL_STREAKS_PRESENT
    bResult As Byte
    iStreakCount(1 To 4) As Byte       '// Number of black streaks present in bitonal images
    iStreakHeight(1 To 4) As Byte      '// Height of the largest horizontal black streak
End Type

Rem:// ExcessiveSpotNoise structure
Public Type IQARESULT_EXCESSIVE_SPOT_NOISE
    bResult As Byte
    iCount(1 To 4) As Byte             '// average number of spot per square inch of the image defined for bi-tonal only
End Type

Rem:// ImageOutOfFocus structure
Public Type IQARESULT_IMAGE_OUT_OF_FOCUS
    bResult As Byte
    iImageFocusScore(1 To 4) As Byte   '// (max video gradient) / (grey level dynamic range) * (pixel pitch)
End Type

Rem:// FoldedTornDocCorners structure
Public Type IQARESULT_FOLDED_TORN_DOC_CORNERS
    bResult As Byte
    iTopLeftWidth(1 To 4) As Byte
    iTopLeftHeight(1 To 4) As Byte
    iTopRightWidth(1 To 4) As Byte
    iTopRightHeight(1 To 4) As Byte
    iBottomLeftWidth(1 To 4) As Byte
    iBottomLeftHeight(1 To 4) As Byte
    iBottomRightWidth(1 To 4) As Byte
    iBottomRightHeight(1 To 4) As Byte
End Type

Rem:// FoldedTornDocEdges structure
Public Type IQARESULT_FOLDED_TORN_DOC_EDGES
    bResult As Byte
    iTopWidth(1 To 4) As Byte
    iTopHeight(1 To 4) As Byte
    iLeftWidth(1 To 4) As Byte
    iLeftHeight(1 To 4) As Byte
    iRightWidth(1 To 4) As Byte
    iRightHeight(1 To 4) As Byte
    iBottomWidth(1 To 4) As Byte
    iBottomHeight(1 To 4) As Byte
End Type

Rem:// DocFramingError structure
Public Type IQARESULT_DOC_FRAMING_ERROR
    bResult As Byte
    iTop(1 To 4) As Byte
    iLeft(1 To 4) As Byte
    iRight(1 To 4) As Byte
    iBottom(1 To 4) As Byte
End Type

Rem:// ExcessiveDocSkew structure
Public Type IQARESULT_EXCESSIVE_DOC_SKEW
    bResult As Byte
    iAngle(1 To 4) As Byte
    iRange(1 To 4) As Byte
End Type

Rem:// CarbonStripDetection structure
Public Type IQARESULT_CARBON_STRIP_DETECTION
    bResult As Byte
    iStripHeight(1 To 4) As Byte
End Type

Rem:// Piggyback structure
Public Type IQARESULT_PIGGYBACK
    bResult As Byte
End Type

Rem:// IQA result structure
Public Type MF_IQA_RESULT
    iSize(1 To 4) As Byte
    iVersion(1 To 4) As Byte
    iRet(1 To 4) As Byte

    stUnderSize As IQARESULT_UNDERSIZE_IMAGE
    stOverSize As IQARESULT_OVERSIZE_IMAGE
    stMinCompressedImageSize As IQARESULT_MIN_COMPRESSED_IMAGE_SIZE
    stMaxCompressedImageSize As IQARESULT_MAX_COMPRESSED_IMAGE_SIZE
    stFrontRearImageMismatch As IQARESULT_FRONT_REAR_IMAGE_MISMATCH
    stImageTooLight As IQARESULT_IMAGE_TOO_LIGHT
    stImageTooDark As IQARESULT_IMAGE_TOO_DARK
    stHorizontalStreaksPresent As IQARESULT_HORIZONTAL_STREAKS_PRESENT
    stExcessiveSpotNoise As IQARESULT_EXCESSIVE_SPOT_NOISE
    stImageOutOfFocus As IQARESULT_IMAGE_OUT_OF_FOCUS
    stFoldedTornDocCorners As IQARESULT_FOLDED_TORN_DOC_CORNERS
    stFoldedTornDocEdges As IQARESULT_FOLDED_TORN_DOC_EDGES
    stDocFramingError As IQARESULT_DOC_FRAMING_ERROR
    stExcessiveDocSkew As IQARESULT_EXCESSIVE_DOC_SKEW
    stCarbonStripDetection As IQARESULT_CARBON_STRIP_DETECTION
    stPiggyBack As IQARESULT_PIGGYBACK
End Type

Rem:/********************************/
Rem:/* Barcode parameters           */
Rem:/********************************/
Rem:// Structure version(for iVersion)
Public Const MF_BARCODE_VERSION& = &H100

Rem:// Barcode symbol
Public Const MF_BARCODE_SYMBOL_CODABAR& = &H1
Public Const MF_BARCODE_SYMBOL_CODE128& = &H2
Public Const MF_BARCODE_SYMBOL_CODE39& = &H4
Public Const MF_BARCODE_SYMBOL_ITF& = &H8
Public Const MF_BARCODE_SYMBOL_EAN_JAN& = &H10
Public Const MF_BARCODE_SYMBOL_UPC_A& = &H20
Public Const MF_BARCODE_SYMBOL_UPC_E& = &H40

Rem:// Barcode direction
Public Const MF_BARCODE_DIRECTION_ALL& = 0
Public Const MF_BARCODE_DIRECTION_LEFTRIGHT& = 1
Public Const MF_BARCODE_DIRECTION_TOPBOTTOM& = 2
Public Const MF_BARCODE_DIRECTION_RIGHTLEFT& = 3
Public Const MF_BARCODE_DIRECTION_BOTTOMTOP& = 4

Rem:// Barcode area origin
Public Const MF_BARCODE_ORIGIN_TOP_LEFT& = 0
Public Const MF_BARCODE_ORIGIN_BOTTOM_LEFT& = 1
Public Const MF_BARCODE_ORIGIN_TOP_RIGHT& = 2
Public Const MF_BARCODE_ORIGIN_BOTTOM_RIGHT& = 3

Rem:// Barcode color
Public Const MF_BARCODE_TARGET_COLOR_GRAY& = 0
Public Const MF_BARCODE_TARGET_COLOR_RED& = 1
Public Const MF_BARCODE_TARGET_COLOR_GREEN& = 2
Public Const MF_BARCODE_TARGET_COLOR_BLUE& = 3
Public Const MF_BARCODE_TARGET_COLOR_UV& = 4

Rem:// Barcode data
Public Type BARCODE_DATA
    dwSymbol(1 To 4) As Byte
    bDirection As Byte
    wStartX(1 To 2) As Byte
    wStartY(1 To 2) As Byte
    wEndX(1 To 2) As Byte
    wEndY(1 To 2) As Byte
    dwDataSize(1 To 4) As Byte     ' data length
    pData(1 To 4) As Byte          ' barcode data(binary)
End Type

Rem:// Barcode decode information
Public Type BARCODE_INFO
    iRet(1 To 4) As Byte
    bStatus As Byte
    bDetail As Byte
    dwSymbolMask(1 To 4) As Byte
    bDirection As Byte
    bOrigin As Byte
    wStartX(1 To 2) As Byte
    wStartY(1 To 2) As Byte
    wEndX(1 To 2) As Byte
    wEndY(1 To 2) As Byte
End Type

Rem:// Barcode structure
Public Type MF_BARCODE
Rem:// Barcode Section
    iSize(1 To 4) As Byte
    iVersion(1 To 4) As Byte
    iRet(1 To 4) As Byte

    bErrorSelect As Byte
    bErrorEject As Byte
    bStamp As Byte
    bCancel As Byte

    dwTargetColor(1 To 4) As Byte
    sResolution(1 To 2) As Byte
    dwInfoMode(1 To 4) As Byte
    stInfo(1 To 5) As BARCODE_INFO
    bDataCount As Byte         ' array size for lpData
    lpData(1 To 4) As Byte     ' array of BARCODE_DATA
End Type


Rem:/********************************/
Rem:/* OCR_AB parameters            */
Rem:/********************************/
Rem:// Structure version(for iVersion)
Public Const MF_OCR_AB_VERSION& = &H100

Rem:// Ocr Type
Public Const MF_OCR_FONT_OCRA_NUM& = 1
Public Const MF_OCR_FONT_OCRA_ALPHA& = 2
Public Const MF_OCR_FONT_OCRA_ALPHANUM& = 3
Public Const MF_OCR_FONT_OCRA_ALPHANUM_WOOH& = 7
Public Const MF_OCR_FONT_OCRA_ALPHANUM_WOZERO& = 11
Public Const MF_OCR_FONT_OCRB_NUM& = 17
Public Const MF_OCR_FONT_OCRB_ALPHA& = 18
Public Const MF_OCR_FONT_OCRB_ALPHANUM& = 19
Public Const MF_OCR_FONT_OCRB_ALPHANUM_WOOH& = 23
Public Const MF_OCR_FONT_OCRB_ALPHANUM_WOZERO& = 27

Rem:// Direction
Public Const MF_OCR_LEFTRIGHT& = 1
Public Const MF_OCR_TOPBOTTOM& = 2
Public Const MF_OCR_RIGHTLEFT& = 3
Public Const MF_OCR_BOTTOMTOP& = 4

Rem:// Area(for bEndX, bEndY)
Public Const OCR_AREA_RIGHT& = 65535
Public Const OCR_AREA_BOTTOM& = 65535

Rem:// SpeceHandling(for bSpeceHandling)
Public Const OCR_SPACE_ENABLE& = 1
Public Const OCR_SPACE_DISABLE& = 0

Public Const MF_OCR_AB_CHAR_MAX& = 128

Public Type MF_OCR_AB
    iSize(1 To 4) As Byte
    iVersion(1 To 4) As Byte
    iRet(1 To 4) As Byte
    bOcrType As Byte
    bDirection As Byte
    wStartX(1 To 2) As Byte
    wStartY(1 To 2) As Byte
    wEndX(1 To 2) As Byte
    wEndY(1 To 2) As Byte
    bSpaceHandling As Byte
    szOcrStr(1 To MF_OCR_AB_CHAR_MAX) As Byte
    stOcrReliableInfo(1 To MF_OCR_AB_CHAR_MAX) As MF_OCR_RELIABLE_INFO
End Type

Rem:/********************************/
Rem:/* VERSION_INFO parameters      */
Rem:/********************************/
Public Const VERSION_CHAR_MAX& = 64

Public Type VERSION_INFO
    lpszDescription(1 To VERSION_CHAR_MAX) As Byte
    lpszVersion(1 To VERSION_CHAR_MAX) As Byte
End Type

Rem:#pragma pack(pop)

Rem:#endif // !defined(_MULTI_FUNCTION_H)

